/**
 * Module containing the application object and other global
 * (window-independent) objects. To import it you can write:
 *
 *   Components.utils.import("resource://app/app.jsm");
 *
 * @author Wladimir Palant <Wladimir.Palant@tomtom.com>
 * @copyright 2008 TomTom BV
 */

var EXPORTED_SYMBOLS = ["CI", "Cc", "subscriptLoader"];

const CI = Components.interfaces;
const Cc = Components.classes;
const subscriptLoader = Cc["@mozilla.org/moz/jssubscript-loader;1"].getService(CI.mozIJSSubScriptLoader);

try
{
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/util.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/fileUtils.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/addonManager.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/app.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/backgroundProcessManager.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/autoDeviceUpdate.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/brandingManager.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/cart.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/cdManager.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/comm.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/deviceManager.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/dllUtils.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/downloader.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/errorListener.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/fetchhttp.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/firstRun.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/login.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/loginDeviceRel.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/autoLogin.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/migrate.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/netutil.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/serverinput.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/settings.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/staticURLIDs.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/tlvvocfetcher.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/tripUpload.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/urlHandler.js");

    // @@ Order matters! If a subtype has simple types that extend it, put it before simple.js. Put
    // supertypes before those types which extend the supertype.
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/ttCurrency.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/ttImage.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/ttItemRef.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/ttItemFactory.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/ttItem.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/ttNavItem.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/ttAddon.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/ttRegion.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/ttItemList.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/ttDependencyTreeBuilder.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/subtype/ttSubscription.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/subtype/ttAudioSampleMixin.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/subtype/ttNoInstallSubscription.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/subtype/ttImageItem.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/subtype/ttSoundItem.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/subtype/ttMap.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/subtype/ttVoice.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/subtype/ttPOI.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/subtype/ttProgram.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/subtype/ttTheme.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/subtype/ttEmulator.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/subtype/ttFuelPrice.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/subtype/simple.js");
    subscriptLoader.loadSubScript("chrome://tthome/content/logic/model/subtype/ttMapShare.js");
} catch (e) { error(e); };

// Emulation for some window functions

const XMLHttpRequest = Components.Constructor("@mozilla.org/xmlextras/xmlhttprequest;1", "nsIXMLHttpRequest");
