/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


const CLASS_ID = Components.ID("{a9e7ea35-20df-4ee4-9d95-3a7e00bf9ce2}");
const CLASS_NAME = "Commandline validator";
const CONTRACT_ID = "@home2.tomtom.com/commandline-validator;1";

const CI = Components.interfaces;
const Cc = Components.classes;

const kDebug = false;

var factory =
{
    createInstance: function (aOuter, iid)
    {
if (aOuter != null)
            throw Components.results.NS_ERROR_NO_AGGREGATION;

        return new Validator().QueryInterface(iid);
    }
};
var module =
{
    registerSelf: function (aCompMgr, aFileSpec, aLocation, aType)
    {
        aCompMgr = aCompMgr.QueryInterface(CI.nsIComponentRegistrar);
        aCompMgr.registerFactoryLocation(CLASS_ID, CLASS_NAME, CONTRACT_ID, aFileSpec, aLocation, aType);
        var catWoman = Cc["@mozilla.org/categorymanager;1"]
                       .getService(CI.nsICategoryManager);
        catWoman.addCategoryEntry("command-line-validator", "a-home2", CONTRACT_ID, true, true);{}
},

    unregisterSelf: function (aCompMgr, aLocation, aType)
    {
        aCompMgr = aCompMgr.QueryInterface(CI.nsIComponentRegistrar);
        aCompMgr.unregisterFactoryLocation(CLASS_ID, aLocation);

        var catWoman = Cc["@mozilla.org/categorymanager;1"]
                       .getService(CI.nsICategoryManager);
        catWoman.deleteCategoryEntry("command-line-validator", "a-home2", true);
    },

    getClassObject: function (aCompMgr, aCID, aIID)
    {
        if (!aIID.equals(CI.nsIFactory))
            throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

        if (aCID.equals(CLASS_ID))
            return factory;

        throw Components.results.NS_ERROR_NO_INTERFACE;
    },

    canUnload: function (aCompMgr) { return true; }
};
function NSGetModule(aCompMgr, aFileSpec) { return module; }
function Validator()
{
}
Validator.prototype =
{
    validate : function(commandline)
    {
var osintPos = commandline.findFlag("osint", false);
        var urlPos = commandline.findFlag("uri", false);
        if (urlPos != -1 &&
            (osintPos != -1 || commandline.state == CI.nsICommandLine.STATE_REMOTE_EXPLICIT))
        {
            if (commandline.length != urlPos + 2)
            {
                error("extra commandline option after -osint -uri foo denied");
                throw Components.results.NS_ERROR_ABORT;
            }
commandline.handleFlag("osint", false);
        }
},

    QueryInterface : function(aIID)
    {
        if (aIID.equals(CI.nsICommandLineValidator) ||
            aIID.equals(CI.nsISupports))
            return this;

        throw Components.results.NS_ERROR_NO_INTERFACE;
    }
};

function debug(text)
{
    if (!kDebug)
        return;
    dump(text + "\n");
    Components.utils.reportError(text);
}

function error(text)
{
    dump(text + "\n");
    Components.utils.reportError(text);
}
