/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function AutoDeviceUpdate()
{
}
AutoDeviceUpdate.prototype =
{
    previousAttemptTime : 0,
    _kMapShareInvitePage : "chrome://tthome/content/ui/dialogs/NY/enable.xul",
    _kMapShareInvitationTimestampPref : "tomtom.device.all.mapShare.download.previousInvitation",

    start : function()
    {
        gApplication.deviceManager.addObserver(this);
        gApplication.login.addObserver(this);

        var firstRun = true;
        try {
            firstRun = prefService().getBoolPref("tomtom.app.firstrun");
        } catch (e) {}

        if (firstRun)
        {
            this.previousAttemptTime = new Date().getTime();
        }
        else
        {
            this.autoUpdateConditional();
        }
    },
changed : function(deviceChanged, locationChanged)
    {
        if (deviceChanged === false)
            return;
        var me = this;
        runAsync(function()
        {
            me.autoUpdateConditional();
        });
    },

    autoUpdateConditional : function()
    {
        try {
            var mainwin = gApplication.getSomeMainWindow();
            if (!mainwin || mainwin.currentTask())
                return;

            var dev = gApplication.deviceManager.activeDevice;
            if (!dev)
                return;

            var lmgDoFirstTimeNag = false;
            var excludeModels = "|go715|go910|go710|go510|go700|go500|go300|goclassic|onev3" +
                                "|cork1024|cork512|cork0|one|rider|rider2|pocketpc|palm" +
                                "|mobile_S60v3|newcastle|newcastle2|";
            if (excludeModels.indexOf("|" + dev.model.id + "|") == -1)
            {
                try {
                    lmgDoFirstTimeNag = prefService().getBoolPref("tomtom.device." + dev.id + ".doLMGFirstTimeNag");
                } catch (e) {
                    lmgDoFirstTimeNag = true;
                }
            }

            var autoUpdate = false;
            try {
                autoUpdate = prefService().getBoolPref("tomtom.device.all.autoUpdate");
            } catch(e) { unimportantError(e); }

            if (autoUpdate && lmgDoFirstTimeNag)
            {
                mainwin.loadTaskByName("latestMapGuarantee", {
                    cleanupHandler: makeCallback(this, this.autoUpdateConditional)
                });
                prefService().setBoolPref("tomtom.device." + dev.id + ".doLMGFirstTimeNag", false);
            }
            else if (this.shouldShowMapShareInvitation())
            {
                openDialogAsWindow(this._kMapShareInvitePage);
            }
            else if (autoUpdate && (gApplication.startupURI == null ||
                                    gApplication.startupURI == "tomtomhome:"))
            {
                var time = Date.now();
                if (time - this.previousAttemptTime < 60*60*1000)
                    return;
                this.previousAttemptTime = time;
                mainwin.loadTaskByName("update", {silent: true}, null, -10);
            }
        } catch (e) { unimportantError(e); }
    },

    shouldShowMapShareInvitation : function()
    {
        var mapShareEnabled = false;
        var mapShare = gApplication.deviceManager.activeDevice.mapShare;
        if (mapShare && mapShare.mapPatchDownloadsEnabled)
        {
            mapShareEnabled = true;
        }

        var now = Date.now() / 1000;
        var previousInvitation = 0;
        try {
            previousInvitation = prefService().getIntPref(this._kMapShareInvitationTimestampPref);
        } catch (e) {}

        if (mapShareEnabled)
        {
            prefService().setIntPref(this._kMapShareInvitationTimestampPref, now);
        }
        if (!mapShare || mapShareEnabled || now - previousInvitation < 90*24*60*60)
        {
            return false;
        }

        prefService().setIntPref(this._kMapShareInvitationTimestampPref, now);
        return true;
    },

    __end : null
}
