/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/

EXPORTED_SYMBOLS.push("BackgroundProcessManager");
var BackgroundProcessManager =
{
    kRunName: "TomTomHOME.exe",
isEnabled: function()
    {
        if (gApplication.settings.isOSWindows())
        {
            var registry = this._openWindowsRegistryRun();
            let enabled = registry.hasValue(this.kRunName);
            registry.close();
            return enabled;
        }
        else if (gApplication.settings.isOSMacOSX())
        {
            var process = this._getHomeRunnerLoginMac();
            if (process)
            {
                process.run(true, ["isenabled"], 1);
                return process.exitValue == 0;
            }
            else
            {
                throw new Exception(getStringBundle("chrome://tthome/locale/logic/BackgroundProcessManager.properties")
                                    .GetStringFromName("initialisationException"));
            }
        }
        throw new Exception(getStringBundle("chrome://tthome/locale/logic/BackgroundProcessManager.properties")
                            .GetStringFromName("OSException"));
    },

    enable: function()
    {
        this._setEnabled(true);
    },

    disable: function()
    {
        this._setEnabled(false);
    },

    _setEnabled: function(enable)
    {
        if (gApplication.settings.isOSWindows())
        {
            var registry = this._openWindowsRegistryRun();

            if (enable)
            {
                var homerunner = gApplication.settings.installDir;
                homerunner.append("TomTomHOMERunner.exe");
                registry.writeStringValue(this.kRunName, '"' + homerunner.path + '" -s');
            }
            else
            {
                registry.removeValue(this.kRunName);
            }
            registry.close();
        }
        else if (gApplication.settings.isOSMacOSX())
        {
            var process = this._getHomeRunnerLoginMac();
            if (process)
            {
                process.run(true, ["isrunning"], 1);
                var processIsRunning = process.exitValue == 0;

                if (enable && !processIsRunning)
                    process.run(false, ["launch"], 1);
                else if(!enable && processIsRunning)
                    process.run(false, ["quit"], 1);

                var enableargs = [enable ? "enable" : "disable"];

                process = this._getHomeRunnerLoginMac();
                var result = process.run(false, enableargs, enableargs.length);
            }
        }
    },

    _openWindowsRegistryRun: function()
    {
        var registry = Cc["@mozilla.org/windows-registry-key;1"]
                   .createInstance(CI.nsIWindowsRegKey);
        registry.open(registry.ROOT_KEY_CURRENT_USER,
                      "Software\\Microsoft\\Windows\\CurrentVersion\\Run",
                      registry.ACCESS_WRITE | registry.ACCESS_READ);
        return registry;
    },

    _getHomeRunnerLoginMac: function()
    {
        var homeRunnerLogin = gApplication.settings.installDir;
        homeRunnerLogin.append("Resources");
        homeRunnerLogin.append("TomTomHOMERunnerLogin");
        if (homeRunnerLogin.exists() && homeRunnerLogin.isFile())
        {
            var process = Cc["@mozilla.org/process/util;1"].createInstance(CI.nsIProcess);
            process.init(homeRunnerLogin);
            return process;
        }
        return null;
    }
}
