/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function checkFirstRun()
{
    var curVersion = gApplication.settings.version;
    var first = true;
    var lastRun = "0.0";
    try {
        first = prefService().getBoolPref("tomtom.app.firstrun");
    } catch (e) {}
    try {
        if (!first)
            lastRun = prefService().getCharPref("tomtom.app.firstrun.version");
    } catch (e) {}
    if (first)
    {
        if (!doFirstRunActions())
        {
            return;
        }
    }
    else
    {
        if (versionNewerThan(curVersion, lastRun))
        {
            doUpgradeActions(curVersion, lastRun);
        }
    }

    var curVersion = gApplication.settings.version;
    prefService().setCharPref("tomtom.app.firstrun.version", curVersion);
    prefService().setBoolPref("tomtom.app.firstrun", false);
    if (prefService().prefHasUserValue("tomtom.app.autostart") && BackgroundProcessManager.isEnabled())
        {
            BackgroundProcessManager.disable();
            prefService().clearUserPref('tomtom.app.autostart');
        }
}
function doFirstRunActions()
{
    try
    {
        if (!BackgroundProcessManager.isEnabled())
            BackgroundProcessManager.enable();
    } catch(e) { unimportantError(e, "An error occured trying to enable and launch HomeRunnerLogin."); }

    return true;
}
function doUpgradeActions(curVersion, lastRun)
{
    if (gApplication.settings.isOSMacOSX())
    {
        var updaterDir = gApplication.settings.profileDir;{}
        updaterDir.append("Updates");
        ensureDirExists(updaterDir);

        if (!updaterDir.isDirectory())
            throw new InvalidValue("Updates directory is invalid.", updaterDir);
		
        updaterDir.append("extract");
        updaterDir.append("MacLatest.pkg");

        if (updaterDir.exists())
        {
            for (let child in getFilesInDir(updaterDir.parent.parent))
            {
                try
                {
                    removeFile(child, true);
                }
                catch (e)
                {
                    unimportantError(e);
           	    }
        	}
        }
    }

    if (versionOlderThan(lastRun, "2.4"))
    {
        var prefs = Cc["@mozilla.org/preferences-service;1"]
            .getService(CI.nsIPrefService);
        var devicePrefs = prefs.getBranch("tomtom.device.").getChildList("", {});

        var deviceIDs = {};
        for each (var entry in devicePrefs)
        {
            if (!entry.match(/^all/))
                deviceIDs[entry.split(".")[0]] = true;
        }

        for (deviceID in deviceIDs)
        {
             var firstTimeNagPrefName = "tomtom.device." + deviceID + ".doLMGFirstTimeNag";
             if (!prefService().prefHasUserValue(firstTimeNagPrefName))
                 prefService().setBoolPref(firstTimeNagPrefName, false);
        }
    }
}

