/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function LoginDeviceRelationship()
{
}
LoginDeviceRelationship.prototype =
{
    start : function()
    {
        gApplication.deviceManager.addObserver(this);
        gApplication.login.addObserver(this);
    },
_previousGetDeviceCall : null,
_validateDeviceAssociation: function(validatingUsername, acceptCallback, rejectCallback)
    {
        var dev = gApplication.deviceManager.activeDevice;
		var me = this;
		
        if (!dev)
        {
me.showNoDevInAccountDialog(null,
                    validatingUsername,
                    null, null,
                    null, null);
			
            acceptCallback();
            return;
        }

        if (this._previousGetDeviceCall)
        {
            this._previousGetDeviceCall.cancel(new ServerError("A new request has been initiated.", Components.results.NS_BINDING_RETARGETED));
            this._previousGetDeviceCall = null;
        }

        this._previousGetDeviceCall = rpc.call("account", "getDevice", {}, null, RPC.METHOD_GET, function(result)
        {
            if (gApplication.deviceManager.activeDevice != dev)
            {
                acceptCallback();
                return;
            }

            me._previousGetDeviceCall = null;
            if (result.@serial.toString() == "")
            {
me.showNoDevInAccountDialog(dev,
                    validatingUsername,
                    result.@serial, result.@code,
                    result.@model, result.@name);
				
				acceptCallback();
                return;
            }
            if (dev.serial != result.@serial.toString())
            {
var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                    .getService(Components.interfaces.nsIWindowMediator);
                var enumerator = wm.getEnumerator("tthome:loginDeviceMismatch");
                if (enumerator.hasMoreElements())
                {
                    rejectCallback(new UserCancelledException());
                    return;
                }
                var acceptLogin = me.showNoMatchDialog(dev,
                    validatingUsername,
                    result.@serial, result.@code,
                    result.@model, result.@name);
                if (acceptLogin == null || acceptLogin)
                    acceptCallback();
                else
                    rejectCallback(new UserCancelledException());
                return;
            }
            if ((result.@navcoreversion.toString() != "" &&
                 parseInt(dev.versionNavCore.toString(), 10) != parseInt(result.@navcoreversion.toString(), 10))
                || result.@serial.toString() == "")
            {
me.setDeviceInAccount(dev, function(result)
                {
},
                error);
            }

            acceptCallback();
        },
        function(e)
        {
            if (e.code == Components.results.NS_BINDING_RETARGETED)
            {
                rejectCallback(new UserCancelledException());
                return;
            }

            error(e);
            acceptCallback();
        });
    },
changed : function()
    {
        var username = gApplication.login.currentUsername;
        var dev = gApplication.deviceManager.activeDevice;

        if (!username || !dev)
            return;

        dev.userLoginName = username;
    },
setDeviceInAccount : function(dev, successCallback, errorCallback)
    {
        var myErrorCallback = function(e)
        {
            if (e.code == 101)
            {
                gApplication.deviceManager.showApplicationUpdateDialog();
                e.severity = Exception.SEVERITY_IGNORE;
                errorCallback(e);
            }
            else
            {
                if (e.code == 572)
                    e = new InformativeException(errorToText(e));
                errorCallback(e);
            }
        };

        var params =
        {
            deviceCode : dev.deviceCode,
            deviceSerial : dev.serial,
            deviceModel : dev.model.id,
            deviceNavcoreVersion : dev.versionNavCore,
            deviceParameters : gApplication.deviceManager.getDeviceParametersStringForDevice(dev)
        };
        addSubscriptionsRPCArgs(params);
        return rpc.call("account", "setDevice", params, null, RPC.METHOD_POST,
            successCallback, myErrorCallback);
    },
showNoMatchDialog : function(cur,
                                 accountUserName,
                                 accountSerial, accountDeviceCode,
                                 accountModelID, accountModelName)
    {
        return openDialogAsWindow(
            "chrome://tthome/content/ui/dialogs/login/loginDeviceMismatch.xul",
            {
                currentDevice : cur,
                accountSerial : accountSerial,
                accountDeviceCode : accountDeviceCode,
                accountModelName : accountModelName,
                accountUserName : accountUserName
            });
    },
showNoDevInAccountDialog : function(cur,
                                 accountUserName,
                                 accountSerial, accountDeviceCode,
                                 accountModelID, accountModelName)
    {
		return openDialogAsWindow(
            "chrome://tthome/content/ui/dialogs/login/linkDevice.xul",
            {
                currentDevice : cur,
                accountSerial : accountSerial,
                accountDeviceCode : accountDeviceCode,
                accountModelName : accountModelName,
                accountUserName : accountUserName
            });
		
    },
	

    __end : null
}
