/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


EXPORTED_SYMBOLS.push("ttImageItem");
function ttImageItem()
{
    ttNavItem.apply(this);
}
ttImageItem.prototype =
{
    _width : null,
    _height : null,
  
    _listEntry :
    {
        modelType : ttImageItem,
        xmlTag : "image",
        tocTag : "Image",
        priority : 21,
        itemtypeEnum : 1400,
        idlType : CI.ttIImage
    },
  
    importFromDLL : function(item)
    {
        ttNavItem.prototype.importFromDLL.apply(this, arguments);
        item = item.QueryInterface(CI.ttIImage);
        this._width = makeSafe.integer(item.width);
        this._height = makeSafe.integer(item.height);
    },
  
    importFromXML : function(xml)
    {
        ttNavItem.prototype.importFromXML.apply(this, arguments);

        this._width = makeSafe.integer(xml.width);
        this._height = makeSafe.integer(xml.height);
    },
    get width()
    {
        return this._width;
    },
    get height()
    {
        return this._height;
    },

    createTOC : function()
    {
        var table = ttNavItem.prototype.createTOC.apply(this, arguments);
        var toc = table.elements()[0];

        toc.Height = this.height;
        toc.Width = this.width;

        return table;
    },

    _ensureXML : function()
    {
        if (this._xml)
            return;
        ttItem.prototype._ensureXML.apply(this, arguments);
        this.width = this.width;
        this.height = this.height;
    },

    set width(newVal)
    {
        this._width = makeSafe.integer(newVal);
        this._ensureXML();
        this._xml.width = newVal;
    },
    set height(newVal)
    {
        this._height = makeSafe.integer(newVal);
        this._ensureXML();
        this._xml.height = newVal;
    },
    
    __end : null
}

extend(ttImageItem, ttNavItem);
AddSubtypeV1(ttImageItem.prototype._listEntry);
