/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


EXPORTED_SYMBOLS.push("ttSoundItem");
function ttSoundItem()
{
    ttNavItem.apply(this);
    ttAudioSampleMixin.apply(this);
}
ttSoundItem.prototype =
{
    _language : null,

    _listEntry :
    {
        modelType : ttSoundItem,
        xmlTag : "sound",
        tocTag : "Sound",
        priority : 24,
        itemtypeEnum : 1401,
        idlType : CI.ttINavItem
    },

    importFromDLL : function(item)
    {
        ttNavItem.prototype.importFromDLL.apply(this, arguments);
        item = item.QueryInterface(CI.ttISound);
        if (item.creator)
            this._authorName = makeSafe.string(item.creator);
        if (item.language)
            this._language = makeSafe.languageCode(item.language);
    },

    importFromXML : function(xml)
    {
        ttNavItem.prototype.importFromXML.apply(this, arguments);
        this._importFromXMLTTAudioSample(xml)

        if ("language" in xml)
            this._language = makeSafe.languageCode(xml.language);
    },
    get language()
    {
        return this._language;
    },

    _ensureXML : function()
    {
        if (this._xml)
            return;
        ttItem.prototype._ensureXML.apply(this, arguments);
        if (this.authorName)
            this.authorName = this.authorName;
        if (this.language)
            this.language = this.language;
    },

    set language(newVal)
    {
        this._language = makeSafe.languageCode(newVal);
        this._ensureXML();
        this._xml.language = newVal;
    },

    __end : null
}

extend(ttSoundItem, ttNavItem);
extendMixIn(ttSoundItem, ttAudioSampleMixin);
AddSubtypeV1(ttSoundItem.prototype._listEntry);
