/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


EXPORTED_SYMBOLS.push("ttItem");
function ttItem()
{
  this._locations = [];
  this._variant = new Map();
  this._dependencies = [];
  this._subitems = [];
}
ttItem.prototype =
{
  _isServer : null,
  _xml : null,
  _listEntry : null,
  _idurl : null,
  _idstr : null,
  _idnum : null,
  _variant : null,
  _name : null,
  _description : null,
  _version : null,
  _icon : null,
  _preview : null,
  _size : null,
  _locationType : 0,
  _locations : null,
  _endPrice : null,
  _oldPrice : null,
  _targetModels : null,
  _stringBundle : getStringBundle("chrome://tthome/locale/logic/model/ttitem.properties"),
  _authorName : null,
  _supplierName : null,
  _supplierID : null,
  _supplierIcon : null,
  _tags : null,
  _categories : null,
  _downloads : null,
  _lastModification : null,
  _isSharing : false,
  _rating : null,
  _votes : null,
  _hasIDURL : false,
  _hasHOME2Metadata : false,
_dependencies : null,
_subitems: null,

  get id()
  {
    if (this._idnum)
        return this._idnum;
    return this.idstrlong;
  },
  get idnum()
  {
    return this._idnum;
  },
  get idstr()
  {
    return this._idstr;
  },
  get idstrlong()
  {
    return (this.listEntry ? this.listEntry.xmlTag : "unknown") + "/" + this._idstr;
  },
  get idurl()
  {
    if (this._idurl)
      return this._idurl;

    if (this._idnum)
      return "http://num1.id.tomtom.com/" + this._idnum;
    else if (this._idstr)
    {
      if (this._idstr.substr(0, 4) == "http")
        return this._idstr;

      return "http://str1.id.tomtom.com/" +
             (this.listEntry ? this.listEntry.xmlTag : "unknown") +
             "/" + encodeURIComponent(this._idstr);
    }
    throw new NotReached();
  },
  get idurlWithVersion()
  {
    var result = this.idurl;
    result += "?version=" + this.version;
    if (this._variant && this._variant.values().length > 0)
    {
        result += "&variant=";
        var first = true;
        this._variant.iterateOverAll(function(key, value)
        {
            if (first)
                first = false;
            else
                result += "+";
            result += key + ":" + value;
        });
    }
    return result;
  },
get hasIDURL()
  {
    return this._hasIDURL;
  },
get significantIDs()
  {
    return [this.idurl, this.idstrlong];
  },

  get variant()
  {
    return this._variant;
  },
  get name()
  {
    return this._name;
  },
get description()
  {
    return this._description;
  },
  get version()
  {
    return this._version;
  },
get size()
  {
    return this._size;
  },
get icon()
  {
    return this._icon;
  },
get preview()
  {
    return this._preview;
  },
get sourceXML()
  {
    return this._xml.copy();
  },
  get price()
  {
    return this._endPrice;
  },
  get oldPrice()
  {
    return this._oldPrice;
  },
  get discountedBy()
  {
    return this._discountedBy;
  },
  get isLocal()
  {
    return !this._isServer;
  },
  get isServer()
  {
    return this._isServer;
  },
get locationType()
  {
    return this._locationType;
  },
get locations()
  {
    return this._locations;
  },
  get authorName()
  {
    return this._authorName;
  },
  get supplierID()
  {
    return this._supplierID;
  },
  get supplierName()
  {
    return this._supplierName;
  },
  get supplierIcon()
  {
    return this._supplierIcon;
  },
get listEntry()
  {
    return this._listEntry;
  },
get typeID()
  {
    return this.listEntry ? this.listEntry.xmlTag : "unknown";
  },
get typePriority()
  {
    return this.listEntry && this.listEntry.priority ? this.listEntry.priority : 0;
  },
  get displayCategory()
  {
    return this.listEntry ? this.listEntry.xmlTag : "unknown";
  },
get typeLabel()
  {
    return this._typeLabel(this.displayCategory, false);
  },
  get typeLabelPlural()
  {
    return this._typeLabel(this.displayCategory, true);
  },
  _typeLabel : function(name, plural)
  {
    if (!this.__proto__._typeStringBundle)
    {
        this.__proto__._typeStringBundle =
            getStringBundle("chrome://tthome/locale/logic/model/itemTypes.properties");
    }
    var label;
    if (plural)
        name += "Plural";
    try {
        label = this.__proto__._typeStringBundle.GetStringFromName(name);
    } catch (e) {
label = this.__proto__._typeStringBundle.GetStringFromName("unknown");
    }
    return label;
  },
  get downloads()
  {
    return this._downloads;
  },
  get lastModification()
  {
    return this._lastModification;
  },
  get rating()
  {
    return this._rating;
  },
  get votes()
  {
    return this._votes;
  },
  get tags()
  {
    return this._tags;
  },
  get categories()
  {
    return this._categories;
  },
get isSharing()
  {
    return this._isSharing;
  },
get isShareable()
  {
    var shareable = ttItem.isShareable([this.typeID]);
    if (shareable && this instanceof ttPOI)
        return (this.idstr != "FuelStations");
    else
        return shareable;
  },
  get isRateable()
  {
    var rateable = (ttItem.cRateableTypes[this.typeID]);
    if (rateable && this instanceof ttPOI)
        return (this.idstr != "FuelStations");
    else
        return rateable;
  },
get dependencies()
  {
       return this._dependencies;
  },
get subitems()
  {
       return this._subitems;
  },
newerThan : function(other)
  {
    assert(other instanceof ttItem, "need ttItem");
    return versionNewerThan(this.version, other.version);
  },
compareTo : function(other)
  {
    return 0;
  },

  set idurl(newVal)
  {
    this._idurl = makeSafe.contentidurl(newVal);
    this._hasIDURL = true;
    this._ensureXML();
    this._xml.@idurl = newVal;
  },
  set idnum(newVal)
  {
    this._idnum = makeSafe.contentidnum(newVal);
    this._ensureXML();
    this._xml.@idnum = newVal;
  },
  set idstr(newVal)
  {
    this._idstr = makeSafe.contentidstr(newVal);
    this._ensureXML();
    this._xml.@idstr = newVal;
  },
  set name(newVal)
  {
    this._name = newVal;
    this._ensureXML();
    this._xml.title = newVal;
    this.setNameLanguage(gApplication.settings.networkLocale);
  },
  set description(newVal)
  {
    this._description = newVal;
    this._ensureXML();
    this._xml.description = newVal;
    this._xml.description.@mimetype = "text/plain";
    this.setDescriptionLanguage(gApplication.settings.networkLocale);
  },
  _NAMESPACE_XML : new Namespace("xml", "http://www.w3.org/XML/1998/namespace"),
  setNameLanguage : function(newVal)
  {
    var xmlns = this._NAMESPACE_XML;
    this._xml.title.@xmlns::lang = makeSafe.languageCode(newVal);
  },
  setDescriptionLanguage : function(newVal)
  {
    var xmlns = this._NAMESPACE_XML;
    this._xml.description.@xmlns::lang = makeSafe.languageCode(newVal);
  },
  set version(newVal)
  {
    this._version = makeSafe.version(newVal);
    this._ensureXML();
    this._xml.@version = newVal;
  },
  set size(newVal)
  {
    this._size = makeSafe.integer(newVal);
    this._ensureXML();
    this._xml.size = newVal;
  },
  set price(newVal)
  {
    assert(newVal instanceof ttCurrency, "Price must be a ttCurrency");
    this._endPrice = newVal;
    this._ensureXML();
    this._xml.price = newVal.exportToXML();
  },
  set icon(newVal)
  {
    assert(newVal instanceof ttImage || newVal == null, "Icon must be a ttImage");
    this._icon = newVal;
    this._ensureXML();
    for each (var image in this._xml.image.(@usage == "icon"))
    {
        delete this._xml.children()[image.childIndex()];
    }
    if (newVal)
    {
      var xml = newVal.exportToXML();
      xml.@usage = "icon";
      this._xml.appendChild(xml);
    }
  },
  set preview(newVal)
  {
    assert(newVal instanceof ttImage || newVal == null, "Preview must be a ttImage");
    this._preview = newVal;
    this._ensureXML();
    for each (var image in this._xml.image.(@usage == "preview"))
    {
        delete this._xml.children()[image.childIndex()];
    }
    if (newVal)
    {
      var xml = newVal.exportToXML();
      xml.@usage = "preview";
      this._xml.appendChild(xml);
    }
  },
set locations(newVal)
  {
    assert(!newVal || newVal.length > -1, "download locations must be an array (potentially empty)");
    var xml = <download/>;
    var haveMain = false;
    for (var i = 0; i < newVal.length; i++)
    {
      var d = newVal[i];
      if ((d.url instanceof CI.nsIFile) || (d.url instanceof CI.nsIURI && d.url.schemeIs("file")))
        continue;

      var dxml = <url/>;
      dxml.@location = makeSafe.url(d.url.spec).spec;
      dxml.@size = makeSafe.integer(d.size);

      if (d.content)
        dxml.@content = makeSafe.string(d.content);
      else
        dxml.@content = "main";
      if (dxml.@content == "main")
      {
        if (haveMain)
          throw "Can have only one main content location";
        else
          haveMain = true;
      }

      xml.appendChild(dxml);
    }

    this._locations = newVal;
    this._ensureXML();

    if (xml.elements().length() > 0)
        this._xml.download = xml;
    else
    {
delete this._xml.download;
    }
  },
  set authorName(newVal)
  {
    this._authorName = makeSafe.string(newVal);
    this._ensureXML();
    this._xml.author.name = newVal;
    this._xml.author.@anonymous = "false";
  },
  set supplierName(newVal)
  {
    this._supplierName = makeSafe.string(newVal);
    this._ensureXML();
    this._xml.supplier.name = newVal;
  },
  set supplierID(newVal)
  {
    this._supplierID = makeSafe.alphanumdash(newVal);
    this._ensureXML();
    this._xml.supplier.@id = newVal;
  },

set isSharing(newVal)
  {
    this._isSharing = makeSafe.bool(newVal);
    this._ensureXML();
    this._xml.supplier.@sharing = newVal;
    if (newVal)
    {
        const anon = "TomTom Community User";
        this.supplierName = anon;
        this.authorName = anon;
        this._xml.author.@anonymous = "true";
    }
    else
        delete this._xml.supplier;
  },
  set downloads(newVal)
  {
    this._downloads = (newVal == null ? null : makeSafe.integer(newVal));
    this._ensureXML();
    if (this._downloads == null)
        delete this._xml.downloadcount;
    else
        this._xml.downloadcount = this._downloads;
  },
  set lastModification(newVal)
  {
    assert(newVal == null || newVal instanceof Date, "Last update time must be a Date");
    this._lastModification = newVal;
    this._ensureXML();
    if (this._lastModification == null)
        delete this._xml.lastmodificationtime;
    else
        this._xml.lastmodificationtime = dateToISO8601(this._lastModification);
  },
  set rating(newVal)
  {
    this._rating = (newVal == null ? null : makeSafe.rangeInt(newVal, 0, 5000));
    this._ensureXML();
    if (this._rating == null)
    {
        this._votes = null;
        delete this._xml.rating;
    }
    else
        this._xml.rating.@stars = this._rating;
  },
  set votes(newVal)
  {
    this._votes = (newVal == null ? null : makeSafe.integer(newVal));
    this._ensureXML();
    if (this._votes == null)
    {
        this._rating = null;
        delete this._xml.rating;
    }
    else
        this._xml.rating.@votes = this._votes;
  },
  set tags(newVal)
  {
    this._tags = makeSafe.list(newVal,
                    function (tag) { return makeSafe.alphanumdash(tag); },
                    " ").join(" ");
    this._ensureXML();
    this._xml.sharing.tags = this._tags;
  },
  set categories(newVal)
  {
    this._categories = makeSafe.alphanumdash(newVal);
    this._ensureXML();
    if ("sharing" in this._xml)
        delete this._xml.sharing.category;
    if (newVal)
        this._xml.sharing.category.@id = newVal;
  },
_ensureXML : function()
  {
    if (this._xml)
      return;
    this._xml = <{this.listEntry.xmlTag}/>;
    this.idstr = this.idstr;
    this.name = this.name;
    this.description = this.description;
    this.version = this.version;
    this.size = this.size;
    this.icon = this.icon;
    this.preview = this.preview;
    this.locations = this.locations;
  },
importFromXML : function(xml)
  {
    assert(typeof xml == "xml", "Need XML");
    this._xml = xml;
    if ("@idurl" in xml)
    {
        this._idurl = makeSafe.contentidurl(xml.@idurl);
        this._hasIDURL = true;
    }
    if ("@idnum" in xml)
        this._idnum = makeSafe.contentidnum(xml.@idnum);
    if ("@idstr" in xml)
        this._idstr = makeSafe.contentidstr(xml.@idstr);
    else
        this._idstr = this.idurl;
    this._name = makeSafe.label(this._getLangSensitiveElem(xml.title));
    if ("description" in xml)
    {
        var ucDescription = this._getLangSensitiveElem(
            xml.description.(function::attribute("mimetype").length() != 0 &&
                             function::attribute("mimetype") == "text/plain"));
        if (ucDescription)
            this._description = makeSafe.label(ucDescription);
    }
    this._version = makeSafe.version(xml.@version);

    if ("size" in xml)
    {
        this._size = makeSafe.integer(xml.size);
    }

    if ("price" in xml)
    {
        this._endPrice = ttCurrency.prototype.createFromServer(xml.price);
        this._oldPrice = this._endPrice.copy();
        if ("discount" in xml.price)
        {
            let discount = ttCurrency.prototype.parseCurrencyString(xml.price.discount.@amountreduction);
            this._discountedBy = new ttCurrency(discount[0], discount[1], this._endPrice.currencyCode);
            this._oldPrice = ttCurrency.prototype.add(this._endPrice, this._discountedBy);

            if (this._endPrice.value == 0)
                this._endPrice.free = true;
        }
        var taxes = xml.price.tax.(@type == "vat");
        if (taxes.length() > 0)
            this._taxVAT = ttCurrency.prototype.createFromServer(taxes[0]);
    }

    for each (var icon in xml.image.(@usage == "icon"))
    {
        try {
            this._icon = ttImage.prototype.createFromServer(icon);
            if (this._icon.width)
                makeSafe.rangeInt(this._icon.width, 16, 128);
            if (this._icon.height)
                makeSafe.rangeInt(this._icon.height, 16, 128);
        } catch (e) { unimportantError(e); }
    }
    for each (var preview in xml.image.(@usage == "preview"))
    {
        try {
            this._preview = ttImage.prototype.createFromServer(preview);
        } catch (e) { unimportantError(e); }
    }

    if ("download" in xml)
    {
        this._locations = new Array();

        for each (var url in xml.download.url)
        {
            var location =
            {
                url    : makeSafe.url(url.@location),
                size   : "@size" in url ? makeSafe.integer(url.@size) : 0,
                content: makeSafe.string(url.@content)
            };

            if (location.content == "main")
                this._mainLocation = location.url;

            this._locations.push(location);
        }

        if (this._locations.length == 0)
            throw new Exception(this._stringBundle.GetStringFromName("noDownloadURL"));
        if (!this._mainLocation)
            this._mainLocation = this._locations[0].url;
    }

    if ("author" in xml)
    {
        this._authorName = makeSafe.string(xml.author.name);
        if ("@anonymous" in xml.author && makeSafe.bool(xml.author.@anonymous))
            this._authorName = this._stringBundle.GetStringFromName("anonymous");
    }

    if ("supplier" in xml)
    {
        this._supplierName = makeSafe.string(xml.supplier.name);
        if ("@id" in xml.supplier)
            this._supplierID = makeSafe.string(xml.supplier.@id);
        if ("@sharing" in xml.supplier)
            this._isSharing = makeSafe.bool(xml.supplier.@sharing);
        for each (var icon in xml.supplier.image.(@usage == "icon"))
        {
            try {
                this._supplierIcon = ttImage.prototype.createFromServer(icon);
            } catch (e) { unimportantError(e); }
        }
    }

    if ("downloadcount" in xml)
    {
        this._downloads = makeSafe.integer(xml.downloadcount);
    }

    if ("lastmodificationtime" in xml)
    {
        this._lastModification = makeSafe.date(xml.lastmodificationtime);
    }

    if ("rating" in xml)
    {
        this._rating = makeSafe.rangeInt(xml.rating.@stars, 0, 5000);
        this._votes = makeSafe.integer(xml.rating.@votes);
    }

    if ("sharing" in xml)
    {
        if ("tags" in xml.sharing)
        {
            this._tags = makeSafe.list(xml.sharing.tags.text(),
                            function (tag) { return makeSafe.alphanumdash(tag); },
                            " ").join(" ");
        }
        for each (var cat in xml.sharing.category)
        {
            this._categories = makeSafe.alphanumdash(cat.@id);
            break;
        }
    }

    this._dependencies = [];
    if ("dependencies" in xml)
    {
        for each (var reference in xml.dependencies.itemref)
        {
            this._dependencies.push(ttItemRef.prototype.createFromServer(reference));
        }
    }

    this._hasHOME2Metadata = true;
  },
_getLangSensitiveElem: function(aElemList)
  {
    assert(typeof aElemList == "xml", "Need XML");

    if (aElemList.length() == 0)
        return null;

    var lang = gApplication.settings.networkLocale;
    var langAttr = new QName("http://www.w3.org/XML/1998/namespace", "lang");

    var result = aElemList.(function::attribute(langAttr) == lang);
    if (result && result.length() != 0)
        return result[0];

    result = null;
    result = aElemList.(function::attribute(langAttr).length() != 0 &&
        function::attribute(langAttr).substr(0, 2) == lang.substr(0, 2));
    if (result && result.length() != 0)
        return result[0];

    result = null;
    result = aElemList.(function::attribute(langAttr).length() != 0 &&
        function::attribute(langAttr).substr(0, 2) == "en");
    if (result && result.length() != 0)
        return result[0];

    return aElemList[0];
  },
importFromServer : function(xml)
  {
    this._xml = xml;

    this.importFromXML(xml);

    if (!("price" in xml))
    {
        this._oldPrice = null;
        this._endPrice = null;
        this._locationType = 4;
    }
    else
    {
        if (this._endPrice.free)
            this._locationType = 4;
        else
            this._locationType = 6;
    }
this._isServer = true;
  },
exportToXML : function()
  {
    this._ensureXML();
    return this._xml.copy();
  },
download : function(aProgressCallback, aSuccessCallback, aErrorCallback)
  {
    throw new Bug("Not implemented");
  },

  __end : null
}
ttItem.sizeBytesToMB = function(bytes)
{
    if (bytes == 0)
        return this.prototype._stringBundle.formatStringFromName("sizeMB", ["0"], 1);
    var mb = bytes / 1048576;
    if (mb <= 0.05)
        return this.prototype._stringBundle.GetStringFromName("sizeTiny");
    var rounded = Math.round(mb * 10) / 10;
    rounded = rounded.toFixed(1);
    return this.prototype._stringBundle.formatStringFromName("sizeMB", [rounded], 1);
}
ttItem.sizeBytesToActualDisplay = function(bytes)
{
    var kb = bytes / 1024;
    var mb = kb / 1024;
    var format = this.prototype._stringBundle.formatStringFromName;

    if (kb < 1) return format("sizeKB", ["1"], 1);
    else if (kb < 100) return format("sizeKB", [kb.toFixed(0)], 1);
    else if (kb < 10 * 1024) return format("sizeKB", [kb.toFixed(0)], 1);
    else if (mb < 100) return format("sizeMB", [mb.toFixed(1)], 1);
    else return format("sizeMB", [mb.toFixed(0)], 1);
}
ttItem.cRateableTypes =
{
    arrivalsound: true,
    buddysymbol: true,
    carsymbol: true,
    colorscheme: true,
    favouritesymbol: true,
    homesymbol: true,
    itinerary: true,
    messagereceived: true,
    poi: true,
    ringtone: true,
    satimage: true,
    shutdownsound: true,
    startupscreen: true,
    startupsound: true,
    suspendscreen: true,
    trail: true,
    voice: true,
    warningsound: true,
    zipcode: true
}
ttItem.isRateable = function(typeID)
{
    return (typeID in ttItem.cRateableTypes && ttItem.cRateableTypes[typeID]);
}
ttItem.cShareableTypes =
{
    arrivalsound: true,
    buddysymbol: true,
    carsymbol: true,
    colorscheme: true,
    favouritesymbol: true,
    homesymbol: true,
    itinerary: true,
    messagereceived: true,
    poi: true,
    ringtone: true,
    satimage: true,
    shutdownsound: true,
    startupscreen: true,
    startupsound: true,
    suspendscreen: true,
    voice: true,
    warningsound: true
}
ttItem.isShareable = function(typeID)
{
    return (typeID in ttItem.cShareableTypes && ttItem.cShareableTypes[typeID]);
}
