/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function TLVVocabularyFetcher()
{
}
TLVVocabularyFetcher.prototype =
{
    _kFilename : "itemmetadata.tlvvoc.xml",
    _kURL : "http://home.tomtom.com/tlvvocabulary/itemmetadata.tlvvoc.xml",
    _triedToFetch : false,
start : function()
    {
        try {
            var inProfile = this._getLocalVocFile(gApplication.settings.profileDir);
            if (!inProfile.exists())
                throw "file not found";
            this._setVoc(inProfile);
        } catch (e) {
            unimportantError(e, "Could not use item metadata TLV voc in profile: ");
            var inInstall = this._getLocalVocFile(gApplication.settings.installDir);
if (inInstall.exists())
            this._setVoc(inInstall);
        }

        rpc.addOnlineObserver(this);
    },

    changed : function()
    {
        try {
            if (!rpc.isOnline)
                return;
            if (this._triedToFetch)
                return;
            this._triedToFetch = true;

            var inProfile = this._getLocalVocFile(gApplication.settings.profileDir);
            var me = this;
            var url = null;
            try {
                url = rpc.serviceBaseURL("tlvvocabulary").spec;
            } catch (e1) { unimportantError(e1);
}
if (!url)
                return;
            url += this._kURL.replace("http://", "");{}
new Downloader().download(
                getIOService().newURI(url, null, null),
                inProfile,
                function() {}, function(file)
                {
                    file.moveTo(inProfile.parent, me._kFilename);
                    me._setVoc(inProfile);
                },
                unimportantError);
        } catch (e) { error(e); }
    },

    _getLocalVocFile : function(dir)
    {
        var file = dir;
        file.append("Resources");
        ensureDirExists(file);
        file.append(this._kFilename);
        return file;
    },

    _setVoc : function(file)
    {
        var voc = readFile(file).join("\n");
        gApplication.homeServices.itemMetadataTLVVocabulary = voc;
    },

    __end : null
}
