/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function Commit()
{
    ttPage.apply(this, arguments);
    this.parts = new Array();
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/bindings/commit.properties");
}
Commit.prototype =
{
    _stringBundle : null,
    _showMessage : false,
    _speed : 3,
    _deviceType : null,
    _action : null,
    _disconnect : true,
    _done : false,
    _taskname : null,
    _errorFlag : false,

    init : function(length, action)
    {
        var device = gApplication.deviceManager.activeDevice;
        if (device)
        {
            top.gMainWindow.statusbar.deviceStateDisplay.overrideDeviceBusyStatus(true);
            this._deviceType = gApplication.deviceManager.getDeviceType();
        }

        this._taskname = window.parent.task.name;
        this._action = action;
        this.showDeviceMessage();
        if(!(this._taskname == "AddonsTask" || this._action == 'removelocal'))
        {
            this.loadDisconnectDeviceMessage(device);
            this.slideDown("disconnectWarning");
        }
    },
loadDisconnectDeviceMessage : function(device)
    {
        let currenttask = top.gMainWindow.currentTask().name;
        if (prefService().prefHasUserValue("tomtom.account.showDisconnectMessage"))
        {
            this._showMessage = prefService().getBoolPref("tomtom.account.showDisconnectMessage");
        }
        if(device)
        {
            if(currenttask == "Update")
            {
                openDialog("chrome://tthome/content/ui/dialogs/disconnectMessage/updateTaskDisconnectMessage.xul",
                                  "title",
                                  "chrome,centerscreen,titlebar=no,modal",
                                  { currenttask: currenttask},
                                  {},{},false, top);
            }
            else{
                if(!this._showMessage)
                {
                    openDialog("chrome://tthome/content/ui/dialogs/disconnectMessage/disconnectMessage.xul",
                                      "title",
                                      "chrome,centerscreen,titlebar=no,modal",
                                      { currenttask: currenttask},
                                      {},{},false, top);
                }
            }
        }
    },
loadDisconnectDeviceErrorMessage : function()
    {
        let currenttask = top.gMainWindow.currentTask().name;
        openDialog("chrome://tthome/content/ui/dialogs/disconnectMessage/disconnectErrorMessage.xul",
                            "title",
                            "chrome,centerscreen,titlebar=no,modal",
                            { installLocOfDevice: this._deviceType, currenttask: currenttask},
                            {},{},false, top);
    },

    partSetup : function(i, name)
    {
        try {
            var part = new Object();
            this.parts[i] = part;
            if((this._taskname == "BackupTask") || (this._taskname == "RestoreTask"))
            {
                E("results").hidden=true;
                E("resultsone").hidden=false;
                E("backuprestore").hidden=false;
                E("arrowdesc").hidden=true;

                if(this._deviceType != "pnd")
                {
                    E("deviceimage").className = "automotiveDeviceImage";
                }
            }
            if(this._taskname == 'BackupTask')
            {
                E("backupmiddle").hidden=false;
                E('nobackup').hidden=true;


            }
            if(this._taskname == 'RestoreTask')
            {
                E("restoremiddle").hidden=false;
                E("nobackup").hidden=true;
            }
            if((this._taskname =='BackupTask') || (this._taskname == 'RestoreTask'))
            {
                part.citem = document.createElement("backupitem");
                if(this._taskname == 'BackupTask')
                {
                    part.citem.setAttribute("backupArrow", false);
                    part.citem.setAttribute("restoreArrow", true);
                    part.citem.setAttribute("progress", 0);
                }
                else
                {
                    part.citem.setAttribute("backupArrow", true);
                    part.citem.setAttribute("restoreArrow", false);
                     part.citem.setAttribute("progress", 247);

                }
            }
            else
            {
                part.citem = document.createElement("commititem");
            }

            if((this._taskname == 'BackupTask') || (this._taskname == 'RestoreTask'))
            {
                E("resultsone").appendChild(part.citem);
            }
            else
            {
                E("results").appendChild(part.citem);
                part.citem.setAttribute("number", (i + 1) + ".");
            }
            part.citem.setAttribute("name", name);
            part.citem.setAttribute("status", "notstarted");
            part.citem.setAttribute("last", "true");
            if (i > 0)
            {
                this.parts[i - 1].citem.removeAttribute("last");
            }

        } catch (e) { error(e); }
    },
    partStart : function(i)
    {
        try {
            var part = this.parts[i];
            part.citem.setAttribute("status", "inprogress");
            part.citem.setAttribute("progressmode", "undetermined");

            part.citem.setAttribute("text", this._stringBundle.GetStringFromName("commit.processing"));
           if((this._taskname == 'BackupTask') || (this._taskname == 'RestoreTask'))
            {
                var scroller = E("resultsone").boxObject.QueryInterface(CI.nsIScrollBoxObject);
                scroller.ensureElementIsVisible(part.citem);
            }
            else
            {
                var scroller = E("results").boxObject.QueryInterface(CI.nsIScrollBoxObject);
                scroller.ensureElementIsVisible(part.citem);
            }
        } catch (e) {
            top.gMainWindow.statusbar.deviceStateDisplay.overrideDeviceBusyStatus(false);
            error(e);
        }
    },

    partProgress : function(i, percent, text)
    {
        try {
            var device = gApplication.deviceManager.activeDevice;
            if (!device && !(this._taskname == "AddonsTask" || this._action == 'removelocal'))
            {
                this._wizard().cancelCommit();
            }
            else
            {
                var part = this.parts[i];
                if (percent > 0)
                {
                    if(this._taskname == 'BackupTask')
                    {
                        var progressWidth = ((210/100) * percent) + 30;
                        part.citem.setAttribute("progress", progressWidth);

                    }
                    else if(this._taskname == 'RestoreTask')
                    {
                        var progressWidth = 247 - ((247/100) * percent);
                        part.citem.setAttribute("progress", progressWidth);
                        this.showLastBackup();
                    }
                    else
                    {
                        part.citem.setAttribute("progressmode", "determined");
                        part.citem.setAttribute("progress", percent);
                        part.citem.setAttribute("text", text);
                    }
                }
            }
        } catch (e) {
            top.gMainWindow.statusbar.deviceStateDisplay.overrideDeviceBusyStatus(false);
            error(e);
        }
    },

    partDone : function(i, success, textOrException, cancelCommit)
    {
        try {
            var part = this.parts[i];
            var text = errorToText(textOrException);
            part.citem.setAttribute("text", text);
            part.citem.setAttribute("tooltiptext", text);
            part.citem.setAttribute("status", success ? "done" : "error");

            if (!success)
            {
                this._errorFlag = true;
                E("disconnectWarning").hidden = true;

                if(this._taskname == 'BackupTask')
                {
                    part.citem.setAttribute("progress", 0);
                    E('nobackup').hidden=false;
                }
                else if(this._taskname == 'RestoreTask')
                {
                    part.citem.setAttribute("restoreGreen", true);
                }

                if (cancelCommit)
                {
                    E("disturbedDownload").hidden = false;
                    E("commit_desc").textContent = this._stringBundle.GetStringFromName("error.abort");
                    E("disturbedSubHeader").textContent = this._stringBundle.GetStringFromName("error.continue");
                }
                else if(!this._disconnect)
                {
                    E("disturbedDownload").hidden = false;
                }
                else
                {
                    E("disturbedDownload").hidden = true;
                    if(this._taskname == 'Update')
                    {
                        E("disturbedDownloadOther").hidden = false;
                    }
                }
            }
        } catch (e) {
            top.gMainWindow.statusbar.deviceStateDisplay.overrideDeviceBusyStatus(false);
            error(e);
        }
    },
    allDone : function(success, iFailed)
    {
        try {
            E("disconnectWarning").hidden = true;
            if (success)
            {
                this.title = this._stringBundle.GetStringFromName("commit.title.done");
                E("allDone").hidden = false;
                this._done = true;
                if(this._taskname =='BackupTask')
                this.showLastBackup();
            }
            else
            {
                this.title = this._stringBundle.GetStringFromName("commit.title.cancelled");
                this.allowContinue(true);
            }

            this.subtitle = this._stringBundle.GetStringFromName("commit.clickDone");

            for (var i = iFailed + 1; i < this.parts.length; i++)
            {
                var part = this.parts[i];
                part.citem.setAttribute("text", this._stringBundle.GetStringFromName("commit.failed.earlier"));
                part.citem.setAttribute("status", "error");
            }
        } catch (e) {
            error(e);
        } finally {
            top.gMainWindow.statusbar.deviceStateDisplay.overrideDeviceBusyStatus(false);
        }
    },
disturbedDownload : function(activestatus)
    {
        if(activestatus)
        {
            E("disconnectWarning").hidden = true;
            E("disturbedDownload").hidden = false;
            E("allDone").hidden = true;
            this._disconnect = false;
        }
    },
slideDown : function(elemId)
    {
        if(this._errorFlag)
            return;

        if(this._disconnect)
        {
            E(elemId).hidden = false;
            E(elemId).style.height = (parseInt(E(elemId).style.height)+ this._speed)+'px';
            if (parseInt(E(elemId).style.height) < 70)
            {
                setTimeout(makeCallback(this, function()
                {
                    if(E("allDone").hidden)
                    {
                        this.slideDown(elemId);
                    }
                }), 10);
            }
            else
            {
                E(elemId).hidden = false;
                if(!E("allDone").hidden)
                {
                    E("disconnectWarning").hidden = true;
                }
                else
                {
                    E(elemId).hidden = false;
                }
                this.setOpacity(elemId);
            }
        }
        return;
    },
setOpacity : function(elemId)
    {
        E(elemId).style.opacity = parseFloat(E(elemId).style.opacity) + 0.01;
        if(parseFloat(E(elemId).style.opacity)<1)
        {
            setTimeout(makeCallback(this, function()
            {
                this.setOpacity(elemId);
            }),0);
        }
    },
showLastBackup: function()
    {
        var backupFolder = gApplication.settings.backupsDir;
        var backup = getLatestBackup(true, backupFolder);

        if(backup)
        {
            var file = Cc["@mozilla.org/file/local;1"]
             .createInstance(CI.nsILocalFile);

            file.initWithPath(backup.location.path);
            file.append('backup.xml');

            if (!file.exists())
            {
                 E("backuppop").hidden = true;
            }
            E('nobackup').hidden = true;
            E('backuptimestamp').hidden = false;
            var modTime = backup.modificationTime;
            var timeStamp = modTime.split(' ');
            var date="";
            var months = ["","January","February","March","April","May","June","July","August","September","October","November","December"];
            if(timeStamp.length == 5)
            {
                date = months[parseInt(timeStamp[1], 10)]+" "+timeStamp[0]+", "+timeStamp[2]+" - "+timeStamp[3]+":"+timeStamp[4];
            }
            E('backuptime').textContent = date;
        }
    },

    showLastBackupDialogue : function()
    {
        top.gMainWindow.dialogs.openDialog(
            "chrome://tthome/content/ui/dialogs/backup/lastBackup.xul"
            );
    },
showDeviceMessage : function()
    {
        E("allDoneHeader").textContent = this._stringBundle.GetStringFromName("commit.allDone.label");
        E("allDoneSubHeader").textContent = this._stringBundle.GetStringFromName("commit.allDone.sublabel");
        if (this._deviceType == "pnd")
        {
            E("disconnectHeader").textContent = this._stringBundle.GetStringFromName("pnd.disconnectWarning");
            E("disconnectSubHeader").textContent = this._stringBundle.GetStringFromName("pnd.disconnectSubWarning");
            E("commit_desc").textContent = this._stringBundle.GetStringFromName("error.pnd.title");

            if ((this._taskname == 'BuyAndInstall') || (this._taskname == 'ShowLocalItems') || (this._taskname == 'RestoreTask')  || (this._taskname == 'Update'))
            {
                E("disturbedSubHeader").textContent = this._stringBundle.GetStringFromName("error.pnd.update.content");
                if(this._taskname == 'Update')
                {
                    E("disconnectSubHeader").textContent = this._stringBundle.GetStringFromName("pnd.disconnectSubWarningUpdate");
                    E("allDoneSubHeader").textContent = this._stringBundle.GetStringFromName("commit.allDone.sublabelUpdate");
                }
            }
            if ((this._taskname == 'BackupTask') || (this._action == 'copytopc'))
            {
                E("disturbedSubHeader").textContent = this._stringBundle.GetStringFromName("error.backup.content");
            }
            if(this._action == 'removedevice')
            {
               E("disturbedSubHeader").textContent = this._stringBundle.GetStringFromName("error.pnd.remove.content");
            }
        }
        else
        {
            E("disconnectHeader").textContent = this._stringBundle.GetStringFromName("sd.disconnectWarning");
            E("disconnectSubHeader").textContent = this._stringBundle.GetStringFromName("sd.disconnectSubWarning");
            E("commit_desc").textContent = this._stringBundle.GetStringFromName("error.sd.title");
            if ((this._taskname == 'BuyAndInstall') || (this._taskname == 'ShowLocalItems') || (this._taskname == 'RestoreTask')  || (this._taskname == 'Update'))
            {
                E("disturbedSubHeader").textContent = this._stringBundle.GetStringFromName("error.sd.update.content");
            }
            if ((this._taskname == 'BackupTask') || (this._action == 'copytopc'))
            {
                E("disturbedSubHeader").textContent = this._stringBundle.GetStringFromName("error.backup.content");
            }
            if(this._action == 'removedevice')
            {
               E("disturbedSubHeader").textContent = this._stringBundle.GetStringFromName("error.sd.remove.content");
            }

        }

    },

    __end : null
}

extend(Commit, ttPage);
window.page = new Commit();
