/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


window.onload = function()
{
    var dashboard = E("add-to-my-go");
    if (dashboard)
    {
        var origRefresh = dashboard.refreshDeviceDependencies;
        dashboard.refreshDeviceDependencies = function()
        {
            origRefresh.apply(this, arguments);
            updateDocumentButton(dashboard);
            updateColorSchemesButton(dashboard);
            updateVoiceButton(dashboard);
            updateSafetyCameraButton(dashboard);
            updateImagesButton(dashboard);
            updateSoundButton(dashboard);
            updatePoiButton(dashboard);
        }
        updateDocumentButton(dashboard);
        updateColorSchemesButton(dashboard);
        updateVoiceButton(dashboard);
        updateSafetyCameraButton(dashboard);
        updateImagesButton(dashboard);
        updateSoundButton(dashboard);
        updatePoiButton(dashboard);
    }
}
function addMessageLaunch(type)
{
    if (gApplication.deviceManager.activeDevice)
    {
        top.gMainWindow.dialogs.openDialogAsPage(
            "chrome://tthome/content/ui/dialogs/info/addgoPage.xul",
            { type : type });
        return;
    }

    top.gMainWindow.dialogs.openDialogAsPage(
        top.gMainWindow.dialogs.kDeviceRequiredPage,
        null,
        null,
    function()
    {
        if (gApplication.deviceManager.activeDevice)
        {
            top.gMainWindow.dialogs.openDialogAsPage(
                "chrome://tthome/content/ui/dialogs/info/addgoPage.xul",
                { type : type });
        }
    }, false, top);
}

function buyAndInstallTTSVoiceLaunch()
{
    var dev = gApplication.deviceManager.activeDevice;
    if (!dev)
    {
        var sb = getStringBundle("chrome://tthome/locale/ui/dashboard/dashboard.properties");
        ttMessageService().alert(sb.GetStringFromName("needDevice.title"), sb.GetStringFromName("needDevice.text"));
        return;
    }
    var supportsLoquendo = dev.hasCapability("TTSLoquendo*");
    var supportsNuance = dev.hasCapability("TTSNuance*");
    var params = { contentType : null };

    if (supportsLoquendo && supportsNuance)
    {
var caps = gApplication.deviceManager.activeDeviceCapabilitiesString;
        if (caps.indexOf("TTSLoquendo") < caps.indexOf("TTSNuance"))
            params.contentType = "loquendovoice";
        else
            params.contentType = "vocalizervoice";
    }
    else if (supportsLoquendo)
        params.contentType = "loquendovoice";
    else if (supportsNuance)
        params.contentType = "vocalizervoice";
    else
        throw new NotReached("Have neither Loquendo nor Nuance voice capability.");

    top.gMainWindow.loadTaskByName("buyAndInstall", params);
}

function updateDocumentButton(dashboard)
{
    var canUseDocuments = true;
    var installLoc = gApplication.deviceManager.activeInstallLocation;
    var device = gApplication.deviceManager.activeDevice;

    if (device && device.hasCapability("NoDocuments"))
    {
        canUseDocuments = false;
    }

    if (installLoc && canUseDocuments)
    {
        var path = installLoc.path.path;
        if (path.indexOf("\\\\{") == 0 && path.indexOf("}") > 0)
        {
            canUseDocuments = false;
        }
    }

    if ("content-list-documents" in dashboard.buttonsById)
    {
        var button = dashboard.buttonsById["content-list-documents"];
        if (button.getAttribute("disabled") == "true")
            return;

        button.setAttribute("disabled", !canUseDocuments);
        if (!canUseDocuments && !button.hasAttribute("clickdisabled"))
        {
            button.setAttribute("clickdisabled", "this._unsupportedCapability()");
        }
    }
}

function updateColorSchemesButton(dashboard)
{
    var canUseColorSchemes = true;
    var device = gApplication.deviceManager.activeDevice;

    if (device && device.hasCapability("NoColorSchemes"))
    {
        canUseColorSchemes = false;
    }

    if ("content-list-colour-schemes" in dashboard.buttonsById)
    {
        var button = dashboard.buttonsById["content-list-colour-schemes"];
        if (button.getAttribute("disabled") == "true")
            return;

        button.setAttribute("disabled", !canUseColorSchemes);
        if (!canUseColorSchemes && !button.hasAttribute("clickdisabled"))
        {
            button.setAttribute("clickdisabled", "this._unsupportedCapability()");
        }
    }
}

function updateVoiceButton(dashboard)
{
    var canUseVoices = true;
    var device = gApplication.deviceManager.activeDevice;

    if (device && device.hasCapability("NoVoices"))
    {
        canUseVoices = false;
    }

    if ("content-list-voices" in dashboard.buttonsById)
    {
        var button = dashboard.buttonsById["content-list-voices"];
        if (button.getAttribute("disabled") == "true")
            return;

        button.setAttribute("disabled", !canUseVoices);
        if (!canUseVoices && !button.hasAttribute("clickdisabled"))
        {
            button.setAttribute("clickdisabled", "this._unsupportedCapability()");
        }
    }
}

function updateSafetyCameraButton(dashboard)
{
    var canUseSafetyCamera = true;
    var device = gApplication.deviceManager.activeDevice;
    
    if (device && device.hasCapability("NoSafetyCameras"))
    {
        canUseSafetyCamera = false;
    }

    if ("content-list-cameras" in dashboard.buttonsById)
    {
        var button = dashboard.buttonsById["content-list-cameras"];
        if (button.getAttribute("disabled") == "true")
            return;

        button.setAttribute("disabled", !canUseSafetyCamera);
        if (!canUseSafetyCamera && !button.hasAttribute("clickdisabled"))
        {
            button.setAttribute("clickdisabled", "this._unsupportedCapability()");
        }
    }
}

function updateImagesButton(dashboard)
{
    var canUseImages = true;
    var device = gApplication.deviceManager.activeDevice;
    
     if (device && device.hasCapability("NoImages"))
    {
        canUseImages = false;
    }

    if ("content-list-images" in dashboard.buttonsById)
    {
        var button = dashboard.buttonsById["content-list-images"];
        if (button.getAttribute("disabled") == "true")
            return;

        button.setAttribute("disabled", !canUseImages);
        if (!canUseImages && !button.hasAttribute("clickdisabled"))
        {
            button.setAttribute("clickdisabled", "this._unsupportedCapability()");
        }
    }
}

function updateSoundButton(dashboard)
{
    var canUseSound = true;
    var device = gApplication.deviceManager.activeDevice;
    
    if (device && device.hasCapability("NoSounds"))
    {
        canUseSound = false;
    }

    if ("content-list-sounds" in dashboard.buttonsById)
    {
        var button = dashboard.buttonsById["content-list-sounds"];
        if (button.getAttribute("disabled") == "true")
            return;

        button.setAttribute("disabled", !canUseSound);
        if (!canUseSound && !button.hasAttribute("clickdisabled"))
        {
            button.setAttribute("clickdisabled", "this._unsupportedCapability()");
        }
    }
}

function updatePoiButton(dashboard)
{
    var canUsePoi = true;
    var device = gApplication.deviceManager.activeDevice;
    
     if (device && device.hasCapability("NoPoi"))
    {
        canUsePoi = false;
    }

    if ("content-list-points" in dashboard.buttonsById)
    {
        var button = dashboard.buttonsById["content-list-points"];
        if (button.getAttribute("disabled") == "true")
            return;

        button.setAttribute("disabled", !canUsePoi);
        if (!canUsePoi && !button.hasAttribute("clickdisabled"))
        {
            button.setAttribute("clickdisabled", "this._unsupportedCapability()");
        }
    }
}

function audiobooksLaunch()
{
    top.gMainWindow.dialogs.openDialogAsPage(
        "chrome://tthome/content/ui/dialogs/audiobook/audiobook.xul");
}

function subdashGoBack()
{
    top.gMainWindow.loadContent(window.getChromeArg("return"));
}
function overrideSafetyCameraWithDangerZoneIfCountryFrance()
{
    if(gApplication.settings.country == 'FR' && E("content-list-cameras"))
    {
        this._stringBundle = getStringBundle("chrome://tthome/locale/ui/dashboard/addgo.properties");
            E("content-list-cameras").setAttribute('id', 'content-list-fr-cameras');
            E("content-list-fr-cameras").removeAttribute('croppedlabel');
            E("content-list-fr-cameras").setAttribute('label', this._stringBundle.GetStringFromName("addgo.cameras.fr.label"));
            var aLabel = E("content-list-fr-cameras").getAttribute("label").trim();
            if (!/\s/.test(aLabel))
            {
                E("content-list-fr-cameras").setAttribute("croppedlabel", aLabel);
            }            
            
            E("content-list-fr-cameras").setAttribute('sublabel', this._stringBundle.GetStringFromName("addgo.cameras.fr.sublabel"));
            E("content-list-fr-cameras").setAttribute('helptopic', 'danger_zones');
    }
}