/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function NYFeedbackDialog()
{
    ttDialog.call(this, "footer");
}
NYFeedbackDialog.prototype =
{
    onLoad: function(params)
    {
        if (!gApplication.deviceManager.activeDevice || !gApplication.deviceManager.activeDevice.mapShare)
        {
            E("mapshare-not-supported").hidden = false;
            return;
        }
        else
        {
            E("feedback-enabled").hidden = false;
        }

        var email = "";
        var optIn = prefService().getBoolPref("tomtom.mapshare.feedback");
        if (optIn)
        {
            email = prefService().getCharPref("tomtom.device.all.mapShare.upload.feedbackEmailAddress");
        }
        if (!email)
        {
            email = gApplication.login.getDefaultUsername();
        }
        E("feedback.optin.textbox").value = email;
        if (optIn)
        {
            E("feedback-enabled").selectedItem = E("feedback.optin.radio");
        }
        else
        {
            E("feedback-enabled").selectedItem = E("feedback.optout.radio");
        }
    },

    saveAndClose : function()
    {
        var mapShareStringBundle = E("mapShareStringBundle");
        var email = "";
        var validEmail = true;
        var optIn = E("feedback-enabled").selectedItem == E("feedback.optin.radio");
        if (optIn)
        {
            try{
                email = E("feedback.optin.textbox").value;
                checkEmailAddressSyntax(email);
            }
            catch(e)
            {
                ttMessageService().alert(mapShareStringBundle.getString("invalidEmail"), e);
                validEmail = false;
            }
        }
        if (validEmail)
        {
            prefService().setCharPref("tomtom.device.all.mapShare.upload.feedbackEmailAddress", email);
            prefService().setBoolPref("tomtom.mapshare.feedback", optIn);
            this.close()
        }
    },

    __end : null
}
extend(NYFeedbackDialog, ttDialog);
var dialog = new NYFeedbackDialog();
