/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


const HomeConnection =
{
    _downloadUrl1: "http://home.tomtom.com/media/suppliers/check.png",
    _downloadUrl2: "https://home.tomtom.com/media/suppliers/check.png",
    _downloadUrl3: "http://download.tomtom.com/sweet/application/releases/check.png",
    _downloadUrl4: "http://download.tomtom.com/sweet/application/releases/check.zip",
    _downloadUrl5: "http://download.tomtom.com/sweet/application/releases/check.zip",
    _initialByte : 1000,
    _lastByte : 2020,
    _hashCode1 : "68edc7d1cb1a901238bf31920b25ae9d",
    _hashCode2 : "68edc7d1cb1a901238bf31920b25ae9d",
    _hashCode3 : "68edc7d1cb1a901238bf31920b25ae9d",
    _hashCode4 : "0ca5e8b5d48183245f35440cd145cc7b",
    _hashCode5 : "7336be5dbac45c564ff18e965d7f0ec2",

    onLoad: function (params)
    {
       var status =  "";
       var checkNo = params.requestNo.toString();
       var downloadUrl = this["_downloadUrl"+checkNo] ;
       var hashCode = this["_hashCode"+checkNo] ;

       if(params.requestNo == 5)
       {
          status = "\t Test" + checkNo + ": Request Status of  "+ downloadUrl + " for Byte Range: " + this.checkStatus(downloadUrl ,true, hashCode);
       }
       else
       {
          status = "\t Test" + checkNo + ": Request Code of "+ downloadUrl + ": " + this.checkStatus(downloadUrl ,false, hashCode);
       }

       return status;
    },
checkStatus: function (aURL, aBytes, aHash)
    {

        try
        {
            var result = "";
            var xmlhttp = new XMLHttpRequest();
            xmlhttp.open('GET', aURL, false);
            if (aBytes)
            {
               xmlhttp.setRequestHeader("Range", "bytes=" + this._initialByte + "-" + this._lastByte);
            }

            xmlhttp.send(null);

            if(xmlhttp.readyState == 4)
            {
                if (xmlhttp.status == 200)
                {
                           var generatedHash = this.computeHash(xmlhttp.responseText);
                           if(generatedHash == aHash)
                           {
                                result = xmlhttp.status + ", (Success)";
                           }
                           else
                           {
                                result = xmlhttp.status + ", mismatched content (fail)";
                           }

                }
                else if (xmlhttp.status == 206)
                {
                        var generatedHash = this.computeHash(xmlhttp.responseText);
                        if(generatedHash == aHash)
                        {
                             result = xmlhttp.status + ", (Success)";
                        }
                        else
                        {
                             result = xmlhttp.status + " , mismatched content (fail)";
                        }
                }
                else
                {
                      result = xmlhttp.status + " , (fail)";
                }
            }
        }
        catch(e)
        {
            result =  errorToText(e);
        }
        return result;
    },
computeHash : function (aData)
    {
        var converter =
          Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].
            createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
        converter.charset = "UTF-8";
        var result = {};
        var data = converter.convertToByteArray(aData, result);
        var ch = Components.classes["@mozilla.org/security/hash;1"]
                           .createInstance(Components.interfaces.nsICryptoHash);
        ch.init(ch.MD5);
        ch.update(data, data.length);
        var hash = ch.finish(false);
        var hexHash = "";
        for (let i in hash)
        {
            hexHash += ("0" + hash.charCodeAt(i).toString(16)).slice(-2);
        }
        return hexHash;
    }
};
