/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/



const XULNS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
function LastBackupDialog()
{
    ttDialog.call(this, "footer");
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/dialogs/backup/lastBackup.properties");
}
LastBackupDialog.prototype =
{
    onLoad: function(params)
    {
        var listbox = E("item-listbox");
        var itemStringBundle = getStringBundle("chrome://tthome/locale/logic/model/itemTypes.properties");
        var tocfile = gApplication.settings.backupsDir;
        var backup = getLatestBackup(true, tocfile);

        var modTime = backup.modificationTime;
        var timeStamp = modTime.split(' ');
        var months = ["","January","February","March","April","May","June","July","August","September","October","November","December"];
        if(timeStamp.length == 5)
        {
             var lastBackupTime  = months[parseInt(timeStamp[1], 10)]+" "+timeStamp[0]+", "+timeStamp[2]+" - "+timeStamp[3]+":"+timeStamp[4];
        }

        var subtitle = this._stringBundle.formatStringFromName("window.subtitle", [lastBackupTime], 1);
        E("subtitle").subtitle = subtitle;

        var file = Cc["@mozilla.org/file/local;1"]
             .createInstance(CI.nsILocalFile);

        file.initWithPath(backup.location.path);
        file.append('backup.xml');

        if (file.exists())
        {
            var text = readFile(file);
            try
            {
                listbox.clear();
                var parser=new DOMParser();
                var xmlDoc= parser.parseFromString(text,'text/xml');
                var itemTags = xmlDoc.getElementsByTagName ("Item");
                var xmlNodes = ["name", "description", "version", "size"];

                for (var i = 0; i < itemTags.length; i++)
                {
                    var cur = i;
                    var itemType = itemTags[i].getElementsByTagName ('typeID')[0].textContent;

                    for(let k = i + 1; k < itemTags.length; k++)
                    {
                        var itemTypeNext = itemTags[k].getElementsByTagName ('typeID')[0].textContent;
                        if(itemType == itemTypeNext)
                        {
                            i++;
                        }
                    }
                     if(i == cur)
                     {
                         var typeLabel = itemStringBundle.GetStringFromName(itemType);
                     }
                     else
                     {
                         var typeLabel = itemStringBundle.GetStringFromName(itemType+'Plural');
                     }

                     var category = document.createElementNS(XULNS, "ttlistboxcategory");
                     category.setAttribute("label", typeLabel);
                     category.setAttribute("closed", true);
                     listbox.addItem(category);

                    for (let m = cur; m < i + 1; m++)
                    {
                        var recordNode = itemTags[m].getElementsByTagName (xmlNodes[0])[0];
                        if ('textContent' in recordNode)
                        {
                                var wrapperMain = document.createElementNS(XULNS, "hbox");
                                var wrapperImage = document.createElementNS(XULNS, "vbox");
                                var icon = itemTags[m].getElementsByTagName ('icon')[0];
                                var imageIcon =  document.createElement("image");
                                imageIcon.setAttribute("id" , "item-icon");


                                if(icon)
                                {
                                  icon = icon.textContent;
                                  imageIcon.setAttribute("src",icon);
                                }
                                wrapperImage.appendChild(imageIcon);
                                wrapperMain.appendChild(wrapperImage);

                                var wrapperTitle = document.createElementNS(XULNS, "vbox");
                                var titleBox = document.createElementNS(XULNS, "hbox");
                                var descr = document.createElementNS(XULNS, "description");
                                var imageLogo = document.createElement("image");
                                descr.textContent = unescape(decodeURIComponent(recordNode.textContent));
                                descr.setAttribute("id" , 'item_desc');
                                imageLogo.setAttribute("id", "main_image");
                                wrapperTitle.setAttribute("id" , "main_wrapper");

                                titleBox.appendChild(imageLogo);
                                titleBox.appendChild(descr);
                                wrapperTitle.appendChild(titleBox);
                        }

                        var wrapper = document.createElementNS(XULNS, "vbox");
                        for (let j = 1; j < xmlNodes.length; j++)
                        {
                            recordNode = itemTags[m].getElementsByTagName (xmlNodes[j])[0];
                            if ('textContent' in recordNode)
                            {
                                    var description = document.createElementNS(XULNS, "description");
                                    if(j==2)
                                    {
                                        var version = document.createElementNS(XULNS, "label");
                                        version.setAttribute("id" ,"version");
                                        version.setAttribute("value" , getStringBundle("chrome://tthome/locale/ui/dialogs/backup/lastBackup.properties").GetStringFromName("version.label"));

                                        var size = document.createElementNS(XULNS, "label");
                                        size.setAttribute("value" , recordNode.textContent);
                                        description.appendChild(version);
                                        description.appendChild(size);
                                    }
                                    else if(j==3)
                                    {
                                      var size_label = document.createElementNS(XULNS, "label");
                                      size_label.setAttribute("id" , "size");
                                      size_label.setAttribute("value" ,getStringBundle("chrome://tthome/locale/ui/dialogs/backup/lastBackup.properties").GetStringFromName("size.label"));

                                      var size = document.createElementNS(XULNS, "label");
                                      size.setAttribute("value" , ttItem.sizeBytesToMB(recordNode.textContent));
                                      description.appendChild(size_label);
                                      description.appendChild(size);
                                    }
                                    else
                                    {
                                      description.textContent= unescape(decodeURIComponent(recordNode.textContent));
                                    }
                                    description.setAttribute("id" , "item_info");
                                    wrapper.appendChild(description);
                            }
                        }
                        wrapper.setAttribute("hidden" ,'true');
                        wrapper.setAttribute("id" ,'item' + m);
                        wrapperTitle.appendChild(wrapper);
                        var moreLink = document.createElementNS(XULNS,"ttlink");
                        moreLink.setAttribute("id" , "more_link" + m);
                        moreLink.setAttribute("class" , "more_link");
                        moreLink.setAttribute("label" , getStringBundle("chrome://tthome/locale/ui/bindings/ttitemlistbox.properties").GetStringFromName("moreinfo.label"));
                        moreLink.addEventListener("click", makeCallback(this, this.toggle, m), false);
                        wrapperTitle.appendChild(moreLink);
                        wrapperMain.appendChild(wrapperTitle);
                        category.addItem(wrapperMain);
                        var border =  document.createElementNS(XULNS,"seperator");
                        border.setAttribute("id", "border");
                        category.addItem(border);
                    }
                }
                listbox.doneLoading = true;
            }
            catch(e)
            {
                error(e);
            }
        }
    },

    toggle: function(cur)
    {
        var hidden = E("item"+cur).hidden;
        if(hidden)
        {
            E("item"+cur).hidden = false;
            E("more_link"+cur).setAttribute("label" , getStringBundle("chrome://tthome/locale/ui/bindings/ttitemlistbox.properties").GetStringFromName("list.hide"));
        }
        else
        {
            E("item"+cur).hidden = true;
            E("more_link"+cur).setAttribute("label" , getStringBundle("chrome://tthome/locale/ui/bindings/ttitemlistbox.properties").GetStringFromName("moreinfo.label"));
        }
     },
    __end : null
}
extend(LastBackupDialog, ttDialog);
var dialog = new LastBackupDialog();
