/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function WaitForDeviceDialog()
{
    ttDialog.call(this, "message-footer");
}
WaitForDeviceDialog.prototype =
{
_deviceId: null,
_deviceType: null,
_success: false,

    onLoad: function(params)
    {
        var dev = gApplication.deviceManager.activeDevice;
        var loc = gApplication.deviceManager.activeInstallLocation;
        this._bundle = E("devicedisconnect-bundle");
		this._deviceType = "pnd";
		if (dev)
		{
			this._deviceId = dev.id;
		}
        this._deviceType = this._getDeviceType(dev, loc);
        setTimeout(makeCallback(this, this.attemptReboot), 0);
    },

    attemptReboot: function()
    {
        var dev = gApplication.deviceManager.activeDevice;
        assert(dev, "Device was disconnected before a reboot could be attempted.");
        gApplication.deviceManager.pauseDeviceSelection();
        gApplication.homeServices.devices().addObserver(this);
        window.addEventListener("unload", makeCallback(this, function()
        {
            gApplication.homeServices.devices().removeObserver(this);
            gApplication.deviceManager.resumeDeviceSelection();

            if (this._success)
                opener.top.gMainWindow.loadTaskByName("update");
        }), false);

        var rebootOutcome = CI.ttIDevice.kDisconnectFail;
        try
        {
            rebootOutcome = dev.disconnect(true);
        }
        catch (e)
        {
            unimportantError(e);
        }

        if (rebootOutcome != CI.ttIDevice.kDisconnectReboot)
            this.onRebootFail();
    },

    onRebootFail: function()
    {
        E("content-deck").selectedPanel = E("reboot-failed-" + this._deviceType);
        E("header").setAttribute("title", this._bundle.getString("window.title." + this._deviceType));
        E("subheader").subtitle = this._bundle.getString("window.subtitle." + this._deviceType);
    },

    onRebootDone: function(dev)
    {
        this._success = true;
        
        E("content-deck").selectedPanel = E("reconnect-success");
        E("header").setAttribute("title", this._bundle.getString("reconnect.title"));
        E("subheader").subtitle = null;
        E("header").className = "alert-header";
        E("message-footer").getLeftButton().notvisible = true;
        E("message-footer").getRightButton().notvisible = false;
        E("message-footer").setAttribute("onrightcommand", "dialog.close();");
        
        E("content-deck").setAttribute("onclose", "gApplication.deviceManager.resumeDeviceSelection(dev);");
    },

    QueryInterface: function(iid)
    {
        if (iid.equals(CI.ttICollectionObserver) ||
            iid.equals(CI.nsISupportsWeakReference) ||
            iid.equals(CI.nsISupports))
            return this;
        throw Components.results.NS_ERROR_NO_INTERFACE;
    },

    _getDeviceType : function(dev, loc)
    {
        if (dev && dev.model.familyName == "PocketPC")
            return "pocketpc"
        else if (loc && loc.physicalType == CI.ttIInstallLocation.kLocationTypeCardReader)
            return "card";
        else
            return "pnd";
    },
    added: function(dev)
    {
        if (dev instanceof CI.ttIDevice && dev.id == this._deviceId)
            this.onRebootDone(dev);
    },
    removed: function() {},
    repopulated: function() {},

    __end : null
}
extend(WaitForDeviceDialog, ttDialog);
var dialog = new WaitForDeviceDialog();
