/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


var gSerial = null;
var gDeviceCode = null;
 
var observer =
{
    changed: function(deviceChanged, locationChanged)
    {
        window.deviceChanged();
    }
};
function DeviceRequiredDialog()
{
    ttDialog.call(this, "footer");
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/dialogs/device/deviceRequiredPage.properties");}
 
DeviceRequiredDialog.prototype =
{
    _stringBundle: null,
    
    onLoad: function(params)
    {
        
        gApplication.deviceManager.addObserver(observer)
        if (params && (params.specificDeviceSerial || params.specificDeviceDeviceCode))
        {
            setSpecificDevice(
                params.specificDeviceSerial,
                params.specificDeviceDeviceCode,
                params.specificDeviceModelName);
        }
        deviceChanged();
        var taskName = ''; 
        if (top.gMainWindow.currentTask())
            taskName = top.gMainWindow.currentTask().name;
        else
            taskName = params.contentType;
        this.loadStrings(taskName);
    },
loadStrings : function(taskName)
    {
        var showJourneyThree = ["Update", "traffic", "liveservices", "safetycamera", "dangerzone"];
        var taskItems = ["Update", "traffic", "safetycamera","liveservices", "localsearch", "ActivatePromotionCodeTask", "map"];
        
        if(taskItems.indexOf(taskName)== -1)
        {
          taskName = "others";
        }
        
        if(gApplication.settings.country == 'FR' && taskName== "safetycamera")
        {
            taskName = "dangerzone";
        }
        
        E("footer-header").textContent = this._stringBundle.GetStringFromName("footer.header." + taskName);
        E("journey-text-left").textContent = this._stringBundle.GetStringFromName("journey.line.left."+taskName);
        E("journey-text-middle").textContent = this._stringBundle.GetStringFromName("journey.line.middle."+taskName);
        
        if(showJourneyThree.indexOf(taskName)!= -1)
        {
            E("round-dot3").hidden = false;
            E("journey-text-right").hidden = false;
            E("journey-text-right").textContent = this._stringBundle.GetStringFromName("journey.line.right."+taskName);
        }
        else
        {    
             E("journey-text-middle").setAttribute('width' ,350) ;
        }
		
		var numThree = (E("sub-header3").clientHeight/2) - 13;
        E("three").setAttribute("style", "padding-top:"+numThree+"px;");
    },
close : function(selectDevice)
    {
        gApplication.deviceManager.removeObserver(observer);
        gApplication.deviceManager.resumeDeviceSelection(selectDevice);
        var result;
        if (selectDevice)
            result = (gApplication.deviceManager.activeDevice == selectDevice);
        else
            result = (gApplication.deviceManager.activeDevice != null);
        ttDialog.prototype.close.call(this, result);
    },
 
    __end : null
}
extend(DeviceRequiredDialog, ttDialog);
var dialog = new DeviceRequiredDialog();
function setSpecificDevice(serial, deviceCode, modelName)
{
    E("dev-model").value = modelName;
    E("dev-serial").value = serial;
    E("dev-devicecode").value = deviceCode;
    E("specificDeviceBox").hidden = false;
    gDeviceCode = deviceCode;
    gSerial = serial;
    if (gDeviceCode || gSerial)
    {
        gApplication.deviceManager.pauseDeviceSelection();
    }
}
 
function deviceChanged()
{
    if (gSerial || gDeviceCode)
    {
        var devs = gApplication.deviceManager.getAllDevices();
        for (var i = 0; i < devs.length; i++)
        {
            var dev = devs[i];
            if (gDeviceCode && dev.deviceCode == gDeviceCode ||
                gSerial && dev.serial == gSerial)
            {
                dialog.close(dev);
                return;
            }
        }
    }
    else
    {
        if (gApplication.deviceManager.activeDevice)
        {
            dialog.close(null);
            return;
        }
    }
}