/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function Dialogs()
{
    this._windowsOpen = new Map();
}
Dialogs.prototype =
{
    kDeviceRequiredPage : "chrome://tthome/content/ui/dialogs/device/deviceRequiredPage.xul",

    _windowsOpen : null,
openDialog : function(url, params, loadCallback, unloadCallback, allowDupe, parentWindow)
    {
return this.openDialogAsWindow(url, params, loadCallback, unloadCallback, allowDupe, parentWindow);
    },
openDialogAsWindow : function(url, params, loadCallback, unloadCallback, allowDupe, parentWindow)
    {
        return openDialogAsWindow(url, params, loadCallback, unloadCallback, allowDupe, parentWindow);
    },
openDialogAsPage : function(url, params, loadCallback, unloadCallback, allowDupe)
    {
        var starttime = new Date();
        var deck = E("main-deck");
        if (!allowDupe)
        {
            var layers = deck.layers;
            for (var i = 0; i < layers.length; i++)
            {
                if (layers[i].getAttribute("src") == url)
                {
                    deck.selectedIndex = i;
                    return deck.selectedItem.contentWindow;
                }
            }
        }

        var newFrame = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "iframe");
        newFrame.style.MozBinding = "url(chrome://global/content/bindings/general.xml#iframe)";

        newFrame.setAttribute("src", url);
        deck.addLayer(newFrame);
        var newWindow = newFrame.contentWindow;
        newWindow._frame = newFrame;
        var handle = { _window : newWindow };

        var loadFunc = function()
        {
try {
                newWindow.dialog.setupPage(params, loadCallback);
            } catch (e if e instanceof Error) {
                let ex = { __proto__: e };
                ex.toString = function()
                {
                    return this.__proto__.toString() +
                        "\n|dialog| object not found. Check your dialog JavaScript for syntax errors and whether it is included/loaded, " +
                        "or if there is a problem with the DTD file." +
                        "\nTrying to open page dialog \"" + url + "\".";
                };
                error(ex);
            } catch (e) {
                error(e);
            }

            if (unloadCallback)
            {
                var unloadFunc = function()
                {
                    try {
                        unloadCallback(newFrame.result);
                    } catch (e) {
                        error(e);
                    }
                }
                newWindow.addEventListener("unload", unloadFunc, false);
            }
        }
        newWindow.addEventListener("load", loadFunc, false);
        return handle;
    },
_closeDialogAsPage : function(win, result)
    {
        var frame = win._frame;
        frame.result = result;
        var deck = E("main-deck");
        var curIndex = deck.selectedIndex;
        var newIndex = curIndex - 1;
        deck.removeLayer(frame, newIndex);
    },
closeDialog : function(handle)
    {
        var win = handle._window;
assert(typeof win.dialog == "object" && typeof win.dialog.cancel == "function",
"dialog needs to be opened by the Dialogs.openDialog*() functions");
        if (!win.dialog.closed)
            win.dialog.cancel();
    },
_isOpen : function(url)
    {
        if (this._windowsOpen.getValue(url))
          return true;
        var deck = E("main-deck");
        var layers = deck.layers;
        for (var i = 0; i < layers.length; i++)
        {
            if (layers[i].getAttribute("src") == url)
                return true;
        }
        return false;
    },

    __end : null
};
