/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/



var deviceObserver;

function LinkDeviceDialog()
{
    ttDialog.call(this, "footer");
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/dialogs/login/linkDevice.properties");
    deviceObserver =
    {
changed: function(deviceChanged, locationChanged)
        {
            if (!deviceChanged)
            return;

            this._stringBundle = getStringBundle("chrome://tthome/locale/ui/dialogs/login/linkDevice.properties");
            var dev = gApplication.deviceManager.activeDevice;

            if (dev)
            {
                if(deviceSupportsCapabilitySet(dev, "NotAutomotiveEmbedded"))
				{
                    if(dev.isUsbDevice)
					{
						E('deviceImg').className = "connectedUSBDeviceImg";
					}
					else
					{
						E('deviceImg').className = "connectedDeviceImg";
					}
				}
				else
                    E('deviceImg').className = "connectedSDcardImg";

                E("model_name").textContent = dev.model.modelName;
                E("linkDeviceHeader").textContent = this._stringBundle.GetStringFromName("connect.device.header2");
                E("footer").getRightButton().setAttribute('disabled','false');
                dialog.networkCall(rpc.call("account", "getDevice",
                    null,
                    null, RPC.METHOD_GET, function(result)
                    {
                        if (result.@serial.toString())
                        {
                            dialog.close(true);
                        }
                    },
                null));
                
            }
            else
            {
                E('deviceImg').className = "noDeviceImg";
                E("model_name").textContent = this._stringBundle.GetStringFromName("connect.device.label");;
                E("linkDeviceHeader").textContent = this._stringBundle.GetStringFromName("connect.device.header");
                E("footer").getRightButton().setAttribute('disabled','true');
            }

        }
    }
}
LinkDeviceDialog.prototype =
{
    _cur : null,
    _accountModelName : null,
    _accountSerial : null,
    _accountDeviceCode : null,
    _matchingDevice : null,
    _stringBundle : null,
    __accountUserName : null,
onLoad: function(params)
    {
        this._cur = params.currentDevice;
        this._accountModelName = params.accountModelName;
        this._accountSerial = params.accountSerial;
        this._accountDeviceCode = params.accountDeviceCode;
        this._accountUserName = params.accountUserName;

        E("footer").getLeftButton().setAttribute('hidden','true');
        E("footer").getRightButton().focus();

        E("header").setAttribute("title", this._stringBundle.GetStringFromName("link.device.title"));
        E("user_email").textContent = params.accountUserName;

        this.networkCall(rpc.call("account", "getAccountDetails",
            null,
            null, RPC.METHOD_GET, function(result)
            {
                if(result.gender == 'f')
                    E("gender_img").className = "femaleImg";
                else if(result.gender == 'm')
                    E("gender_img").className = "maleImg";
                else
                    E("gender_img").className = "neutralImg";
            },
            null));

        deviceObserver.changed(true, false);
        gApplication.deviceManager.addObserver(deviceObserver);
    },
goLoginPage : function()
    {
        if(!this.close(false))
        {
            var gMainWindow = top.gMainWindow;
            runAsyncDelayed(function()
            {
                gMainWindow.dialogs.openDialog(
                    "chrome://tthome/content/ui/dialogs/taskDialog/taskDialog.xul", {
                        url: "chrome://tthome/content/ui/task/login/login.xul",
                        taskParams: { loginOptional: false }
                    });
            }, 1000);
        }
    },
doOK : function()
    {
        E("footer").getRightButton().setAttribute('hidden','true');
        E("center-box").innerHTML = "<image src='skin:///images/preloader.gif'/>";
        E("linkDeviceHeader").textContent = this._stringBundle.GetStringFromName("linking.device.header");
        E("linkDeviceContent").textContent = this._stringBundle.GetStringFromName("linking.device.content");
        E("change").className = "noDisplay";
        gApplication._loginDeviceRel.setDeviceInAccount(gApplication.deviceManager.activeDevice, makeCallback(this, function(){this.deviceLinked()}), function(e)
            {
                error(e);
            });
    },
deviceLinked : function()
    {
        E("linkDeviceHeader").textContent = this._stringBundle.GetStringFromName("linked.device.header");
        E("linkDeviceContent").textContent = this._stringBundle.GetStringFromName("linked.device.content");
        E("center-box").innerHTML = "<label id='ampersand' value='&amp;'/> ";
        E("footer").getRightButton().label = this._stringBundle.GetStringFromName("menuFileExit.label");
        E("footer").setAttribute("onrightcommand","dialog.cancel()");
        E("footer").getRightButton().setAttribute('hidden','false');
        E("change").className = "noDisplay";
        E("header").setAttribute("title", this._stringBundle.GetStringFromName("linked.device.header"));
    },
callUnload : function()
    {
        gApplication.deviceManager.removeObserver(deviceObserver);
    },

    __end : null
}

extend(LinkDeviceDialog, ttDialog);
var dialog = new LinkDeviceDialog();