/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function LoginDeviceMismatchDialog()
{
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/dialogs/login/loginDeviceMismatch.properties");
    ttDialog.call(this, "footer");
}
LoginDeviceMismatchDialog.prototype =
{
    _cur : null,
    _accountModelName : null,
    _accountSerial : null,
    _accountDeviceCode : null,
    _matchingDevice : null,
    _stringBundle : null,

    onLoad : function(params)
    {
        this._cur = params.currentDevice;
        this._accountModelName = params.accountModelName;
        this._accountSerial = params.accountSerial;
        this._accountDeviceCode = params.accountDeviceCode;
        this._accountUserName = params.accountUserName;

        E("connected-model").value = this._cur.model.modelName;
        E("connected-serial").value = this._cur.serial;
        E("account-model").value = this._accountModelName;
        E("account-serial").value = this._accountSerial;
        E("account-user").value = this._accountUserName;
        E("changeDevice-descr").textContent = this._stringBundle.formatStringFromName("changeDeviceDescr",[params.accountUserName], 1);
        E("changeActiveDevice-descr").textContent = this._stringBundle.formatStringFromName("changeActiveDeviceDescr",[params.accountUserName], 1);
        E("changeDeviceInAccountDescr").textContent = this._stringBundle.formatStringFromName("changeDeviceInAccountDescr",[params.accountUserName], 1);

        var allDevices = gApplication.deviceManager.getAllDevices();
        for (var i = 0; i < allDevices.length; i++)
        {
            var dev = allDevices[i];
            if (dev.serial == params.accountSerial ||
                dev.deviceCode == params.accountDeviceCode)
            {
                this._matchingDevice = dev;
                E("changeActiveDevice").hidden = false;
                E("changeActiveDevice-descr").hidden = false;
                E("changeDevice-descr").hidden = true;
                E("changeDevice").hidden = true;{}
break;
            }
        }
    },

    doOK : function()
    {
        var me = this;
        if (E("changeDevice").selected)
        {
            top.gMainWindow.dialogs.openDialog(
                    top.gMainWindow.dialogs.kDeviceRequiredPage,
                    {
                        specificDeviceSerial : this._accountSerial,
                        specificDeviceDeviceCode : this._accountDeviceCode,
                        specificDeviceModelName : this._accountModelName
                    },
                    null,
                    function(success)
                    {
if (success)
                        {
                            me.close(true);
                        }
                    }, false, top);
        }
        else if (E("changeActiveDevice").selected)
        {
            gApplication.deviceManager.selectDevice(this._matchingDevice);
            var dev = gApplication.deviceManager.activeDevice;
            if (dev && (dev.serial == this._accountSerial ||
                        dev.deviceCode == this._accountDeviceCode))
            {
                this.close(true);
            }
        }
        else if (E("changeLogin").selected)
        {
            this.close(false);
            var gMainWindow = top.gMainWindow;
            runAsync(function()
            {
                gMainWindow.dialogs.openDialog(
                    "chrome://tthome/content/ui/dialogs/taskDialog/taskDialog.xul", {
                        url: "chrome://tthome/content/ui/task/login/login.xul",
                        taskParams: { loginOptional: false }
                    });
            });
        }
        else if (E("changeDeviceInAccount").selected)
        {
            E("footer").getRightButton().disabled = true;

            if (this.confirmDeviceRelink())
            {
                this.networkCall(gApplication._loginDeviceRel.setDeviceInAccount(this._cur,
                function()
                {
                    me.close(true);
                },
                function(e)
                {
                    E("footer").getRightButton().disabled = false;
                    error(e);
                }));
            }
            else
            {
                E("footer").getRightButton().disabled = false;
            }
        }
        else if (E("ignore").selected)
        {
            this.close(true);
        }
        else
            throw new NotReached();
    },

    confirmDeviceRelink : function() {
        var result = null;
        new MessageService(window).confirm(
            this._stringBundle.GetStringFromName("changeDeviceInAccountPromtTitle"),
            this._stringBundle.GetStringFromName("changeDeviceInAccountPromtMessage"),
            this._stringBundle.GetStringFromName("changeDeviceInAccountPromtDeny"),
            this._stringBundle.GetStringFromName("changeDeviceInAccountPromtAccept"),
            function()
            {
                result = true;
            },
            function()
            {
                result = false;
            });
        return result;
    },

    __end : null
}
extend(LoginDeviceMismatchDialog, ttDialog);
var dialog = new LoginDeviceMismatchDialog();
