/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


var gArgs;
var gDefaultLocaleWorld = "en-GB";
var gDefaultLocaleAmericaCanada = "en-US";
var gDefaultLocaleMexico = "es-MX";
var gDefaultLocaleInternationalSpanish = "es";
var gAppLocale;
var gNoLicensePage = "chrome://tthome/locale/pages/noLicense.xhtml"

function onLoad()
{
    gArgs = window.arguments[0];

    gAppLocale = gApplication.settings.uiLocale;
    centerWindow();

    toggleButtons(false);
}

function toggleButtons(on)
{
    E("eula-accept-button").disabled = !on;
    E("eula-print-button").disabled = !on;
}
function changeLicense()
{
    var code = E("listbox-country").selectedItem.value;
    if (code && code != "XXX")
    {
loadLicense(code);
    }
    else
    {
        toggleButtons(false);
    }
}

function getLicensePath(localeCode)
{
    var licLeaf = "EULA-"+localeCode+".html";
    var licPath = createLicenseUrl(licLeaf);
    prefService().setCharPref("tomtom.license.accepted", localeCode);
    return licPath;
}

function createLicenseUrl(licLeaf)
{
    var licPath = gApplication.settings.installDir;
    licPath.append("license");
    licPath.append(licLeaf);
    var licFile;
    if (licPath.exists())
    {
        licFile = licPath;
    }
    else
    {
        var noneFile = licPath.parent;
        noneFile.append("EULA-"+gDefaultLocaleWorld+".html");
        if (noneFile.exists())
        {
            licFile = noneFile;
        }
        else
        {
            toggleButtons(false);
            return gNoLicensePage;
        }
    }
try {
        toggleButtons(true);
    }
    catch(e) {}
    return getIOService().newFileURI(licPath).spec;

}

function getLocaleCode(code)
{
    if (gAppLocale)
    {
        if (code == "US" || code =="CA")
        {
var locale = gAppLocale.substr(0, 2);
            if (locale == "fr" || locale == "es")
            {
                return locale + "-US";
            }
            return gDefaultLocaleAmericaCanada;
        }
        else if (code == "MX")
        {
return gDefaultLocaleMexico;
        }
        else
        {
            var locale = gAppLocale.substr(0, 2);
            if (locale == "es" && code != "ES")
            {
                return gDefaultLocaleInternationalSpanish;
            }

            if (gAppLocale == "en-US")
                return gDefaultLocaleWorld;
            return gAppLocale;
        }
    }
    return gDefaultLocaleWorld;
}

function loadLicense(code)
{
    var localeCode = getLocaleCode(code);
    var licFile = getLicensePath(localeCode);
    E("eula-content").setAttribute("src", licFile);
}
function getInstallDirectory()
{
  var directoryService = Cc["@mozilla.org/file/directory_service;1"]
                         .getService(CI.nsIProperties);
  var xulDir = directoryService.get("XCurProcD", CI.nsIFile);
  var installDir = xulDir.parent;
  return installDir;
}

function print()
{
    var printService = Cc["@mozilla.org/gfx/printsettings-service;1"].
                                getService(CI.nsIPrintSettingsService);

    var printSettings = printService.globalPrintSettings;
    printService.initPrintSettingsFromPrinter(printSettings.printerName, printSettings);
    printSettings.printSilent   = false;
    printSettings.showPrintProgress = false;
    printSettings.headerStrLeft = E("eula-content").contentWindow.title;
    printSettings.headerStrCenter = "";
    printSettings.headerStrRight = "";
    printSettings.footerStrLeft = "&PT";
    printSettings.footerStrCenter = "";
    printSettings.footerStrRight = "&D";

    try {
      var ifreq = E("eula-content").contentWindow.QueryInterface(CI.nsIInterfaceRequestor);
      var webBrowserPrint = ifreq.getInterface(CI.nsIWebBrowserPrint);
      webBrowserPrint.print(printSettings, null);
    }
    catch(e) {  }
}

function decline()
{
    gArgs['eulaaccepted'] = false;
    window.close();
}

function accept()
{
    gArgs['eulaaccepted'] = true;
    try {
        var newCountry = E("listbox-country").value;
        gApplication.settings.country = newCountry;
    }
    catch(e) {
        alert(e);
    }
    window.close();
}
