/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


const MainWindowStatusBar =
{
showProgress: function (aName)
    {
        return new StatusBarProgressMeter(E("statusbar-progressmeter"),
                                          E("statusbar-progress-label"),
                                          this,
                                          aName);
    },
setTextVisible: function(visible)
    {
        E("by-text").hidden = !visible;
    },
setProgressVisible: function(visible)
    {
        E("statusbar-progress-box").hidden = !visible;
        E("statusbar-progress-box-separator").hidden = !visible;
    },
setLockVisible: function(visible)
    {
        E("statusbar-lockicon").hidden = !visible;
        E("statusbar-lockicon-separator").hidden = !visible;
    },
showSecureLockHelp: function()
    {
        gMainWindow.goHelp("payment_security");
    },

    deviceStateDisplay:
    {
        _state : null,
_ignoreDeviceChanges : null,

        init: function()
        {
            E("device-state-box-icon").addEventListener("click", makeCallback(this, function()
                {
                    if (this.state == "connected")
                        gMainWindow.goDeviceDisconnect();
                }), false);
            gApplication.deviceManager.addObserver(this);
            gApplication.deviceManager.addDeviceAccessObserver(this);
            this.state = "disconnected";
        },

        changed: function()
        {
            if (!this._ignoreDeviceChanges)
            {
                let activeDevice = gApplication.deviceManager.activeDevice;

                if (activeDevice)
                    this.state = activeDevice.isLocked ? "busy" : "connected";
                else
                    this.state = "disconnected";
            }
        },

        deviceAccessed: function(isLocked)
        {
            if (!this._ignoreDeviceChanges)
            {
                var newState = isLocked ? "busy" : "connected";

                if (this._state != newState)
                    this.state = newState;
            }
        },

        get state()
        {
            return this._state;
        },

        set state(state)
        {
            var activeDevice = gApplication.deviceManager.activeDevice;
            this._state = state;
            E("device-state-box-icon").tooltipText = gMainWindow.mainBundle.getString("statebox.tooltip." + state);
            E("device-state-box-icon").className = state;
            E("device-state-box-label").value = activeDevice ? activeDevice.model.modelName : gMainWindow.mainBundle.getString("statebox.nodevice");
        },

        overrideDeviceBusyStatus: function(value)
        {
            if (value)
            {
                this._ignoreDeviceChanges = true;
                this.state = "busy";
            }
            else
            {
                this._ignoreDeviceChanges = false;
                this.state = "connected";
                this.changed();
            }
        },

        teardown: function()
        {
            gApplication.deviceManager.removeObserver(this);
            gApplication.deviceManager.removeDeviceAccessObserver(this);
            this.state = "disconnected";
        }
    }
};
function StatusBarProgressMeter(aProgressMeterElem, aLabelElem, aStatusBar, aLabelText)
{
    this._mProgressMeterElem = aProgressMeterElem;
    this._mLabelElem         = aLabelElem;
    this._mStatusBar         = aStatusBar;

    this._mLabelElem.value = aLabelText;

    aStatusBar.setProgressVisible(true);
}

StatusBarProgressMeter.prototype =
{
    _mProgressMeterElem: null,
    _mLabelElem        : null,
progress: function (aPercent)
    {
        this._mProgressMeterElem.value = aPercent;
        this._mProgressMeterElem.mode  = "determined";
    },

    setDetermined: function (aDetermined)
    {
        this._mProgressMeterElem.mode = (aDetermined ? "determined" : "undetermined");
    },
done: function()
    {
        this._mStatusBar.setProgressVisible(false);
        this._mLabelElem.value        = "";
        this._mProgressMeterElem.mode = "undetermined"
    }
};
