/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function RemoteContentPage()
{
    ttPage.apply(this, arguments);
    this.stringBundle = getStringBundle("chrome://tthome/locale/ui/remoteContentPage/remoteContentPage.properties");
}

RemoteContentPage.prototype =
{
_result: null,
_defaultTitle: null,
_defaultSubtitle: null,
_defaultContinueLabel: null,
_endURL: null,
_progressListener: null,
insecureConnectionsAllowed: false,
_securityUICallback: null,
stringBundle: null,
_securityPrefs: {
        "security.warn_entering_weak": null,
        "security.warn_submit_insecure": null,
        "security.warn_viewing_mixed": null
    },
_ignoreBrowserHistory : null,
inputOnLoad: function(params)
    {
        assert(params && typeof params.title == "string", "Title parameter is mandatory");
        assert(params && typeof params.subtitle == "string", "Subtitle parameter is mandatory");

        this._ignoreBrowserHistory = params.ignoreBrowserHistory;
        this._defaultTitle = params.title;
        this._defaultSubtitle = params.subtitle;
        if ("continueLabel" in params)
            this._defaultContinueLabel = params.continueLabel;
        this.remotePageLoaded();
        E("loadingBox").hidden = false;

        window.addEventListener("unload", makeCallback(this, this.unloadWindow), false)

        var prefs = Cc["@mozilla.org/preferences-service;1"]
            .getService(CI.nsIPrefBranch);
        for (let pref in this._securityPrefs)
        {
            if (prefs.prefHasUserValue(pref))
                this._securityPrefs[pref] = prefs.getBoolPref(pref);
        }
    },
inputDone: function(params)
    {
        assert(params && typeof params.startURL == "string", "Start URL is mandatory");

        var browser = E("browser");
        this._progressListener = new ProgressListener(browser, params.securityExceptionResolver);
        browser.addEventListener("TTUpdateButton", makeCallback(this, this.updateContinueButton), false, true);
        browser.addEventListener("TTHelpLink", makeCallback(this, this.addLinkTo), false, true);
        
        function getInputStream(string)
        {
            var stream = Cc["@mozilla.org/io/string-input-stream;1"].createInstance(CI.nsIStringInputStream);
            stream.setData(string, string.length);
            return stream;
        }

        var headers = null;
        var headersList = [];
        if (params.body)
            headersList.push("Content-Length: " + params.body.length);
        if (params.headers)
        {
            for (let [name, value] in Iterator(params.headers))
            {
                value = encodeURIComponent(value).replace(/%20/g, " ").replace(/%2F/gi, "/");
                headersList.push(name + ": " + value);
            }
        }
        if (headersList.length)
            headers = getInputStream(headersList.join("\r\n"));

        var body = null;
        if (params.body)
            body = getInputStream("\r\n" + params.body);

        if ("endURL" in params)
            this._endURL = params.endURL;

        if ("insecureConnectionsAllowed" in params)
            this.insecureConnectionsAllowed = params.insecureConnectionsAllowed;

        if (!this.insecureConnectionsAllowed)
        {
            var prefs = Cc["@mozilla.org/preferences-service;1"]
                .getService(CI.nsIPrefBranch);
            for (let pref in this._securityPrefs)
            {
                prefs.setBoolPref(pref, false);
            }
        }

        if ("securityUICallback" in params)
            this._securityUICallback = params.securityUICallback;

        if (this._securityUICallback)
            this._securityUICallback(true);

        try
        {
            browser.webNavigation.loadURI(params.startURL,
                         CI.nsIWebNavigation.LOAD_FLAGS_NONE,
                         null,
                         body,
                         headers);
        }
        catch (e)
        {
            errorAbortTask(e);
        }
    },
result: function()
    {
        return this._result;
    },
remotePageLoading: function()
    {
        E("loadingBox").hidden = false;
    },
remotePageLoaded: function()
    {
        E("loadingBox").hidden = true;

        var doc = E("browser").contentDocument;
        var ucResultElements = doc.documentElement.getElementsByTagNameNS(
                                "http://home.tomtom.com/remote/v1", "result");

        if (ucResultElements.length > 0)
        {
            this._result = makeSafe.string(ucResultElements[0].textContent).trim();
            this._wizard().goForward();
            return;
        }

        if (this._endURL && E("browser").contentWindow.location.href.indexOf(this._endURL) == 0)
        {
            this._wizard().goForward();
            return;
        }

        var ucTitle = doc.documentElement.getAttribute("title");
        if (ucTitle)
            this.title = makeSafe.string(ucTitle);
        else
            this.title = this._defaultTitle;

        var ucSubtitle = doc.documentElement.getAttribute("subtitle");
        if (ucSubtitle)
            this.subtitle = makeSafe.string(ucSubtitle);
        else
            this.subtitle = this._defaultSubtitle;

        this.updateContinueButton();
    },
    addLinkTo : function()
    {
        var addLink = E("browser").contentDocument.getElementById("code-text");
        if (addLink)
	    top.gMainWindow.goHelp("activate_my_promotion_code");
    },
updateContinueButton: function()
    {
        var ucContinueButton = E("browser").contentDocument.getElementById("TTButton_continue");
        var button = this._wizard()._wizfooter.getRightButton();

        var label = this._defaultContinueLabel;
        if (ucContinueButton)
            label = makeSafe.string(ucContinueButton.textContent).trim();

        if (label)
        {
            button.label = label;
            var canContinue = this._result;
            if (ucContinueButton)
                canContinue = !ucContinueButton.hasAttribute("disabled");
            this.allowContinue(canContinue);
        }
        else
            button.notvisible = true;
    },
goBack: function()
    {
        if (this._ignoreBrowserHistory)
            this._wizard().goBack();
        else
        {
            var browser = E("browser");
            if (browser.canGoBack)
            {
                browser.goBack();
            }
            else
            {
                this._wizard().goBack();
            }
        }
    },
goNext: function()
    {
        var doc = E("browser").contentDocument;
        var ucContinueButton = doc.getElementById("TTButton_continue");
        if (ucContinueButton)
        {
            ucContinueButton.click();
        }
        else
        {
            this._wizard().goForward();
        }
    },
unloadWindow: function()
    {
        var prefs = Cc["@mozilla.org/preferences-service;1"]
            .getService(CI.nsIPrefBranch);
        for (let pref in this._securityPrefs)
        {
            try {
                if (this._securityPrefs[pref])
                    prefs.setBoolPref(pref, this._securityPrefs[pref]);
                else
                    prefs.clearUserPref(pref);
            } catch (e) {}
        }

        if (this._securityUICallback)
            this._securityUICallback(false);
    }
}
extend(RemoteContentPage, ttPage);
window.page = new RemoteContentPage();
function ProgressListener(browser, securityExceptionResolver)
{
    this._browser = browser;
    this._securityExceptionResolver = securityExceptionResolver;
    browser.webProgress.addProgressListener(this,
        CI.nsIWebProgress.NOTIFY_STATE_WINDOW |
        CI.nsIWebProgress.NOTIFY_SECURITY);
}
ProgressListener.prototype =
{
_browser: null,
_securityState: null,
_securityExceptionResolver: null,
onSecurityChange: function (wp, req, state)
    {
        if (req instanceof CI.imgIRequest)
            return;

        if ((state & CI.nsIWebProgressListener.STATE_IS_SECURE) == 0)
        {
            this._securityState = { state: state, name: req.name };
        }
    },
onStateChange: function (wp, req, state, status)
    {
        if (!req ||
            wp.DOMWindow != this._browser.contentWindow)
        {
            return;
        }

        if (state & CI.nsIWebProgressListener.STATE_START)
        {
            page.remotePageLoading();
            return;
        }

        if (state & CI.nsIWebProgressListener.STATE_STOP)
        {
            try
            {
                var error = null;
                var securityError = null;

                if (req instanceof CI.nsIChannel)
                {
                    if (!req.URI.schemeIs("chrome"))
                    {
                        if (!page.insecureConnectionsAllowed && this._securityState)
                        {
                            let errorID = null;
                            if (this._securityExceptionResolver)
                            {
                                errorID = this._securityExceptionResolver();
                            }
                            else
                            {
                                errorID = "RemoteContentPage/OnStateChange/ExpectedSecureConnection";
                            }

                            securityError = new ServerError(null, status, req.URI.spec, null, null, errorID);
                            if (req.URI.spec != this._securityState.name)
                            {
                                let subError = new ServerError(null, status, this._securityState.name, null, null, errorID);
                                securityError.inner = subError;
                            }
                        }
                        if (status != Components.results.NS_ERROR_DOCUMENT_NOT_CACHED)
                            error = NetUtil.isRequestSuccess(req, status);

                        if (error && securityError)
                        {
                            error.message = errorToText(securityError);
                            error.inner = securityError;
                        }
                        else if (!error && securityError)
                        {
                            error = securityError;
                        }
                    }
                }
                if (status == Components.results.NS_BINDING_ABORTED)
                {
                    error = null;
                }

                if (error)
                    throw error;

                page.remotePageLoaded();
            }
            catch (e)
            {
                errorAbortTask(e);
            }
        }
    },
    onProgressChange: function (wp, req, cur, max, curtotal, maxtotal) {},
    onLocationChange: function (wp, req, loc) {},
    onStatusChange: function (wp, req, status, message) {},
QueryInterface: function(aIID)
    {
        if (aIID.equals(CI.nsIWebProgressListener) ||
            aIID.equals(CI.nsISupportsWeakReference) ||
            aIID.equals(CI.nsISupports)) {
            return this;
        }
        throw Components.results.NS_NOINTERFACE;
    }
}
