/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function BillingAddress()
{
    ttPage.apply(this, arguments);
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/checkout/billingAddress.properties");
}

BillingAddress.prototype = 
{
    _validFields : [],
    _loadFinished : false,
    _stringBundle : null,
    companyVal : null,
    vatNumVal : null,

    inputOnLoad : function(args)
    {
        var items = {
            firstName: E("firstname"),
            lastName: E("lastname"),
            gender: E("gender"),
            street: E("street"),
            zipCode: E("zipCode"),
            city: E("city"),
            state: E("state"),
            stateMandatory: E("state-mandatory"),
            country: E("country"),
			residenceCountryList: E("residenceCountryList"),
			selfCertificationSection: E("selfCertificationSection"),
            company: E("company"),
            vatCode: E("vatcode")
        };
        
        this._items = items;
		
		let footer = this._wizard()._wizfooter;
		footer.getRightButton().label = this._stringBundle.GetStringFromName("RightButton.text");
		
        this._validFields[items.firstName.id] = false;
        this._validFields[items.lastName.id] = false;
        this._validFields[items.street.id] = false;
        this._validFields[items.zipCode.id] = false;
        this._validFields[items.city.id] = false;
        this._validFields[items.state.id] = false;
        this._validFields[items.country.id] = false;
		this._validFields[items.residenceCountryList.id] = false;
		this._validFields[items.selfCertificationSection.id] = false;
        
        if(args.country == 'US' || args.country == 'CA')
        {
            E("stateRow").hidden = false;
            E("companyPaymentCheckbox").hidden = true;
        }

        if (args.firstname != "")
        {
            items.firstName.value = args.firstname;
            this._validFields[items.firstName.id] = true;
        }
        else
        {
            items.firstName.value = this._stringBundle.GetStringFromName("firstname.label");
            this._setActive(items.firstName, false);
        }

        if (args.lastname != "")
        {
            items.lastName.value = args.lastname;
            this._validFields[items.lastName.id] = true;
        }
        else
        {
            items.lastName.value = this._stringBundle.GetStringFromName("lastname.label");
            this._setActive(items.lastName, false);
        }

        if (args.gender != "")
        {
            items.gender.value = args.gender;
        }

        if (args.street != "")
        {
            items.street.value = args.street;
            this._validFields[items.street.id] = true;
        }
        else
        {
            items.street.value = this._stringBundle.GetStringFromName("street.label");
            this._setActive(items.street, false);
        }

        if (args.zipCode != "")
        {
            items.zipCode.value = args.zipCode;
            this._validFields[items.zipCode.id] = true;
        }
        else
        {
            items.zipCode.value = this._stringBundle.GetStringFromName("zipCode.label");
            this._setActive(items.zipCode, false);
        }

        if (args.city != "")
        {
            items.city.value = args.city;
            this._validFields[items.city.id] = true;
        }
        else
        {
            items.city.value = this._stringBundle.GetStringFromName("city.label");
            this._setActive(items.city, false);
        }

        if (args.state != "")
        {
            items.state.value = args.state;
        }
        this._validFields[items.state.id] = (args.state != "" || (args.country != "US" && args.country != "CA"));

        if (args.country != "")
        {
            items.country.value = args.country;
            this._validFields[items.country.id] = true;
            if (items.country.value == "US" || items.country.value == "CA")
            {
                items.state.removeAttribute("disabled");
                items.stateMandatory.hidden = false;
				
				E("vatcountryresidence").hidden = true;
				this._validFields[items.residenceCountryList.id] = true;
				this._validFields[items.selfCertificationSection.id] = true;
            }
			else
			{
				items.residenceCountryList._insertItemAtBegin(items.country.label, items.country.value);
			}
        }
        
        if (args.company == "")
        {
            items.company.value = this._stringBundle.GetStringFromName("company.name");
            this._setActive(items.company, false);
        }
        
        if (args.vatnumber == "")
        {
            items.vatCode.value = this._stringBundle.GetStringFromName("vat.number");
            this._setActive(items.vatCode, false);
        }
        
        if (args.company != "" || args.vatnumber != "")
        {
            items.company.value = args.company;
            this.companyVal = args.company;
            this._validFields[items.company.id] = true;
            
            items.vatCode.value = args.vatnumber;
            this.vatNumVal = args.vatnumber;
            this._validFields[items.vatCode.id] = true;
            
            E("companyPaymentCheckbox").checked = true;
        
            E("companyPayment").hidden = false;
            this.checkValue();
        }

        this._loadFinished = true;

        this.taskCanContinue();
    },
    
    result : function()
    {
        var items = this._items;
        var companyName = "";
        var vatCode = "";

        if(items.company.value.trim() == "" || items.company.value == this._stringBundle.GetStringFromName("company.name")){
            companyName = "";
        }
        else
        {
            companyName = items.company.value.trim();
        }

        if(items.vatCode.value.trim() == "" || items.vatCode.value == this._stringBundle.GetStringFromName("vat.number"))
        {
            vatCode = "";
        }
        else
        {
            vatCode = items.vatCode.value.trim();
        }
        return {
                firstname : items.firstName.value.trim(),
                lastname : items.lastName.value.trim(),
                gender : items.gender.value,
                street : items.street.value.trim(),
                zipCode : items.zipCode.value.trim(),
                city : items.city.value.trim(),
                state : items.state.value == "XXX" ? "" : items.state.value,
                country : items.country.value,
				vatcountryresidence : items.residenceCountryList.value == "XXX" ? "" : items.residenceCountryList.value,
				vatcountryselfcertificated : E("self-certify-country").value,
                company : companyName,
                vatnumber : vatCode
                };
    },
    checkStringMediumNotEmpty : function(aTextbox)
    {
        try
        {
            checkStringNotEmpty(aTextbox.value.trim());
            checkStringMediumSyntax(aTextbox.value.trim());
        }
        catch (e){
            this._markInvalid(aTextbox, errorToText(e));
            return;
        }
        this._markValid(aTextbox);
    },

    checkStringLongNotEmpty : function(aTextbox)
    {
        try
        {
            checkStringNotEmpty(aTextbox.value.trim());
            checkStringLongSyntax(aTextbox.value.trim());
        }
        catch (e){
            this._markInvalid(aTextbox, errorToText(e));
            return;
        }
        this._markValid(aTextbox);
    },

    checkStringShortNotEmpty : function(aTextbox)
    {
        try
        {
            checkStringNotEmpty(aTextbox.value.trim());
            checkStringShortSyntax(aTextbox.value.trim());
            if(aTextbox.id == "zipCode")
            {
                aTextbox.value = aTextbox.value.toUpperCase();
            }
        }
        catch (e){
            this._markInvalid(aTextbox, errorToText(e));
            return;
        }
        this._markValid(aTextbox);
    },    
    
    checkStringValueNotEmpty : function(aTextbox)
    {
        try
        {
            checkStringNotEmpty(aTextbox.value.trim());
            if(aTextbox.id == "vatcode")
            {
                aTextbox.value = aTextbox.value.toUpperCase();
            }
        }
        catch (e){
            this._markInvalid(aTextbox, errorToText(e));
            return;
        }
        this._markValid(aTextbox);
    },

    validateState : function(aTTListBox)
    {
        if ((this._items.country.value != "US" && this._items.country.value != "CA") || (aTTListBox.value && aTTListBox.value != "XXX"))
            this._markValid(aTTListBox);
        else
            this._markInvalid(aTTListBox);
    },
	
	validateResidenceCountry : function(aTTListBox)
	{
		var defaultValue = "XXX";
        if (aTTListBox.value != defaultValue)
        {
			this._markValid(aTTListBox);
			if (aTTListBox.value == this._items.country.value)
			{
				this._markValid(this._items.selfCertificationSection);
				this._items.selfCertificationSection.hidden = true;
			}
            else
			{
				this._markInvalid(this._items.selfCertificationSection);
				E("self-certify-country")._clearMenuItems();
				var itemIndex_0 = aTTListBox._getItemAtIndex(0);
				var itemIndex_1 = aTTListBox._getItemAtIndex(1);
				var theCountryOfResidenceItem = aTTListBox.selectedItem;
				E("self-certify-country")._addMenuItem(itemIndex_0.label, itemIndex_0.value);
				E("self-certify-country")._addMenuItem(itemIndex_1.label, itemIndex_1.value);
				E("self-certify-country")._addMenuItem(theCountryOfResidenceItem.label, theCountryOfResidenceItem.value);
				E("self-certify-country").selectedIndex = 0;
				this._items.selfCertificationSection.hidden = false;
			}
        }
		else
		{
			this._markInvalid(aTTListBox);
			this._markInvalid(this._items.selfCertificationSection);
			this._items.selfCertificationSection.hidden = true;
		}
	},
	
	validateSelfCertifyCountry : function(aTTListBox)
	{
		var defaultValue = "XXX";
        if (aTTListBox.value != defaultValue)
        {
			this._markValid(this._items.selfCertificationSection);
        }
        else
        {
			this._markInvalid(this._items.selfCertificationSection);
        }
	},

    validateCountry : function(aTTListBox)
    {
        var items = this._items;
        var state = items.state;
        var stateMandatory = items.stateMandatory;
        var defaultValue = "XXX";
        if (aTTListBox.value == "US")
        {
            state.removeAttribute("disabled");
            stateMandatory.hidden = false;
            state.setAttribute("defaultItemName", this._stringBundle.GetStringFromName("select.state.label"));
            state.view = "us-states";
            state.value = defaultValue;
            E("valStateMsg").value = this._stringBundle.GetStringFromName("state.x.label");
this.validateState(state);
        } 
        else if (aTTListBox.value == "CA")
        {
            state.removeAttribute("disabled");
            stateMandatory.hidden = false;
            state.setAttribute("defaultItemName", this._stringBundle.GetStringFromName("select.province.label"));
            state.view = "ca-states";
            state.value = defaultValue;
            E("valStateMsg").value = this._stringBundle.GetStringFromName("province.x.label");
this.validateState(state);
        }
        else
        {
            state._clearMenuItems();
            state._addMenuItem(this._stringBundle.GetStringFromName("select.state.label"), "XXX");
            state.value = defaultValue;
            state.setAttribute("disabled", "true");
            stateMandatory.hidden = true;
            this._markValid(state);
        }
        if (aTTListBox.value != defaultValue)
        {
            this._markValid(aTTListBox);
            return;
        }
        this._markInvalid(aTTListBox);
    },

    taskCanContinue : function()
    {
        var allValid = true;

        for each (var valid in this._validFields)
        {
            if (!valid)
                allValid = false;
        }
        this.allowContinue(allValid);
    },

    _markInvalid: function(node, msg)
    {
        if (!this._loadFinished)
            return;

        this._validFields[node.id] = false;
        if (msg)
        {
            node.parentNode.lastChild.value = msg;
        }
        node.parentNode.setAttribute("invalid" , "true");
        this.taskCanContinue();
    },

    _markValid : function(node)
    {
        if (!this._loadFinished)
            return;

        this._validFields[node.id] = true;
        node.parentNode.removeAttribute("invalid");
        this.taskCanContinue();
    },
    
    togglePayAsCompany : function()
    {
        this.checkValue();
        var company = this._items.company;
        var vatcode = this._items.vatCode;

        if(E("companyPaymentCheckbox").checked)
        {
            E("companyPayment").hidden = true;
            company.value = null;
            vatcode.value = null;
            this._markValid(company);
            this._markValid(vatcode);
        }
        else
        {
            E("companyPayment").hidden = false;
            company.value = this.companyVal;
            vatcode.value = this.vatNumVal;
            this.checkValue();
        }
        this.taskCanContinue();
    },
    
    checkValue : function()
    {
        var company = this._items.company;
        var vatcode = this._items.vatCode;
        
        if (company.value == "")
        {
            company.value = this._stringBundle.GetStringFromName("company.name");
            this._setActive(company, false);
            this._validFields[company.id] = false;
        }else{
            this._validFields[company.id] = true;
            this._setActive(company, true);
        }
        
        if (vatcode.value == "")
        {
            vatcode.value = this._stringBundle.GetStringFromName("vat.number");
            this._setActive(vatcode, false);
            this._validFields[vatcode.id] = false;
        }else{
            this._validFields[vatcode.id] = true;
            this._setActive(vatcode, true);
        }
    },
checkField: function(id)
    {
        var elem = E(id);
        if(elem == null)
            return;

        var val = elem.value.trim();
        this._setActive(elem, true);

        if(val.length >0 && (val == this._stringBundle.GetStringFromName("firstname.label") ||
            val == this._stringBundle.GetStringFromName("lastname.label") ||
            val == this._stringBundle.GetStringFromName("street.label") ||
            val == this._stringBundle.GetStringFromName("zipCode.label") ||
            val == this._stringBundle.GetStringFromName("company.name") ||
            val == this._stringBundle.GetStringFromName("vat.number") ||
            val == this._stringBundle.GetStringFromName("city.label")))
            {
                elem.value = "";
            }
    },
setDefaultText: function(id)
    {
        var elem = E(id);
        if(elem == null)
            return;

       if((id == "firstname") && (elem.value.trim() == "" || (elem.value.trim() == this._stringBundle.GetStringFromName("firstname.label"))))
        {
            elem.value = "";
            this.checkStringMediumNotEmpty(elem);
            elem.value = this._stringBundle.GetStringFromName("firstname.label");
            this._setActive(elem, false);
        }
        if((id == "lastname") && (elem.value.trim() == "" || (elem.value.trim() == this._stringBundle.GetStringFromName("lastname.label"))))
        {
            elem.value = "";
            this.checkStringMediumNotEmpty(elem);
            elem.value = this._stringBundle.GetStringFromName("lastname.label");
            this._setActive(elem, false);
        }
        if((id == "street") && (elem.value.trim() == "" || (elem.value.trim() == this._stringBundle.GetStringFromName("street.label"))))
        {
            elem.value = "";
            this.checkStringLongNotEmpty(elem);
            elem.value = this._stringBundle.GetStringFromName("street.label");
            this._setActive(elem, false);
        }
        if((id == "zipCode") && (elem.value.trim() == "" || (elem.value.trim() == this._stringBundle.GetStringFromName("zipCode.label"))))
        {
            elem.value = "";
            this.checkStringShortNotEmpty(elem);
            elem.value = this._stringBundle.GetStringFromName("zipCode.label");
            this._setActive(elem, false);
        }
        if((id == "city") && (elem.value.trim() == "" || (elem.value.trim() == this._stringBundle.GetStringFromName("city.label"))))
        {
            elem.value = "";
            this.checkStringShortNotEmpty(elem);
            elem.value = this._stringBundle.GetStringFromName("city.label");
            this._setActive(elem, false);
        }
        if((id == "company") && (elem.value.trim() == "" || (elem.value.trim() == this._stringBundle.GetStringFromName("company.name"))))
        {
            elem.value = "";
            this.checkStringValueNotEmpty(elem);
            elem.value = this._stringBundle.GetStringFromName("company.name");
            this._setActive(elem, false);
        }
        if((id == "vatcode") && (elem.value.trim() == "" || (elem.value.trim() == this._stringBundle.GetStringFromName("vat.number"))))
        {
            elem.value = "";
            this.checkStringValueNotEmpty(elem);
            elem.value = this._stringBundle.GetStringFromName("vat.number");
            this._setActive(elem, false);
        }
    },
_setActive: function(node, value)
    {
        node.parentNode.setAttribute("active", value);
    },

    __end : null

}
extend(BillingAddress, ttPage);
window.page = new BillingAddress();
