/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function OrderConfirmation()
{
    ttPage.apply(this, arguments);
}
OrderConfirmation.prototype =
{
    _sb : null,
    _listbox : null,

    inputOnLoad : function(args)
    {
        this._sb = E("stringbundle");
        this._listbox = E("listbox");
        this._listbox.addObserver(this);
        E("orderID").textContent = args.orderID;
    },

    inputDone : function(args)
    {
        this._listbox.addItemList(args.itemlist);

        if (args.success)
        {
            E("success").hidden = false;
            E("success2").hidden = false;
        }
    },

    __end : null
}
extend(OrderConfirmation, ttPage);
window.page = new OrderConfirmation();

var htmlPage = null;
var constructPrintPage = function(orderID, items, totalPrice, sb)
{
    htmlPage = E("print-preview").contentDocument;
    htmlPage.getElementById("ordernumber").appendChild(
        htmlPage.createTextNode(sb.getFormattedString("ordernumber.label", [orderID]))
    );
    var orderContent = htmlPage.getElementById("order-content");
    for(var i = 0; items.lenght; i++)
    {
        orderContent.appendChild(createOrderRow(items[i]));
    }
    var priceRow = createPriceRow(totalPrice, sb);
    orderContent.appendChild(priceRow);
}

function createItemRow(item)
{
    var row = htmlPage.createElementNS("http://www.w3.org/1999/xhtml", "tr");
    var img = htmlPage.createElementNS("http://www.w3.org/1999/xhtml", "img");
    img.src = item.icon.url;
    var iconTD = createTD();
    iconTD.appendChild(img);
    row.appendChild(iconTD);
    row.appendChild(createTDText(item.name));
    row.appendChild(createTDText(item.size));
    row.appendChild(createTDText(item.price));
    return row;
}

function createPriceRow(totalPrice, sb)
{
    var row = htmlPage.createElementNS("http://www.w3.org/1999/xhtml", "tr");
    row.setAttribute("class", "totalprice");
    row.appendChild(createTD());
    row.appendChild(createTDText(sb.getString("totalprice.label")));
    row.appendChild(createTD());
    row.appendChild(createTDText(totalPrice));
    return row;
}

function createTD()
{
    return htmlPage.createElementNS("http://www.w3.org/1999/xhtml", "td");
}
function createTDText(text)
{
    var td = createTD();
    td.appendChild(htmlPage.createTextNode(text));
    return td;
}
