/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


var gSuggestedAddress = null;
function AddressSelectDialog()
{
    ttDialog.call(this, "footer");
}
AddressSelectDialog.prototype =
{
    onLoad: function(params)
    {
        gSuggestedAddress = params.suggestedAddress;
        if (params.suggestedAddress)
            setSuggestedAddress(params.suggestedAddress);
        if (params.requestedAddress)
            setRequestedAddress(params.requestedAddress);
    },

    __end : null
}
extend(AddressSelectDialog, ttDialog);
var dialog = new AddressSelectDialog();


function setSuggestedAddress(address)
{
    var r = "";
    if (address.city)
        r += address.city + "\n";
    if (address.street)
        r += address.street + (address.housenumber ? " " + address.housenumber : "") + "\n";
    if (address.country)
    {
        try {
            var sbC = getStringBundle("chrome://tthome/locale/ttlocalelist/countries.properties");
            r += sbC.GetStringFromName(address.country) + "\n";
        } catch (e) { unimportantError(e); }
    }

    E("address.suggested.box").value = r;
}

function setRequestedAddress(address)
{
    if (address.city)
        E("address.city.box").value = address.city;
    if (address.street)
        E("address.street.box").value = address.street;
    if (address.housenumber)
        E("address.housenumber.box").value = address.housenumber;
    if (address.country == "US" || address.country == "CA")
    {
        E("address.state.box").value = address.state;
    }
    else
    {
        E("address.state.box").disabled = true;
    }
}

function next()
{
    if (E("manualAddress").selected)
    {
        var manualAddress = {
            city : E("address.city.box").value,
            street : E("address.street.box").value,
            housenumber : E("address.housenumber.box").value,
            state : E("address.state.box").value,
            manualEntry : true
        };
        for (var key in gSuggestedAddress)
            if (!(key in manualAddress))
                manualAddress[key] = gSuggestedAddress[key];

        dialog.close(manualAddress);
    }
    else
    {
        dialog.close(gSuggestedAddress);
    }
}

function toggleSelection()
{
    var d = !E("manualAddress").selected
    E("address.city.box").disabled = d;
    E("address.street.box").disabled = d;
    E("address.housenumber.box").disabled = d;
    E("address.state.box").disabled = d ||
        !(gSuggestedAddress.country == "US" || gSuggestedAddress.country == "CA");
}
