/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function ConnectSDCard()
{
    ttPage.apply(this, arguments);
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/installSelectSome/connectSDCard.properties");
}

ConnectSDCard.prototype =
{
    _stringBundle : null,
    _isLarger : false,
    _device : null,

    inputOnLoad : function(params)
    {
        this._isLarger = params.isLarger;

        this.handleLinks();

        if (this._isLarger)
        {
            this.title = this._stringBundle.GetStringFromName("page.larger.title");
            E("page-message").collapsed = true;
            E("page-message-larger").removeAttribute("collapsed");
        }

        this._device = gApplication.deviceManager.activeDevice;
        this.registerLocationObserver();
        window.addEventListener("unload", makeCallback(this, this.unregisterLocationObserver), false);
    },

    handleLinks : function()
    {
        let tipMessage = this._stringBundle.GetStringFromName("page.sdcard.tip");
        let [beforeLink, linkLabel, afterLink]  = tipMessage.split(/\[\/?link\]/);
        let linkElement = E("tomtom-website");

        if (beforeLink)
            E("page-tip").insertBefore(document.createTextNode(beforeLink), linkElement);

        linkElement.setAttribute("label", linkLabel);

        if (afterLink)
            E("page-tip").insertBefore(document.createTextNode(afterLink), linkElement.nextSibling);
        let tipMessage2 = this._stringBundle.GetStringFromName("page.sdcard.more.tip");
        let [beforeLink2, linkLabel2, afterLink2]  = tipMessage2.split(/\[\/?link\]/);
        let linkElement2 = E("support-website");

        if (beforeLink2)
            E("page-tip-2").insertBefore(document.createTextNode(beforeLink2), linkElement2);

        linkElement2.setAttribute("label", linkLabel2);

        if (afterLink2)
            E("page-tip-2").insertBefore(document.createTextNode(afterLink2), linkElement2.nextSibling);
        let mapsMessage = this._isLarger ? this._stringBundle.GetStringFromName("page.sdcard.larger.maps") : this._stringBundle.GetStringFromName("page.sdcard.maps");
        let [beforeLink3, linkLabel3, afterLink3]  = mapsMessage.split(/\[\/?link\]/);
        let linkElement3 = E("zones-website");

        if (beforeLink3)
            E("maps-message").insertBefore(document.createTextNode(beforeLink3), linkElement3);

        linkElement3.setAttribute("label", linkLabel3);

        if (afterLink3)
            E("maps-message").insertBefore(document.createTextNode(afterLink3), linkElement3.nextSibling);
    },

    registerLocationObserver : function()
    {
        this._device.installLocations().addObserver(this);
    },

    unregisterLocationObserver : function()
    {
        try
        {
            this._device.installLocations().removeObserver(this);
        } catch (e) {
}
    },

    added : function(installLocation)
    {
        gApplication.deviceManager.resumeDeviceSelection(this._device, installLocation);
    },

    removed : function()
    {
    },

    repopulated : function()
    {
    },
ejectDevice : function()
    {
        try {
            if (this._device)
                this._device.disconnect(false);
        } catch (e) {
            error(e);
        }
    },

    QueryInterface : function(iid)
    {
        if (iid.equals(CI.ttICollectionObserver) ||
            iid.equals(CI.nsISupportsWeakReference) ||
            iid.equals(CI.nsISupports))
            return this;
        throw Components.results.NS_ERROR_NO_INTERFACE;
    },

    result : function()
    {
        return "";
    }
};
extend(ConnectSDCard, ttPage);
window.page = new ConnectSDCard();
