/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


const kFreeSpaceBuffer = 262144;
function InstallSelectSome()
{
    ttSubTask.apply(this, arguments);
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/installSelectSome/installSelectSome.properties");
}
InstallSelectSome.prototype =
{
    name : "installSelectSome",
    _result : null,
    _stringBundle : null,
_additionalSizeRequirements : null,
    _items : null,
_devItems : null,
_removableItems : null,
_mapItems : null,
_installTargets : null,
_origLocationChangeMethod : null,
_observedDevice : null,
_restarting : false,
_itemsToDownload : null,
_unusedItemsToRemove : null,
_locationOverrides : null,
_mimItem : null,
start : function(args)
    {
        ttSubTask.prototype.start.apply(this, arguments);

        if (args.items.length == 0)
        {
            this.subtaskDone([]);
            return;
        }

        this._items = args.items;
        this._additionalSizeRequirements = ("additionalSizeRequirements" in args ? args.additionalSizeRequirements : null);

        var hasNavItems = args.items.some(function(item) { return (item instanceof ttNavItem); });
        if (hasNavItems)
        {
            this._task.needDevice(makeCallback(this, function()
            {
                this.registerLocationObserver();
                window.addEventListener("unload", makeCallback(this, this.unregisterLocationObserver), false);
                this._ttwizard.registerReversibleAction(makeCallback(this, this.unregisterLocationObserver));

                if (args.confirmSelection)
                {
                    this.selectInstallLoad(args.hideInstallLater);
                }
                else
                {
                    this.doDeviceScan(makeCallback(this, this.selectInstallDone, args.items));
                }
            }));
        }
        else
        {
            if (args.confirmSelection)
                this.selectInstallLoad(args.hideInstallLater);
            else
                this.doDeviceScan(makeCallback(this, this.selectInstallDone, args.items));
        }
    },
doDeviceScan: function(successCallback)
    {
        this._devItems = new ttItemList();
        this._task.addCleanupHandler(makeCallback(this, function() {
                this._devItems.destructor();
            }));

        this._devItems.addFilter(new ttDependencyTreeBuilder());
        this._task.doDeviceScan(makeCallback(this, function()
            {
               this._restarting = false;

                successCallback();
            }), errorAbortTask, this._devItems);
    },
selectInstallLoad : function(hideInstallLater)
    {
        this._ttwizard.loadPage(
            this._constructPageURL("selectInstall"),
            { hideInstallLater: hideInstallLater },
            makeCallback(this, this.selectInstallAsyncLoad),
            null,
            makeCallback(this, this.selectInstallDone)
            );
    },
selectInstallAsyncLoad : function(page)
    {
        this.doDeviceScan(makeCallback(this, function()
        {
            try {
                var itemList = new ttItemList();
                this._task.addCleanupHandler(function() {
                        itemList.destructor();
                    });
                itemList.addFilter(new ttDuplicateFilter());
                itemList.addFilter(new InstallSelectSomeFilter(this._devItems.contents));

                itemList.addFilter(new ttDependencyTreeBuilder());
                page.inputStart(itemList);

                itemList.addItemListArray(this._items);
            } catch (e) { errorAbortTask(e); }

            page.inputDone();
        }));
    },
selectInstallDone : function(result)
    {
        var haveInstalls = false;
        var haveAddons = false;
        var haveNavcore = false;
        this._itemsToDownload = [];

        for (var i = 0; i < result.length; i++)
        {
            var item = result[i];
            if (item.hasNoDownload)
                continue;

            if (item instanceof ttNavItem)
                haveInstalls = true;
            else if (item instanceof ttAddon)
                haveAddons = true;
            if (item instanceof ttProgram)
                haveNavcore = true;
            if (!item.isLocal)
                this._itemsToDownload.push(item);
        }
        if (haveAddons)
        {
            this._ttwizard.addCommit(
                ttAddon.restartCommitFunction,
                null,
                getStringBundle("chrome://tthome/locale/logic/model/ttAddon.properties").GetStringFromName("commit.restart.label"),
                this.commitPriority);
        }
		var dev = gApplication.deviceManager.activeDevice;
        if (haveNavcore && dev && !dev.isUsbDevice)
        {
            this._task.addCleanupHandler(function(task, success, result)
            {
                if (success)
                {
                    runAsync(function()
                    {
                        top.gMainWindow.dialogs.openDialog(
                            "chrome://tthome/content/ui/dialogs/device/deviceLogicalDisconnectDialog.xul");
                    });
                }
            });
        }
        if (haveInstalls)
        {
            var dev = gApplication.deviceManager.activeDevice;
            if(dev && dev.isUsbDevice)
            {
                this.checkUSBDeviceSize(result);
            }
            else
            {
                this.checkSize(result);
            }
        }
        else
            this.subtaskDone(result);
    },
    checkUSBDeviceSize : function(result)
    {
        var dev = gApplication.deviceManager.activeDevice;
        let navItems = result.filter(function(item) item instanceof ttNavItem);
        var totalInstallSize = 0;
        var sizeToMinus = 0;
		var sizeonUSBtoMinus = 0;
        let itemsOnDevice = this._devItems.contents;
        for(i=0; i<navItems.length; i++)
        {
            totalInstallSize += navItems[i].size;
        }
        for each (let itemOndevice in itemsOnDevice)
        {
            for(i=0; i<navItems.length; i++)
            {
				if(itemOndevice.idstr && ((navItems[i].idstr == itemOndevice.idstr) || (navItems[i].replacedMap == itemOndevice.idstr)) && (navItems[i].newerThan(itemOndevice)))
                {
                    sizeonUSBtoMinus = itemOndevice.size;
					if (navItems[i] instanceof ttMap && navItems[i].basemap)
					{
						var sizeofBaseMap = dev.itemSizeOnDevice(navItems[i].basemap);
						if (sizeofBaseMap > 0)
						{
							sizeToMinus += sizeofBaseMap;
						}
						else if (navItems[i].oldbasemap)
						{
							sizeToMinus += dev.itemSizeOnDevice(navItems[i].oldbasemap);
						}
					}
					else
					{
						var sizeOfInstalledMap = dev.itemSizeOnDevice(navItems[i].idstr);
						if (sizeOfInstalledMap > 0)
						{
							sizeToMinus += sizeOfInstalledMap;
						}
						else if (navItems[i].replacedMap)
						{
							sizeToMinus += dev.itemSizeOnDevice(navItems[i].replacedMap);
						}
					}
                }
            }
        }
		var totalInstallSizeonUSB = totalInstallSize - sizeonUSBtoMinus;
        totalInstallSize = totalInstallSize - sizeToMinus;
        var dev = gApplication.deviceManager.activeDevice;
		var devSize;
		if (dev)
		{
			devSize = dev.FreeSizeOnDevice;
			var theOneMBSize = 1048576;
			devSize = devSize - theOneMBSize;
		}
        if(dev && devSize<totalInstallSize)
        {
            let zoneableMap = null;
            for each(let navItem in navItems)
            {
                if (navItem instanceof ttMap &&
                    navItem.basemap &&
                    navItem.basemap == navItem.idstr)
                    {
                        zoneableMap = navItem;
                        break;
                    }
            }
            if(!zoneableMap)
            {
                let message = this._stringBundle.GetStringFromName("notEnoughDeviceSpace.message");
                    ttMessageService().alert(
                    this._stringBundle.GetStringFromName("notEnoughDeviceSpace.title"), message);
                task.abort();   
            }
            else if(zoneableMap && devSize<zoneableMap.size)
            {
                this._result = result;
                this.mimChoose(navItems, makeCallback(this, this.mapZonesSubtaskLoad, navItems));
            }
        }
        else if (gApplication.deviceManager.activeInstallLocation.sizeInBytesFree<totalInstallSizeonUSB)
        {
            let message = this._stringBundle.GetStringFromName("notEnoughUSBSpace.message");
                ttMessageService().alert(
                this._stringBundle.GetStringFromName("notEnoughUSBSpace.title"), message);
            task.abort();
        }
        else
        {
            this._result = result;
            let mapsToMove = this.mapsToBackup();
            if (mapsToMove.length > 0)
                this.selectCopyLoad(mapsToMove);
            else
                this.selectCopyDone([]);
        }
    },
checkSize : function(installItems)
    {
        this._result = installItems;
        let navItems = installItems.filter(function(item) item instanceof ttNavItem);
        this._removableItems = new ttItemList();
        this._task.addCleanupHandler(makeCallback(this, function() {
                this._removableItems.destructor();
            }));
        this._removableItems.addFilter(new ttNonRemovableFilter(navItems));
        this._removableItems.addItemList(this._devItems);
        let willFit =  ttNavItem.willItemsFit(
            navItems,
            null,
            this._devItems.contents,
            this._additionalSizeRequirements,
            kFreeSpaceBuffer,
            this._locationOverrides);
        if (willFit)
        {
            let mapsToMove = this.mapsToBackup();
            if (mapsToMove.length > 0)
                this.selectCopyLoad(mapsToMove);
            else
                this.selectCopyDone([]);
        }
        else
        {
            if (this._locationOverrides)
            {
                this._locationOverrides = null;
                this.selectInstallDone(installItems);
                return;
            }

            let sdPath = "";
            let hasMemoryCard = false;
            for each (let installLocation in gApplication.deviceManager.getInstallLocationsForDevice())
            {
                if (installLocation.physicalType == CI.ttIInstallLocation.kLocationTypeMemoryCard)
                {
                    hasMemoryCard = true;
                    sdPath = installLocation.path.path;
                    break;
                }
            }
            let devItemsMap = {__proto__: null};
            for each(let item in this._devItems.contents)
                for each (let id in item.significantIDs)
                    devItemsMap[id] = true;
            let newItems = navItems.filter(function(item) !item.significantIDs.some(function(id) id in devItemsMap));
            let itemsWithoutZones = navItems.filter(function(item) !((item instanceof ttMap) && item.basemap));

            let tryDeviceCleanup = false;

            let isDeviceExpandable = hasMemoryCard || this._observedDevice.hasEmptySDCardSlot;
            if (isDeviceExpandable)
            {
                let mapFits = true;
                let locationOverride = null;
                let mapItems = installItems.filter(function(item) item instanceof ttMap);
                if (hasMemoryCard && mapItems.length > 0)
                {
                    mapFits = false;
                    for each (mapItem in mapItems)
                    {
                        locationOverride = null;
                        let locationMatch = mapItem.locationType == 1
                                            && mapItem.sourceDLL.installLocation.physicalType == CI.ttIInstallLocation.kLocationTypeMemoryCard;
                        if (!locationMatch)
                        {
                            locationOverride = [ {item: mapItem, location: sdPath} ];
                            willFit =  ttNavItem.willItemsFit(
                                navItems,
                                null,
                                this._devItems.contents,
                                this._additionalSizeRequirements,
                                kFreeSpaceBuffer,
                                locationOverride);
                            if (willFit)
                            {
                                mapFits = true;
                                break;
                            }
                        }
                    }
                }

                let isPocketPC = this._observedDevice.model.familyName == "PocketPC";
                let hasNewItem = newItems.length > 0;
                let hasMaps = installItems.some(function(item) item instanceof ttMap);
                let shouldSuggestSDCard = (hasNewItem || hasMaps) && !isPocketPC;
                if (shouldSuggestSDCard)
                {
                    if (this._observedDevice.hasEmptySDCardSlot)
                    {
                        this.suggestSDCard(navItems, false);
                    }
                    else if (!mapFits)
                    {
                        this.suggestSDCard(navItems, true);
                    }
                    else if (navItems.length == 1
                          && mapItems.length == 1
                          && mapItems[0].mapType != 2)
                    {
                        this._locationOverrides = [ {item: navItems[0], location: sdPath} ];
                        this.selectCopyDone([]);
                    }
                }
                else
                {
                    tryDeviceCleanup = true;
                }
            }
            else
            {
                tryDeviceCleanup = true;
            }

            if (tryDeviceCleanup)
            {
                let willPotentiallyFit = 
                    ttNavItem.willItemsFit(
                        itemsWithoutZones,
                        this._removableItems.contents,
                        this._devItems.contents,
                        this._additionalSizeRequirements,
                        kFreeSpaceBuffer,
                        this._locationOverrides);

                if (willPotentiallyFit)
                {
                    this.smartRemoval(navItems);
                }
                else
                {
                    let hasMultipleLocations = gApplication.deviceManager.getInstallLocationsForDevice().length > 1;
                    let message = this._stringBundle.GetStringFromName("notEnoughTotalSpace."+
                                                                       (hasMultipleLocations ? "multiple" : "single")+
                                                                       "Location.message");
                    this._task.abort();
                    ttMessageService().alert(
                        this._stringBundle.GetStringFromName("notEnoughTotalSpace.title"),
                        message);
                }
            }
        }
    },
mapsToBackup: function()
    {
        let mapsOnDevice = (this._devItems.contents.filter(function (el) el instanceof ttMap));
        let mapsToMove = [];
        for each (let mapondevice in mapsOnDevice)
            for each (let item in this._items)
                if (mapondevice.basemap && item instanceof ttMap && item.basemap === mapondevice.basemap && item.idstr !== mapondevice.idstr)
                {
                    mapsToMove.push(mapondevice);
                    break;
                }
        return mapsToMove;
    },
suggestSDCard: function(items, isLarger)
    {
        this._ttwizard.loadPage(
            this._constructPageURL("connectSDCard"),
            {isLarger : isLarger},
            makeCallback(this, this.connectSDCardAsync),
            makeCallback(this, this.connectSDCardCheck),
            makeCallback(this, this.connectSDCardDone, items)
        );
    },
connectSDCardAsync: function(page)
    {
        this.unregisterLocationObserver(true);
        if (this._ttwizard.getHistoryMarker() != this._subtaskStartMarker)
            this._ttwizard.registerReversibleAction(makeCallback(this, this.registerLocationObserver));
        gApplication.deviceManager.pauseDeviceSelection();
        let resumeDevice = function() gApplication.deviceManager.resumeDeviceSelection();
        this._task.addCleanupHandler(resumeDevice);
        this._ttwizard.registerReversibleAction(resumeDevice);

        page.inputStart();
        page.inputDone();
    },
connectSDCardCheck: function(result, successCallback, errorCallback, returnCallback)
    {
        if (result == "")
        {
            successCallback();
        }
        else
        {
            errorCallback();
        }
    },
connectSDCardDone: function(items, result)
    {
        gApplication.deviceManager.resumeDeviceSelection();

        if (result == "")
        {
            this.registerLocationObserver();
            this.smartRemoval(items);
        }
        else
        {
            this._task.abort();
        }
    },
smartRemoval : function(navItems)
    {
        let installingMaps = navItems.some(function(item) item instanceof ttMap);
        let smartItemsList = new ttItemList();
        this._task.addCleanupHandler(function() {
                smartItemsList.destructor();
            });
        smartItemsList.addFilter(new SmartRemovalFilter(navItems, this._devItems, installingMaps));
        smartItemsList.addItemList(this._devItems);
        let willItemsFit = ttNavItem.willItemsFit(navItems, smartItemsList.contents, this._devItems.contents,
                            this._additionalSizeRequirements, kFreeSpaceBuffer);
        if (willItemsFit)
        {
            this._ttwizard.loadPage(
                this._constructPageURL("smartRemoval"),
                {
                    list : smartItemsList,
                    installedItems : navItems,
                    additionalSizeRequirements : this._additionalSizeRequirements,
                    devItems : this._devItems,
                    freeSpaceBuffer : kFreeSpaceBuffer
                },
                makeCallback(this, this.smartRemovalAsyncLoad),
                makeCallback(this, this.smartRemovalCheck, navItems),
                makeCallback(this, this.smartRemovalDone, navItems)
            );
        }
        else
        {
            this.mimChoose(navItems, makeCallback(this, this.mapZonesSubtaskLoad, navItems));
        }
    },
smartRemovalAsyncLoad : function(page)
    {
        page.inputStart();
        page.inputDone();
    },
smartRemovalCheck : function(navItems, items, successCallback, errorCallback, returnCallback)
    {
        this._unusedItemsToRemove = items;

        if (ttNavItem.willItemsFit(navItems, items, this._devItems.contents,
                this._additionalSizeRequirements, kFreeSpaceBuffer))
        {
            this.confirmDeleteMsg(items, navItems, successCallback, returnCallback);
        }
        else
        {
            this.mimChoose(navItems, makeCallback(this, successCallback));
        }
    },
smartRemovalDone : function(navItems, items)
    {
        let willItemsFit = ttNavItem.willItemsFit(navItems, items, this._devItems.contents,
                            this._additionalSizeRequirements, kFreeSpaceBuffer);

        if (willItemsFit)
        {
            this._ttwizard.addCommit(
                makeCallback(this, this.removeDeviceCommit),
                items,
                this._stringBundle.GetStringFromName("remove.commit.name"),
                this.commitPriority + 0.1);
            let mapsToMove = this.mapsToBackup();
            if (mapsToMove.length > 0)
                items = items.concat(mapsToMove);

            this.selectCopyLoad(items);
        }
        else
        {
            this.mimChoose(navItems, makeCallback(this, this.mapZonesSubtaskLoad, navItems));
        }
    },
mimChoose : function(navItems, bypassCallback)
    {
        let installingMaps = navItems.some(function(item) item instanceof ttMap);
        if (installingMaps)
        {
            this._mapItems = new ttItemList();
            this._mapItems.addFilter(new ttDuplicateFilter());
            let maps = navItems.filter(function (el) el instanceof ttMap);
            if (maps.length > 1)
            {
                this._mapItems.addItemListArray(maps);

                this._ttwizard.loadPage(
                    this._constructPageURL("mimChoose"),
                    { },
                    makeCallback(this, this.mimChooseAsyncLoad, navItems),
                    null,
                    makeCallback(this, this.mimChooseDone, navItems)
                );
                return;
            }
        }
        bypassCallback(navItems);
    },
mimChooseAsyncLoad : function(navItems, page)
    {
        let mapItems = new ttItemList();
        let maps = navItems.filter(function (el) el instanceof ttMap);
        mapItems.addItemListArray(maps);
        page.inputStart([mapItems, this._mimItem]);
        page.inputDone();
    },
mimChooseDone : function(navItems, items)
    {
        this._mimItem = items[0];

        for each (let installLocation in gApplication.deviceManager.getInstallLocationsForDevice())
        {
            if (installLocation.physicalType == CI.ttIInstallLocation.kLocationTypeInternal)
            {
                this._locationOverrides = [ {item: this._mimItem, location: installLocation.path.path} ];
                break;
            }
        }

        this.selectInstallDone(items);
    },
mapZonesSubtaskLoad : function(navItems)
    {
        let zoneableMap = null;
        for each(let navItem in navItems)
        {
            if (navItem instanceof ttMap &&
                navItem.basemap &&
                navItem.basemap == navItem.idstr)
            {
                zoneableMap = navItem;
                break;
            }
        }

        if (zoneableMap)
        {
            let installedItems = navItems.filter(function(el) el != zoneableMap);

            this.loadSubTask(new MapZones(), {
                    item: zoneableMap,
                    insideInstallFlow: true,
                    installedItems: installedItems,
                    devItems: this._devItems,
                    removableItems : this._removableItems,
                    additionalSizeRequirements: this._additionalSizeRequirements,
                    freeSpaceBuffer: kFreeSpaceBuffer
                }, makeCallback(this, function(zonedMap) {
                       this.mapZonesSubtaskDone(zonedMap, zoneableMap.idstr, navItems);
                }));
        }
        else
            this.selectRemoveLoad(navItems);
    },
mapZonesSubtaskDone : function(zonedMap, originalMapId, navItems)
    {
        assert(zonedMap instanceof ttMap, "Zoned map must be an instance of ttMap.");
        var dev = gApplication.deviceManager.activeDevice;
		var devSize;
		if (dev && dev.isUsbDevice)
		{
			devSize = dev.FreeSizeOnDevice;
			var theOneMBSize = 1048576;
			devSize = devSize - theOneMBSize;
		}
        if(dev && dev.isUsbDevice && devSize<zonedMap.size)
        {
            let message = this._stringBundle.GetStringFromName("notEnoughDeviceSpace.message");
                ttMessageService().alert(
                this._stringBundle.GetStringFromName("notEnoughDeviceSpace.title"), message);
                task.abort();
        }        
        else
        {
            if (zonedMap.idstr == originalMapId)
                this.selectRemoveLoad(navItems);
            else
            {
                let replaceMap = function(item) { return item.idstr == originalMapId ? zonedMap : item; };
                navItems = navItems.map(replaceMap);
                this._result = this._result.map(replaceMap);
                this._itemsToDownload = this._itemsToDownload.map(replaceMap);
                if (!zonedMap.isLocal && !this.isZonedMapOnDevice(zonedMap))
                {
                    if (this._itemsToDownload.length > 0)
                    {
                        for each (let item in this._itemsToDownload)
                        {
                            let isVersionEquals = !zonedMap.newerThan(item) && !item.newerThan(zonedMap);
                            if (item instanceof ttMap && item.basemap && item.basemap == zonedMap.basemap && item.idstr !== zonedMap.idstr && isVersionEquals)
                                this._itemsToDownload.push(zonedMap);
                        }
                    }
                    else
                    {
                        this._itemsToDownload.push(zonedMap);
                    }
                }
                let willItemsFit = ttNavItem.willItemsFit(navItems, null, this._devItems.contents,
                                   this._additionalSizeRequirements, kFreeSpaceBuffer);
    
                if (willItemsFit)
                    this.selectCopyDone([]);
                else
                {
                    if(dev && dev.isUsbDevice && gApplication.deviceManager.activeInstallLocation.sizeInBytesFree<zonedMap.size)
                    {
                        let message = this._stringBundle.GetStringFromName("notEnoughUSBSpace.message");
                        ttMessageService().alert(
                        this._stringBundle.GetStringFromName("notEnoughUSBSpace.title"), message);
                        task.abort();
                    }
                    else
                        this.selectRemoveLoad(navItems);
                }
            }
        }
    },
isZonedMapOnDevice : function(zonedMap)
    {
        let mapsOnDevice = this._devItems.contents.filter(function (el) el instanceof ttMap);
        for each (let mapondevice in mapsOnDevice)
        {
            let isVersionEquals = !zonedMap.newerThan(mapondevice) && !mapondevice.newerThan(zonedMap);
            if (mapondevice.basemap && zonedMap.basemap === mapondevice.basemap && zonedMap.idstr === mapondevice.idstr && isVersionEquals)
                return true;
        }
        return false;
    },
selectRemoveLoad : function(installedItems)
    {
        this._ttwizard.loadPage(
            this._constructPageURL("selectRemove"),
            {
                preSelectedItems : this._unusedItemsToRemove,
                installedItems : installedItems,
                additionalSizeRequirements : this._additionalSizeRequirements,
                devItems : this._devItems,
                freeSpaceBuffer : kFreeSpaceBuffer
            },
            makeCallback(this, this.selectRemoveLoadAsync),
            makeCallback(this, this.selectRemoveCheck, installedItems),
            makeCallback(this, this.selectRemoveDone)
            );
    },

    selectRemoveLoadAsync : function(page)
    {
        page.inputStart(this._removableItems);
        page.inputDone();
    },
selectRemoveCheck : function(installedItems, items, successCallback, errorCallback, returnCallback)
    {
        this.confirmDeleteMsg(items, installedItems, successCallback, returnCallback);
    },

    selectRemoveDone : function(items)
    {
        this._ttwizard.addCommit(
            makeCallback(this, this.removeDeviceCommit),
            items,
            this._stringBundle.GetStringFromName("remove.commit.name"),
            this.commitPriority + 0.1);

        this.selectCopyLoad(items);
    },
confirmDeleteMsg : function(items, installedItems, successCallback, returnCallback)
    {
        let devContents = this._devItems.contents;
        let criticalMessages = [];
        if (!installedItems.some(function(el) el instanceof ttMap))
        {
            let mapsToDelete = (items.filter(function (el) el instanceof ttMap)).length;
            let mapsOnDevice = (devContents.filter(function (el) el instanceof ttMap)).length;
            if (mapsToDelete >= mapsOnDevice)
                criticalMessages.push(this._stringBundle.GetStringFromName("reallyDeleteWarningTextAllMaps"));
        }
        if (!installedItems.some(function(el) el instanceof ttVoice))
        {
            let voicesToDelete = (items.filter(function (el) el instanceof ttVoice)).length;
            let voicesOnDevice = (devContents.filter(function (el) el instanceof ttVoice)).length;
            if (voicesToDelete >= voicesOnDevice)
                criticalMessages.push(this._stringBundle.GetStringFromName("reallyDeleteWarningTextAllVoices"));
        }
        if (items.some(function (el) el instanceof ttProgram))
            criticalMessages.push(this._stringBundle.GetStringFromName("reallyDeleteWarningTextApplications"));

        let warningText;
        if (criticalMessages.length)
        {
            warningText = this._stringBundle.formatStringFromName("reallyDeleteWarningTextCriticals",
                                  [criticalMessages.join("\n")], 1);
        }
        else
        {
            warningText = this._stringBundle.GetStringFromName("reallyDeleteWarningText");
        }

        ttMessageService().confirm(
            this._stringBundle.GetStringFromName("reallyDeleteWarningTitle"),
            warningText,
            null, null,
            successCallback,
            returnCallback);
    },
selectCopyLoad : function(removeItems)
    {
        var localItems = gApplication.itemFactory.createItemListFromDLL(gApplication.homeServices.localNavItems());
        var localItemsMap = {__proto__: null};
        for each (var item in localItems)
            localItemsMap[item.idurl] = item;
        var askCopyItems = removeItems.filter(function(element)
        {
            if (!element.sourceDLL.canCopyToComputer)
                return false;

            return (!(element.idurl in localItemsMap) ||
                    element.newerThan(localItemsMap[element.idurl]));
        });
        if (askCopyItems.length == 0)
        {
            this.selectCopyDone([]);
            return;
        }

        var itemlist = new ttItemList();
        this._task.addCleanupHandler(function() {
                itemlist.destructor();
            });
        itemlist.addFilter(new ttDependencyTreeBuilder());
        itemlist.addItemListArray(askCopyItems);

        this._ttwizard.loadPage(
            this._constructPageURL("selectCopy"),
            itemlist,
            null,
            makeCallback(this, ttNavItem.copyToPCCheck),
            makeCallback(this, this.selectCopyDone)
            );
    },
selectCopyDone : function(items)
    {
        for each(item in this._itemsToDownload)
        {
            if (!item.isLocal)
            {
                this._ttwizard.addCommit(
                    makeCallback(this, this.downloadCommit),
                    item,
                    this._stringBundle.formatStringFromName("commit.download.name", [item.name], 1),
                    this.commitPriority + 0.05);
            }
        }

        if (items.length > 0)
        {
            this._ttwizard.addCommit(
                makeCallback(this, this.removeCopyCommit),
                items,
                this._stringBundle.GetStringFromName("copy.commit.name"),
                this.commitPriority + 0.2);
        }
        let navItems = this._result.filter(function(item) item instanceof ttNavItem);

        let installLocations = {__proto__: null};
        for each (let installLocation in gApplication.deviceManager.getInstallLocationsForDevice())
            installLocations[installLocation.path.path] = installLocation;

        this._installTargets = ttNavItem.getItemsByTargetLocation(navItems, this._devItems.contents, this._locationOverrides);
        for (let installLocationPath in this._installTargets)
        {
            this._ttwizard.addCommit(
                makeCallback(this, this.installCommit),
                installLocations[installLocationPath],
                this._stringBundle.formatStringFromName("commit.install.name", [installLocations[installLocationPath].name], 1),
                this.commitPriority);
        }

        this.unregisterLocationObserver();
        this.subtaskDone(this._result);
    },
handleInstallLocationChange : function()
    {
        if (!this._task.currentlyNeedDevice)
            return;
        if (this._restarting)
            return;

        this._restarting = true;
        this._ttwizard.allowContinue(true);

        this.restart();
    },
registerLocationObserver : function()
    {
        if (!this._origLocationChangeMethod)
        {
            this._origLocationChangeMethod = this._task._installLocationChanged;
            this._task._installLocationChanged = makeCallback(this, this.handleInstallLocationChange);
        }
        if (!this._observedDevice)
        {
            this._observedDevice = gApplication.deviceManager.activeDevice;
            this._observedDevice.installLocations().addObserver(this);
        }
    },
unregisterLocationObserver : function(keepLocationChangeObserver)
    {
        if (this._origLocationChangeMethod && !keepLocationChangeObserver)
        {
            this._task._installLocationChanged = this._origLocationChangeMethod;
            delete this._origLocationChangeMethod;
        }
        if (this._observedDevice)
        {
            try {
                this._observedDevice.installLocations().removeObserver(this);
            } catch (e) {
}
            delete this._observedDevice;
        }
    },
    added : function(installLocation)
    {
        this.handleInstallLocationChange();
    },
    removed : function(installLocation)
    {
        this.handleInstallLocationChange();
    },
    repopulated : function()
    {
        this.handleInstallLocationChange();
    },
    QueryInterface : function(iid)
    {
        if (iid.equals(CI.ttICollectionObserver) ||
            iid.equals(CI.nsISupportsWeakReference) ||
            iid.equals(CI.nsISupports))
            return this;
        throw Components.results.NS_ERROR_NO_INTERFACE;
    },
downloadCommit : function(serveritem, progressCallback, successCallback, errorCallback)
    {
        var resetBroken = true;
        const kBroken = "tomtom.account.brokenDownload";
        if (serveritem.locationType == 6)
        {
            try {
                if (prefService().getBoolPref(kBroken))
                    resetBroken = false;
            } catch (e) { unimportantError(e); };
            prefService().setBoolPref(kBroken, true);
        }

        let extendedSuccessCallback = makeCallback(this, function(item)
        {
            for each (let itemList in this._installTargets)
            {
                let index = itemList.indexOf(serveritem)
                if (index > -1)
                    itemList[index] = item;
            }

            if (resetBroken)
                prefService().setBoolPref(kBroken, false);

            successCallback(this._stringBundle.formatStringFromName(
                            "downloadedItems", [item.name], 1));
            if (serveritem instanceof ttProgram)   
            {  
                this.logNavcoreDownloads(serveritem.version, serveritem._xml.build, false);
            }
        });

        let extendedErrorCallback = function(e)
        {
            try {
                if (serveritem.locationType == 6)
                    prefService().setBoolPref("tomtom.account.brokenDownload", true);
            } catch (e) { unimportantError(e); }

            errorCallback(e);
        }
        let localItems = gApplication.itemFactory.createItemListFromDLL(gApplication.homeServices.localNavItems());
        let certificateLocation = serveritem.getCertificateLocation();
        let localItem = null;
        if (certificateLocation)
        {
            for each (let item in localItems)
            {
                if (item.idurl == serveritem.idurl &&
                    !item.newerThan(serveritem) &&
                    !serveritem.newerThan(item) &&
                    item.getCertificateLocation())
                {
                    localItem = item;
                    break;
                }
            }
        }

        if (localItem)
        {
            return new Downloader().download(certificateLocation.url, gApplication.settings.osTempDir,
                progressCallback,
                makeCallback(this, function(certificateFile)
                {
                    let copiedItem = localItem.createCopyWithDurhamCertificate(certificateFile);

                    this._task.addCleanupHandler(function() removeFile(certificateFile, false));

                    extendedSuccessCallback(copiedItem);
                }),
                extendedErrorCallback);
        }
        else
        {
            return serveritem.download(progressCallback, extendedSuccessCallback, extendedErrorCallback);
        }
    },
installToMemoryCardMsg : function(installLocationType)
    {
        let [title, message] = [ this._stringBundle.GetStringFromName("SDInstall.title"),
                                this._stringBundle.GetStringFromName("SDInstall.message")
                               ];
        if (installLocationType == CI.ttIInstallLocation.kLocationTypeMemoryCard)
        {
            var messageService = new MessageService();
            messageService.alert(title, message);
        }
    },
installCommit : function(installLocation, progressCallback, successCallback, errorCallback)
    {
        let items = this._installTargets[installLocation.path.path];
        return ttNavItem.installOnDevice(installLocation, items, progressCallback,
            makeCallback(this, function()
            {
                successCallback(this._stringBundle.formatStringFromName(
                                "installedItems", [items.length], 1));
                let itemsToInstall = this._items;
                for (let i = 0; i < itemsToInstall.length; i++)
                {
                    if (itemsToInstall[i] instanceof ttMap)
                    {
                        this.installToMemoryCardMsg(installLocation.physicalType);
                        break;
                    }
                    if (itemsToInstall[i] instanceof ttProgram)   
                    {
                       this.logNavcoreDownloads(itemsToInstall[i].version, itemsToInstall[i]._xml.build, true);
                    }
                }
            }),
            errorCallback);
    },
removeDeviceCommit : function(items, progressCallback, successCallback, errorCallback)
    {
        var devItems = gApplication.deviceManager.activeInstallLocation.deviceNavItems();
        var iterator = new ArrayIterator(items, function(item) item.sourceDLL);
        var deleter = devItems.createItemDeleter(iterator);
        var dl = new DeleteListener(progressCallback, successCallback, errorCallback);
        dl.successText = this._stringBundle.formatStringFromName("remove.commit.done",
                         [items.length], 1);
        return new Abortable(deleter.doDelete(dl));
    },
removeCopyCommit : function(items, progressCallback, successCallback, errorCallback)
    {
        return ttNavItem.copyToPC(items, progressCallback, makeCallback(this, function()
        {
            successCallback(this._stringBundle.GetStringFromName("copy.commit.done"));
        }),
        errorCallback);
    },
logNavcoreDownloads : function(installNavcoreVersion, installNavcoreBuild, status)
    {
            var dev = gApplication.deviceManager.activeDevice;
            if (dev)
            {
                if (dev.isAutomotive)
                {
                    var serverargs = {};
                    serverargs.deviceModel = dev.model.id;
                    serverargs.deviceNavcoreVersion = installNavcoreVersion;
                    serverargs.NavcoreBuild = installNavcoreBuild;
                    serverargs.deviceSerial = dev.serial;
                    serverargs.country  = gApplication.settings.country;
                    serverargs.language = gApplication.settings.uiLocale;
                    serverargs.clientVersion  = gApplication.settings.version;
                    serverargs.navcoreinstalled  = status;
                    this.networkCall(rpc.call("statistics", "logAutomotiveNavcoreDownloads",
                         serverargs,
                         null, RPC.METHOD_POST | RPC.USE_CACHE,
                         function(result){
                            return;
                          },
                         function(result){
                            return;
                          }));
                }
            }
    },

    __end : null
}
extend(InstallSelectSome, ttSubTask);
function InstallSelectSomeFilter(devItems)
{
    ttItemListFilter.apply(this);

    this._devItems = {__proto__: null};
    for each (var item in devItems)
    {
        this._devItems[item.idurl] = item;
        this._devItems[item.idstrlong] = item;
    }
}
InstallSelectSomeFilter.prototype =
{
    _devItems : null,

    checkItem : function(item)
    {
        if ((item.idurl in this._devItems && !item.newerThan(this._devItems[item.idurl])) ||
            (item.idstrlong in this._devItems && !item.newerThan(this._devItems[item.idstrlong])))
        {
            return [];
        }
        return [item];
    }
}
extend(InstallSelectSomeFilter, ttItemListFilter);
function SmartRemovalFilter(doNotShowItems, devItems, considerAllMaps)
{
    ttNonRemovableFilter.call(this, doNotShowItems);
    this._considerAllMaps = considerAllMaps;
    this._devItems = devItems;

    for each(let devItem in this._devItems.contents)
    {
        if (devItem instanceof ttVoice &&
            devItem.sourceDLL.active == CI.ttINavItem.kActive)
        {
            this._activeVoice = devItem;
            break;
        }
    }
}
SmartRemovalFilter.prototype =
{
    _activeVoice : null,
    _considerAllMaps : null,
_rules : [
        function(item)
        {
            if (item instanceof ttZipcode || item instanceof ttSatImage)
                return "mapitems";
            else
                return null;
        },
        function(item)
        {
            if (item instanceof ttMap)
                if (this._considerAllMaps || item.sourceDLL.active != CI.ttINavItem.kActive)
                    return "maps";
            return null;
        },
        function(item)
        {
            if (item instanceof ttVoice)
            {
                if(this._activeVoice && (this._activeVoice.language == item.language))
                {
                    return "activelanguageitems";
                }
                return "languageitems";
            }
            else
                return null;
        }
    ],

    checkItem : function(item)
    {
        let result = ttNonRemovableFilter.prototype.checkItem.call(this, item);
        if (result.length == 0)
          return result;

        for each (let rule in this._rules)
        {
            let category = rule.call(this, item);
            if (category)
            {
                item.disposableCategory = category;
                return [item];
            }
        }

        return [];
    }
}
extend(SmartRemovalFilter, ttNonRemovableFilter);