/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function LatestMapGuarantee()
{
    ttSubTask.apply(this, arguments);

    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/latestMapGuarantee/latestMapGuarantee.properties");
}
LatestMapGuarantee.prototype =
{
    name : "latestMapGuarantee",

    _stringBundle : null,
    _doUpdate : true,
    _items : null,

    start : function ()
    {
        ttSubTask.prototype.start.apply(this, arguments);
        this._task.needDevice(makeCallback(this, this.queryForMapLoad));
    },

    queryForMapLoad : function ()
    {
        this._ttwizard.loadPage(
            this._constructPageURL("queryForMap"),
            null,
            makeCallback(this, this.scanDevice),
            null,
            makeCallback(this, this.queryForMapDone));
    },
scanDevice : function (aPage)
    {
        this._task.doDeviceScan(makeCallback(this, this.queryForMapLoadPrecheck, aPage), errorAbortTask);
    },

    queryForMapLoadPrecheck : function (aPage)
    {
		var dev = gApplication.deviceManager.activeDevice;
		var uploadBody = new XML(dev.latestMapGuarantee);

		this.networkCall(rpc.call("shop", "latestMapGuarantee",
			{
				deviceModel: dev.model.id,
				deviceSerial: dev.serial,
				deviceCode: dev.deviceCode,
				deviceCapabilities: gApplication.deviceManager.activeDeviceCapabilitiesString,
				deviceParameters: gApplication.deviceManager.activeDeviceParametersString,
				deviceNavcoreVersion: dev.versionNavCore,
				operatingSystem : gApplication.settings.operatingSystemServerName
			},
			uploadBody,
			RPC.METHOD_POST, function (aResult)
			{
				var title = makeSafe.label(aResult.title);
				var body = makeSafe.label(aResult.text);
				
				aPage.inputDone({ title: title, body: body, doUpdate: true });
			},
			errorAbortTask));
    },

    queryForMapDone : function ()
    {
        this.subtaskDone({ doUpdate: this._doUpdate, mapsToUpdate: this._items });
    },

    __end : null
}
extend(LatestMapGuarantee, ttSubTask);
