/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/



function NewAccountPage()
{
    ttPage.apply(this, arguments);
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/login/newAccountPage.properties");
}
NewAccountPage.prototype =
{
    _stringBundle: null,
    _inputData: null,
    _emailValid: false,
    _passwordFocused: false,
    _passwordConfirmFocused: false,
    _items: null,
inputOnLoad: function(inputData)
    {
        var wizard = this._wizard();
        wizard._wizfooter.getLeftButton().hidden = false;

        this._inputData = inputData;

        function inputDataDefault(name, defaultValue)
        {
            return (name in inputData) ? inputData[name] : defaultValue;
        }
        var isRecognizedAutomotive = typeof this._getCarBrandLabel(this._vehicleBrand) != "undefined";
        var tomtomWorkEnabled = this._isTomTomWorkEnabled();
        var username = inputDataDefault("username", "");
        var rememberPassword = inputDataDefault("rememberPassword", false);
        var tomtomNews = inputDataDefault("tomtomNews", !isRecognizedAutomotive);
        var tomtomWork = inputDataDefault("tomtomWork", tomtomWorkEnabled);
        var items = {
            emailField: E("newAccount.email.field"),
            emailLabel: E("newAccount.email.label"),
            emailHelp: E("newAccount.email.help"),
            passwordField: E("newAccount.password.field"),
            passwordLabel: E("newAccount.password.label"),
            passwordHelp: E("newAccount.password.help"),
            passwordConfirmField: E("newAccount.passwordConfirm.field"),
            passwordConfirmLabel: E("newAccount.passwordConfirm.label"),
            passwordConfirmHelp: E("newAccount.passwordConfirm.help"),
            rememberCheckbox: E("newAccount.remember.checkbox"),
            tomtomNewsCheckbox: E("newAccount.tomtomNews.checkbox"),
            tomtomWorkCheckbox: E("newAccount.tomtomWork.checkbox"),
            firstName: E("newAccount.firstName.field"),
            surName: E("newAccount.surName.field"),
            countryHelp: E("newAccount.country.help"),
            countryLabel: E("newAccount.country.label"),
            createAccountButton: E("create_account"),
            country: E("listbox-country")
        };

        var countryFlag = false;
        var emailFlag = false;
        var passwordFlag = false;
        var passwordErrorFlag = false;
        var passwordConfirmErrorFlag = false;
        var buttonFlag = false;
        var emailErrorFlag = false;
        var renaultOnclick = false;
        items.createAccountButton.disabled = true;
        this._items = items;
        this.renaultNewsFlag = true;

        try {
            items.firstName.value = this._stringBundle.GetStringFromName("firstname.label");
            items.surName.value = this._stringBundle.GetStringFromName("surname.label");
            items.emailField.value = username;
            items.passwordField.value = this._stringBundle.GetStringFromName("password.label");
            items.passwordConfirmField.value = this._stringBundle.GetStringFromName("confirmPassword.label");
            items.rememberCheckbox.checked = rememberPassword;
            items.tomtomNewsCheckbox.checked = tomtomNews;
            items.tomtomWorkCheckbox.hidden = !tomtomWorkEnabled;
            items.tomtomWorkCheckbox.checked = tomtomWork;
            items.rememberCheckbox.addEventListener("CheckboxStateChange", makeCallback(this, this._checkboxChanged), false);
            items.tomtomNewsCheckbox.addEventListener("CheckboxStateChange", makeCallback(this, this._checkboxChanged), false);
            items.tomtomWorkCheckbox.addEventListener("CheckboxStateChange", makeCallback(this, this._checkboxChanged), false);
        } catch (e) {
            error(e);
        }
            this._changeToAutomotiveNewsletter();

            this._setFooterMargin();

            this.validateEmail();
    },
checkField: function(id)
    {
        var elem = E(id);
        if(elem == null)
            return;

        if(elem.parentNode.getAttribute("invalid") == "true")
        {
            elem.parentNode.setAttribute("active","false");
            return;
        }

        var val = elem.value.trim();
        this._setActive(elem);

        if(id.search("email") >= 0)
        {
            this._setValid(elem);
            this._items.emailHelp.hidden = false;
        }
        else if(id.search("password.field") >= 0)
        {
            this._setValid(elem);
            this._items.passwordHelp.hidden = false;
        }
        else if(id.search("Confirm") >= 0)
        {
            this._setValid(elem);
            this._items.passwordConfirmHelp.hidden = false;
            this._items.passwordConfirmHelp.previousSibling.hidden = false;
            this._items.passwordConfirmHelp.nextSibling.hidden = false;
            this._passwordConfirmFocused = true;
        }
        else if(id.search("country") >= 0)
        {
            this._items.countryHelp.hidden = false;
            this._setValid(elem);
        }

        if(val.length >0 && (val == this._stringBundle.GetStringFromName("firstname.label") ||
            val == this._stringBundle.GetStringFromName("surname.label") ||
            val == this._stringBundle.GetStringFromName("email.label") ||
            val == this._stringBundle.GetStringFromName("password.label") ||
            val == this._stringBundle.GetStringFromName("confirmPassword.label")))
            {
                elem.value = "";
            }

        if(val == this._stringBundle.GetStringFromName("password.label") || val == this._stringBundle.GetStringFromName("confirmPassword.label"))
        {
            elem.type = "password";
        }
    },
hideHelpText: function(id)
    {
        var elem = E(id);
        var items = this._items;
        if(id.search("Name") >= 0)
        {
            if(items.firstName.value.trim() == "" || (items.firstName.value.trim() == this._stringBundle.GetStringFromName("firstname.label")))
            {
                items.firstName.value = this._stringBundle.GetStringFromName("firstname.label");
                this._setNormalTrue(items.firstName);
            }
            else
            {
                this._setTypeOn(items.firstName);
            }

            if(items.surName.value.trim() == "" || (items.surName.value.trim() == this._stringBundle.GetStringFromName("surname.label")))
            {
                items.surName.value = this._stringBundle.GetStringFromName("surname.label");
                this._setNormalTrue(items.surName);
            }
            else
            {
                this._setTypeOn(items.surName);
            }
        }
        else if(id.search("country") >= 0)
        {
            items.countryHelp.hidden = true;
            if(items.country.value == "XXX")
            {
                this._setInvalid(elem, items.countryLabel, "");
                this.countryFlag = false;
                this._onBlurInvalidate(elem);
                items.createAccountButton.disabled = true;
                this._allowContinue(false);
            }
            else
            {
                this._setNormalTrue(elem);
                this._setValid(elem);
                this._onBlurValidate(elem);
                this.countryFlag = true;
                this._allowContinue(true);
            }
        }
    },
_validateFields: function()
    {
        if(this.countryFlag && this.emailFlag && this.passwordFlag && this.renaultNewsFlag)
        {
            this._items.createAccountButton.disabled = false;
            this.buttonFlag = false;
        }
        else
        {
            this._items.createAccountButton.disabled = true;
            this.buttonFlag = true;
        }
    },
renaultNewsCheck: function()
    {
        if(!(E("renault-news").selectedIndex == "1" || E("renault-news").selectedIndex == "2"))
        {
            if(this.renaultOnclick)
            {
                E("renault-news").className = "renault-invalid";
            }
            this.renaultOnclick = true;
            this.renaultNewsFlag = false;
        }
        else
        {
            E("renault-news").className = "";
            this.renaultNewsFlag = true;
            this._validateFields();
        }
    },
renaultNewsOnclick: function()  
    {
        this.renaultOnclick = true;
        this.renaultNewsCheck();
    },
_changeToAutomotiveNewsletter: function()
    {
        var checkbox = E("newAccount.tomtomNews.checkbox");
        var vehicleBrand = this._vehicleBrand;
        var carBrandLabel = this._getCarBrandLabel(vehicleBrand);

        this._setNewsletterCheckbox(carBrandLabel, checkbox);
        this._setPrivacyPolicyLink(carBrandLabel, vehicleBrand, checkbox);
    },
_setNewsletterCheckbox : function(brandLabel, checkbox) 
    {
        if(brandLabel != null)
        {
            checkbox.label = this._stringBundle.formatStringFromName("marigot.newsletter", [brandLabel], 1);
            if(brandLabel == "Renault")
            {
                checkbox.hidden = true;
                E("renault-newsletter").hidden = false;
                E("renault-content").textContent = this._stringBundle.GetStringFromName("renault.newsletter");
            }
        }
    },
_setFooterMargin : function()
    {
        var footerMargin = E("right-box").clientHeight + 50;
        E("footer-section").setAttribute("style", "margin-top:"+footerMargin+"px;");
    },
_setPrivacyPolicyLink : function(brandLabel, brand, checkbox) 
    {
        var box = E('policy-leader');
        box.setAttribute("class", "automotive-disclaimer");
        var label = document.createElement("description");
        label.textContent = this._stringBundle.GetStringFromName("marigot.policy");
        var link = document.createElement("ttlink");

        if(brandLabel == null)
        {
            link.setAttribute("type", "webid");
            link.setAttribute("urlid", "privacy");
            link.setAttribute("label", this._stringBundle.GetStringFromName("login.privacyPolicy.link"));
        }
        else
        {
            link.setAttribute("type", "webid");
            link.setAttribute("urlid", brand.replace(/ /g, "") + "Policy");
            link.setAttribute("label", this._stringBundle.formatStringFromName("marigot.link", [brandLabel], 1));  
        }

        box.appendChild(label);
        box.appendChild(link);
    },
get _vehicleBrand()
    {
        let paramsString = gApplication.deviceManager.activeDeviceParametersString;
        let vehicleBrand = "";

        if (paramsString)
        {
            try {
                let params = JSON.parse(paramsString);
                vehicleBrand = params.VehicleBrand || "";
            } catch (e) {
                unimportantError(e);
            }
        }

        return memoize(this, "_vehicleBrand", vehicleBrand);
    },
_getCarBrandLabel : function(vehicleBrand)
    {
        var carBrands = {
            "Mazda" : "Mazda",
            "Renault" : "Renault",
            "Renault Trucks" : "Renault",
            "Opel" : "Opel",
            "Vauxhall" : "Vauxhall",
            "Fiat" : "Fiat",
            "Alfa Romeo" : "Alfa Romeo",
            "Lancia" : "Lancia",
            "Iveco" : "Iveco",
            "Fiat Professional" : "Fiat Professional"
        };

        return carBrands[vehicleBrand];
    },
_isTomTomWorkEnabled: function()
    {
        return gApplication.deviceManager.activeDevice &&
               gApplication.deviceManager.activeDevice.hasCapability("WorkEnabled");
    },
result: function()
    {
        var items = this._items;
        var fname = "";
        var sname = "";

        if(items.firstName.value.trim() == "" || items.firstName.value == this._stringBundle.GetStringFromName("firstname.label")){
            fname = "";
        }
        else
        {
            fname =items.firstName.value;
        }

        if(items.surName.value.trim() == "" || items.surName.value == this._stringBundle.GetStringFromName("surname.label"))
        {
            sname = "";
        }
        else
        {
            sname = items.surName.value;
        }

        if(E("renault-news").selectedIndex == "1")
        {
            items.tomtomNewsCheckbox.checked = true;
        }
        return {
            username: items.emailField.value,
            password: items.passwordField.value,
            rememberPassword: items.rememberCheckbox.checked,
            tomtomNews: items.tomtomNewsCheckbox.checked,
            tomtomWork: items.tomtomWorkCheckbox.checked,
            createAccountBtn: items.createAccountButton,
            firstName: fname,
            surName: sname,
            country: items.country.value,
            gender : E("gender").value
        };
    },
validateEmail: function()
    {
        var items = this._items;
        var emailField = items.emailField;

        if(this.emailErrorFlag)
        {
            items.emailHelp.hidden = false;
        }
        else
        {
            items.emailHelp.hidden = true;
        }

        this._onBlurInvalidate(emailField);

        try {
            checkEmailAddressSyntax(emailField.value.trim());
        } catch (e) {
            this._emailValid = false;

            if(this.emailErrorFlag)
            {
                this._validateFields();
                this.emailErrorFlag=false;
            }
            else
            {
                if(!(emailField.value.trim() == "" || (emailField.value.trim() == this._stringBundle.GetStringFromName("email.label"))))
                {
                    this._setInvalid(emailField, items.emailLabel, errorToText(e));
                }
                this._handleTextColors(emailField, "email.label");
                this._onBlurInvalidate(emailField);
                this.emailFlag = false;
                items.createAccountButton.disabled = true;
                this._allowContinue(false);
            }
            return;
        }
        this.emailErrorFlag=false;
        this._setValid(emailField);
        this._emailValid = true;
        
        this._handleTextColors(emailField, "email.label");
        this._onBlurValidate(emailField);

        this.emailFlag = true;
        this._allowContinue(true);

        this._copyValuesToInputData();
    },
checkEmailError: function()
    {
        this.emailErrorFlag = true;
        this.validateEmail();
    },
validatePassword: function()
    {
        this.passwordErrorFlag=true;
        this._validatePasswords();
    },
validatePasswordFocusChange: function(event)
    {
        this.passwordErrorFlag = false;

        this._items.passwordHelp.hidden = true;
        var passwordField = this._items.passwordField;

        this._handleTextColors(passwordField, "password.label");
        if (event.target == passwordField) return;

        this._passwordFocused = (event.type == "focus");
        this._validatePasswords();
    },
validatePasswordConfirm: function()
    {
        this._items.passwordConfirmHelp.hidden = true;
        this._items.passwordConfirmHelp.previousSibling.hidden = true;
        this._items.passwordConfirmHelp.nextSibling.hidden = true;

        var passwordConfirmField = this._items.passwordConfirmField;
        passwordConfirmField.parentNode.setAttribute('key','true');
        this._validatePasswords();
    },
validatePasswordConfirmFocusChange: function(event)
    {
        var passwordConfirmField = this._items.passwordConfirmField;
        passwordConfirmField.parentNode.removeAttribute('active');
        passwordConfirmField.parentNode.removeAttribute('key');
        if (event.target == passwordConfirmField) return;

        if(this.passwordConfirmErrorFlag == true)
            return;

        this._handleTextColors(passwordConfirmField, "confirmPassword.label");

        this._passwordConfirmFocused = (event.type == "focus");

        this._validatePasswords();
    },
_handleTextColors: function(field, label)
    {
        if(field.value.trim() == "" || field.value.trim() == this._stringBundle.GetStringFromName(label))
        {
            field.type = "text";
            this._setNormalTrue(field);
            field.value = this._stringBundle.GetStringFromName(label);
        }
        else
        {
            this._setTypeOn(field);
        }
    },
_setTypeOn: function(node)
    {
        if(!node.parentNode.hasAttribute("invalid"))
        {
            this._removeOtherAttributes(node, 'typed');
            node.parentNode.setAttribute("typed", "true");
        }
    },
_setNormalTrue: function(node)
    {
        this._removeOtherAttributes(node, 'normal');
        node.parentNode.setAttribute("normal", "true");
    },
_setActive: function(node)
    {
        this._removeOtherAttributes(node, 'active');
        node.parentNode.setAttribute("active", "true");
    },
_removeOtherAttributes: function(node, attr)
    {
        if(attr != 'typed')
        {
            node.parentNode.removeAttribute("typed");
        }

        if(attr != 'normal')
        {
            node.parentNode.removeAttribute("normal");
        }

        if(attr != 'active')
        {
            node.parentNode.removeAttribute("active");
        }

        if(attr != 'invalid')
        {
            node.parentNode.removeAttribute("invalid");
        }
    },
_setValid: function(node)
    {
        node.parentNode.removeAttribute("invalid");
    },
_setInvalid: function(node, messageTarget, message)
    {
        if(message == "")
        message = messageTarget.textContent;
        this._removeOtherAttributes(node, 'invalid');
        messageTarget.textContent = message;
        node.parentNode.setAttribute("invalid", "true");
    },
_validatePasswords: function()
    {
        var items = this._items;
        var passwordField = items.passwordField;
        var password = passwordField.value;
        var passwordConfirmField = items.passwordConfirmField;
        var passwordConfirm = passwordConfirmField.value;
        if(password == this._stringBundle.GetStringFromName("password.label"))
        {
            password = "";
        }
        if(passwordConfirm == this._stringBundle.GetStringFromName("confirmPassword.label"))
        {
            passwordConfirm = "";
        }
        items.passwordConfirmHelp.hidden = true;

        if (password == "")
        {

            this._setValid(passwordField);

            if (passwordConfirm == "")
            {
                this._setValid(passwordConfirmField);
            }
            else
            {
                this._setInvalid(passwordConfirmField,
                                 items.passwordConfirmLabel,
                                 this._stringBundle.GetStringFromName("passwordValidityReq3"));

                this.passwordConfirmErrorFlag = true;
            }
            this._onBlurInvalidate(passwordField);
            this._onBlurInvalidate(passwordConfirmField);
            items.createAccountButton.disabled = true;
            this.passwordFlag = false;
            this._allowContinue(false);

            return;
        }
        try {
            checkNewPasswordSyntax(password, this._passwordFocused);
        } catch (e) {

            if(!this.passwordErrorFlag)
            {
                this._setInvalid(passwordField, items.passwordLabel, errorToText(e));
            }
            this._setValid(passwordConfirmField);
            this._onBlurInvalidate(passwordField);
            this._onBlurInvalidate(passwordConfirmField);
            items.createAccountButton.disabled = true;
            this.passwordFlag = false;
            this._allowContinue(false);

            return;
        }
        var passwordValid = true;
        var passwordError = null;
        passwordConfirmField.removeAttribute('readonly');
        try {
            checkNewPasswordSyntax(password, false);
        } catch (e) {
            passwordValid = false;
            passwordError = errorToText(e);
        }

        if (this._passwordConfirmFocused)
        {

            if (passwordValid && password == passwordConfirm)
            {

                this._setValid(passwordField);
                this._setValid(passwordConfirmField);
                this._onBlurValidate(passwordField);
                this._onBlurValidate(passwordConfirmField);
                this.passwordFlag = true;
                this._allowContinue(
                    !items.emailField.parentNode.hasAttribute("invalid"));

                return;
            }
        }

        if (passwordValid || this._passwordFocused)
        {

            this._setValid(passwordField);

            if (passwordValid && password == passwordConfirm)
            {

                this._setValid(passwordConfirmField);
                this._onBlurValidate(passwordField);
                this._onBlurValidate(passwordConfirmField);
                this.passwordFlag = true;
                this._allowContinue(
                    !items.emailField.parentNode.hasAttribute("invalid"));

                return;
            }
        }
        else
        {

            this._setInvalid(passwordField,
                             items.passwordLabel,
                             passwordError);
        }

        if (this._passwordConfirmFocused)
        {

            this._setInvalid(passwordConfirmField,
                            items.passwordConfirmLabel,
                            this._stringBundle.GetStringFromName("passwordValidityReq3"));

            this.passwordConfirmErrorFlag = true;
        }
        else
        {

            this._setValid(passwordConfirmField);
        }

        if (passwordValid)
        {

            this._onBlurValidate(passwordField);
        }
        else
        {

            this._onBlurInvalidate(passwordField);
        }

        this._onBlurInvalidate(passwordConfirmField);
        items.createAccountButton.disabled = true;
        this.passwordFlag = false;
        this._allowContinue(false);
        if(items.country.value == "XXX")
            items.country.parentNode.setAttribute('invalid',true);
        if(this._vehicleBrand == "Renault")
        {
            this.renaultOnclick = true;
            this.renaultNewsCheck();
        }
    },
_onBlurValidate: function(node)
    {
        if (!node.parentNode.hasAttribute("invalid"))
        {
            node.parentNode.setAttribute("blurvalid", "true");
        }
    },
countryChange: function()
    {
        if(this._items.country.value == "XXX")
        {
            this.countryFlag = false;
            this._allowContinue(false);
        }
        else
        {
            this.countryFlag = true;
            this._items.country.parentNode.removeAttribute("invalid");
            this._allowContinue(true);
        }
    },
_onBlurInvalidate: function(node)
    {
        node.parentNode.removeAttribute("blurvalid");
    },
_checkboxChanged: function()
    {
        this._copyValuesToInputData();
    },
_copyValuesToInputData: function()
    {

        var items = this._items;
        this._inputData["username"] = items.emailField.value;
        this._inputData["rememberPassword"] = items.rememberCheckbox.checked;
        this._inputData["tomtomNews"] = items.tomtomNewsCheckbox.checked;
        if (this._isTomTomWorkEnabled())
        {
            this._inputData["tomtomWork"] = items.tomtomWorkCheckbox.checked;
        }
    },
_allowContinue: function(flag)
    {
        this._validateFields();	
        this._wizard().allowContinue(flag);
    }
}
extend(NewAccountPage, ttPage);
window.page = new NewAccountPage();
