/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function Restore()
{
    ttSubTask.apply(this, arguments);
}
Restore.prototype =
{
    name : "restore",
    _stringBundle : null,

    start : function()
    {
        ttSubTask.prototype.start.apply(this, arguments);
        this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/restore/restore.properties");
        this._task.needDevice(makeCallback(this, this.initiateRestoreLoad));
    },

    initiateRestoreLoad : function()
    {
        var backupFolder = gApplication.settings.backupsDir;
        var latestBackup = getLatestBackup(true, backupFolder);

        if (!latestBackup)
        {
            this._ttwizard.loadPage(
                this._constructPageURL("noBackup"),
                null,
                null,
                null,
                makeCallback(this, this.subtaskDone)
                );
        }
        else
        {
            this._ttwizard.loadPage(
                this._constructPageURL("initiateRestore"),
                null,
                null,
                null,
                makeCallback(this, this.initiateRestoreDone)
                );
        }
    },
    initiateRestoreDone : function()
    {
        var backupFolder = gApplication.settings.backupsDir;
        var backup = getLatestBackup(true, backupFolder);
        this._ttwizard.addCommit(
            makeCallback(this, this.restoreCommit),
            backup,
            this._stringBundle.GetStringFromName("commit.name"),
            this.commitPriority
        );

        this.subtaskDone();
    },

    restoreCommit : function(backup, progressCallback, successCallback, errorCallback)
    {
        var severity    = { value : null };
        var errorStrOut = { value : null };
        var errorOut    = { value : null };
        var dev = gApplication.deviceManager.activeDevice;
        backup.checkPreconditionsRestoreOk(dev, severity, errorOut, errorStrOut);
        if (severity.value != 0 && severity.value != CI.ttIError.kSeverityWarning)
        {
            errorCallback(errorStrOut.value);
            return new NoOpAbortable();
        }

        var me = this;
        return new Abortable(backup.restore(dev, new BaseListener(function(percent)
                {
                    progressCallback(percent * 0.1, me._stringBundle.GetStringFromName("scanning"));
                },
                function(errorCode) {},
                errorCallback),
            new CopyListener( function(percent, text)
                {
                    progressCallback(10 + (percent * 0.9), text)
                },
                successCallback,
                errorCallback)
        ));
    },

    __end : null
}
extend(Restore, ttSubTask);
