/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function EditItemData() {
    ttPage.apply(this, arguments);
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/shareContent/editItemData.properties");
    this._categoriesMap = new Map();
}

EditItemData.prototype =
{
    _stringBundle : null,
    _item : null,
    _stopSharing : false,
    _isUpdate : false,
    _previewOK : false,
    _audioSampleOK : false,
    _previewImageURI : null,
    _audioSampleURI : null,
    _categoriesMap : null,
_kTextInputFilterMap : { "<": true, ">": true, "&": true },
    _kTextInputFilterRegExp : /[<>&]/g,
    _kPreviewImageFilter : "*.png;*.jpeg;*.jpg;*.gif",
    _kSampleSoundFilter : "*.wav",
    _kPreviewImageWidth : 160,
    _kPreviewImageHeight : 160,
_kFieldToContentMap : {
        language : ["voice", "loquendovoice"],
        custompreview : ["arrivalsound", "colorscheme", "itinerary", "messagereceived",
                         "ringtone", "satimage", "warningsound", "startupsound", "shutdownsound"],
        custompreviewlabels : ["arrivalsound", "colorscheme", "itinerary", "messagereceived",
                               "ringtone", "satimage", "warningsound", "startupsound", "shutdownsound"],
        custompreviewpreview : ["arrivalsound", "colorscheme", "itinerary", "messagereceived",
                                "ringtone", "satimage", "warningsound", "startupsound", "shutdownsound"],
        sample : ["voice"],
        category : ["poi", "itinerary", "satimage", "colorscheme", "ringtone", "startupscreen",
                    "suspendscreen", "arrivalsound", "warningsound", "messagereceived", "carsymbol",
                    "startupsound", "shutdownsound", "homesymbol", "favouritesymbol", "buddysymbol"]
    },

    inputOnLoad : function (aItem)
    {
        assert(aItem instanceof ttNavItem);
        this._item = aItem;
        var wizard = this._wizard();

        this._wizard().setAttribute("contenttype", this._item.typeID);
        var itemName;
        var userHandle;
        this._isUpdate = aItem.isUpdate;
        if (!this._isUpdate)
        {
            wizard._wizfooter.getRightButton().label = this._stringBundle.GetStringFromName("next.new.label");
            itemName = document.createElement("textbox");
            itemName.setAttribute("id", "title");
            itemName.setAttribute("maxlength", "32");
            itemName.setAttribute("flex", "1");
            itemName.addEventListener("keypress", function (aEvent) { page.filterChars(aEvent); }, false);
            itemName.addEventListener("input", function (aEvent) { page.filterChars(aEvent); }, false);
            itemName.addEventListener("input", function () { page.validateTitle(itemName); }, false);
            E("title-row").insertBefore(itemName, E("title-valid"));
            userHandle = document.createElement("textbox");
            userHandle.addEventListener("keypress", function (aEvent) { page.filterChars(aEvent); }, false);
            userHandle.addEventListener("input", function (aEvent) { page.filterChars(aEvent); }, false);
        }
        else
        {
            wizard.pagesubtitle = this._stringBundle.GetStringFromName("page.subtitle.edit");
            wizard._wizfooter.getRightButton().label = this._stringBundle.GetStringFromName("next.edit.label");
            itemName = document.createElement("label");
            itemName.setAttribute("id", "title");
            itemName.setAttribute("flex", "1");
            itemName.setAttribute("class", "bold-label");
            E("title-row").insertBefore(itemName, E("title-valid"));
            userHandle = document.createElement("label");
            userHandle.setAttribute("class", "bold-label");
}

        userHandle.setAttribute("id", "userhandle");
        E("userhandle-row").appendChild(userHandle);
        for (var row in this._kFieldToContentMap)
        {
            var rowName = row + "-row";
            if (this._kFieldToContentMap[row].indexOf(this._item.typeID) == -1)
                E(rowName).hidden = true;
        }

        if (!(this._item instanceof ttVoice))
        {
            var me = this;
            this.networkCall(rpc.call("sharing", "getCategories",
                { contentType : this._item.typeID },
                null, RPC.METHOD_GET,
                function (aResult)
                {
                    var categories = [];
                    for each (var cat in aResult.category)
                    {
                        categories.push(
                            {
                                id : makeSafe.string(cat.@id),
                                name : makeSafe.string(cat.text())
                            });
                    }
                    me.populateCategories(categories);
                },
                errorAbortTask));
        }

        gApplication.login.addObserver(this);
        window.addEventListener("unload", makeCallback(this, function() {
            gApplication.login.removeObserver(this);
        }), false);
        E("input-container").hidden = false;
    },

    inputDone : function ()
    {
        this.populateItemData(this._item);
        if (!this._isUpdate)
            this.validateTitle(E("title"));
        if (!E("language-row").hidden)
            this.validateLanguage(E("language"));
        try {
            document.commandDispatcher.advanceFocus();
        } catch (e) {
            unimportantError(e);
        }
        this.allowContinue(gApplication.login.isLoggedIn);
    },

    populateItemData : function (aItem)
    {
        assert(aItem instanceof ttNavItem);
        if (this._isUpdate || !gApplication.homeServices.isSingular(aItem.listEntry.itemtypeEnum))
            E("title").value = aItem.name;
        E("description").value = aItem.description;

        if (aItem instanceof ttVoice)
        {
            var lang = aItem.language;
            if (!lang)
                lang = gApplication.settings.uiLocale;
            E("language").value = lang;
        }

        if (this._kFieldToContentMap["custompreview"].indexOf(aItem.typeID) != -1 && aItem.preview)
        {
            try {
                var previewURL = getIOService().newURI(aItem.preview.url, null, null).QueryInterface(CI.nsIURL);
                this._checkPreviewImage(previewURL);
                E("preview").value = this._stringBundle.formatStringFromName("onServer.label",
                    [ previewURL instanceof CI.nsIFileURL ? previewURL.file.path : previewURL.fileName ], 1);
                this._previewImageURI = previewURL;
                E("preview-radiogroup").selectedIndex = 1;
            } catch (e) {
}
        }

        if (this._kFieldToContentMap["sample"].indexOf(aItem.typeID) != -1 && aItem.audioSample)
        {
            try {
                var sampleURL = aItem.audioSample.QueryInterface(CI.nsIURL);
                this._checkAudioSample(sampleURL);
                E("sample").value = this._stringBundle.formatStringFromName("onServer.label",
                    [ sampleURL instanceof CI.nsIFileURL ? sampleURL.file.path : sampleURL.fileName ], 1);
                this._audioSampleURI = sampleURL;
                E("sample-radiogroup").selectedIndex = 1;
            } catch (e) {
}
        }

        var tags = aItem.tags;
        if (tags)
        {
            E("keywords").value = tags.trim();
        }
        if (this._kFieldToContentMap["category"].indexOf(aItem.typeID) != -1)
        {
            if (aItem.categories && this._categoriesMap.hasValue(aItem.categories))
                E("category").selectedItem = this._categoriesMap.getValue(aItem.categories);
            else
                E("category").selectedIndex = 0;
        }

        E("userhandle").value = (aItem.authorName ? aItem.authorName : "");
    },

    populateCategories : function (aCategories)
    {
        var catList = E("category");

        if (aCategories.length == 0)
        {
            catList.appendItem(this._stringBundle.GetStringFromName("noCategoriesAvailable.label"), null);
            return;
        }

        for (var i = 0; i < aCategories.length; i++)
        {
            var menuItem = catList.appendItem(aCategories[i].name, aCategories[i].id);
            this._categoriesMap.addValue(aCategories[i].id, menuItem);
        }
        if (this._kFieldToContentMap["category"].indexOf(this._item.typeID) != -1)
        {
            if (this._item.categories && this._categoriesMap.hasValue(this._item.categories))
                catList.selectedItem = this._categoriesMap.getValue(this._item.categories);
            else
                catList.selectedIndex = 0;
        }
    },

    selectFile : function (aElementID, aType)
    {
        var picker = Cc["@mozilla.org/filepicker;1"].createInstance(CI.nsIFilePicker);
        var title = this._stringBundle.GetStringFromName("file.picker.title");
        picker.init(window, title, CI.nsIFilePicker.modeOpen);

        var textbox = E(aElementID);
        textbox.focus();

        if (textbox.value)
        {
            try {
                var currentFile = getFile(textbox.value);
                if (currentFile.isDirectory() && currentFile.parent)
                    currentFile = currentFile.parent;
                picker.displayDirectory = currentFile;
            } catch (e) {
}
        }
        switch (aType)
        {
            case "icon":
            case "preview":
                picker.appendFilter(this._stringBundle.GetStringFromName("file.picker.image.filter"),
                                    this._kPreviewImageFilter);
                break;
            case "sample":
                picker.appendFilter(this._stringBundle.GetStringFromName("file.picker.sound.filter"),
                                    this._kSampleSoundFilter);
                break;
            default:
                picker.appendFilters(CI.nsIFilePicker.filterAll);
        }

        if (picker.show() == CI.nsIFilePicker.returnOK)
        {
            var file = picker.file.QueryInterface(CI.nsILocalFile);
            textbox.value = file.path;

            switch (aType)
            {
                case "preview":
                    this._previewImageURI = picker.fileURL;
                    this._checkPreviewImage(picker.fileURL);
                    break;
                case "sample":
                    this._audioSampleURI = picker.fileURL;
                    this._checkAudioSample(picker.fileURL);
                    break;
                default:
                    errorAbortTask(new NotReached("Invalid selector type \"" + aType + "\" for file selection"));
            }
        }
    },
_checkPreviewImage : function (aPreviewImageURL)
    {
        if (!this._checkExtensions(aPreviewImageURL, this._kPreviewImageFilter))
        {
            this._previewOK = false;
            error(new Exception(this._stringBundle.GetStringFromName("previewWrongTypeException")));
            return;
        }
        var img = E("preview-preview");
        var me = this;
        img.onload = function() {
            if (img && img.src != "")
            {
                var width = img.naturalWidth;
                var height = img.naturalHeight;
                E("preview-size").value = width + "x" + height;
                E("preview-actual").hidden = false;
                var approved = (width <= me._kPreviewImageWidth
                                    && height <= me._kPreviewImageHeight);
                me.allowContinue(approved);
                var approveImg = E("preview-approve");
                var approveRec = E("preview-recommended");
                var approveSep = E("preview-sep");
                approveImg.className = approved ? "preview-approved" : "preview-rejected";
                approveRec.hidden = approveSep.hidden = me._previewOK = approved;
            }
        }
        img.src = aPreviewImageURL.spec;
    },
_checkAudioSample : function (aAudioSampleURL)
    {
        var approved = this._checkExtensions(aAudioSampleURL, this._kSampleSoundFilter);

        this._audioSampleOK = approved;
        this.allowContinue(approved);

        if (!approved)
            error(new Exception(this._stringBundle.GetStringFromName("audioSampleWrongTypeException")));
    },

    previewSelectionChanged : function (aRadioGroup, aElementID)
    {
        this.radioSelectionChanged(aRadioGroup, aElementID);
        var isDefault = (aRadioGroup.selectedIndex == 0)
        this.allowContinue(isDefault || (!isDefault && this._previewOK));
    },

    audioSelectionChanged : function (aRadioGroup, aElementID)
    {
        this.radioSelectionChanged(aRadioGroup, aElementID);
        var isDefault = (aRadioGroup.selectedIndex == 0)
        this.allowContinue(isDefault || (!isDefault && this._audioSampleOK));
    },

    radioSelectionChanged : function (aRadioGroup, aElementID)
    {
        var nodes = E(aElementID).childNodes;
        var disabled = !(aRadioGroup.selectedIndex == 1);
        for (var i = 0; i < nodes.length; i++)
            nodes.item(i).disabled = disabled;
    },

    stopSharing : function ()
    {
        this._stopSharing = true;
        this.continue();
    },

    _getURLFromPath : function (aPath)
    {
        var file;
        try
        {
            file = getFile(aPath);
        }
        catch (e)
        {
            file = null;
        }
        return file;
    },

    validateTitle : function (aTitleElem)
    {
        var title = this._trimCollapseWhitespace(aTitleElem.value);
        var error = "";

        try {
            makeSafe.nonemptystring(title);
        } catch (e) {
            error = errorToText(e);
        }

        if (title.length < 3)
            error = this._stringBundle.GetStringFromName("nameTooShort.label");

        var errorLabel = E("title-valid");
        errorLabel.value = error;
        errorLabel.hidden = error ? false : true;

        this.allowContinue(error ? false : true);
    },

    validateLanguage : function (aTTLocaleList)
    {
        this.allowContinue(aTTLocaleList.value ? true : false);
    },
filterChars : function (aEvent)
    {
        if (aEvent.type == "keypress")
        {
            if (this._kTextInputFilterMap[String.fromCharCode(aEvent.charCode)])
                aEvent.preventDefault();
        }
        else if (aEvent.type == "input")
        {
            var textbox = aEvent.target;
            var oldText = textbox.value;
            var newText = oldText.replace(this._kTextInputFilterRegExp, "");
            if (oldText.length == newText.length)
                return;
var selectionStart = textbox.selectionStart;
            var selectionEnd = textbox.selectionEnd;
            textbox.value = newText;
            textbox.setSelectionRange(selectionStart, selectionEnd);
        }
    },
_trimCollapseWhitespace : function (aString)
    {
        return aString.trim().replace(/\s+/g, " ");
    },
_checkExtensions : function (aURL, aExtensions)
    {
        var suffix = "*." + aURL.QueryInterface(CI.nsIURL).fileExtension.toLowerCase();
        var suffixList = aExtensions.split(";");
        if (!suffixList.some(function (aVal) aVal == suffix))
            return false;
        return true;
    },

    next : function ()
    {
        this.continue();
    },

    result : function ()
    {
        var result = {
            name : this._trimCollapseWhitespace(E("title").value),
            description : this._trimCollapseWhitespace(E("description").value),
            spokenLanguage : E("language").value,
            tags : null,
            category : null,
            userHandle : this._trimCollapseWhitespace(E("userhandle").value),
            stopSharing : this._stopSharing
        };

        var category = E("category").value;
        if (category && category.indexOf("XXX") != 0)
            result.category = category;
        if (E("preview-custom").selected)
        {
            result.preview = this._previewImageURI;
            var previewPreview = E("preview-preview");
            result.previewWidth = previewPreview.naturalWidth;
            result.previewHeight = previewPreview.naturalHeight;
        }

        if (E("sample-custom").selected)
            result.sample = this._audioSampleURI;
var tags = E("keywords").value.replace(/[^a-zA-Z0-9\-_ ]/g, " ");
        tags = this._trimCollapseWhitespace(tags);
        result.tags = makeSafe.list(tags,
                        function (tag) { return makeSafe.alphanumdash(tag); },
                        " ").join(" ");

        return result;
    },

    changed : function ()
    {
        this.allowContinue(gApplication.login.isLoggedIn);
    },

    __end : null
}
extend(EditItemData, ttPage);
window.page = new EditItemData();
