/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function ShowAccountItems()
{
    ttSubTask.apply(this, arguments);
}
ShowAccountItems.prototype =
{
    name : "showAccountItems",

    start : function()
    {
        ttSubTask.prototype.start.apply(this, arguments);
        this.showItemsLoad();
    },

    showItemsLoad : function()
    {
        this._ttwizard.loadPage(
            this._constructPageURL("showItems"),
            null,
            makeCallback(this, this.serverListLoadAsyncPrecond),
            null,
            makeCallback(this, this.showItemsDone)
            );
    },

    serverListLoadAsyncPrecond : function(page)
    {
        var me = this;
        this._task.needDevice(function()
        {
            me.networkCall(me._task.needLogin(function()
            {
                me.showItemsLoadAsync(page);
            }));
        });
    },

    showItemsLoadAsync : function(page)
    {
        var itemlist = new ttItemList();
        itemlist.addFilter(new ttDependencyTreeBuilder());
        page.inputStart(itemlist);
        var dev = gApplication.deviceManager.activeDevice;
        var args =
        {
            deviceCode: dev.deviceCode,
            deviceSerial: dev.serial,
            deviceModel: dev.model.id,
            deviceCapabilities: gApplication.deviceManager.activeDeviceCapabilitiesString,
            deviceParameters: gApplication.deviceManager.activeDeviceParametersString,
            deviceNavcoreVersion : dev.versionNavCore,
            deviceNavcoreBuild : dev.buildNumberNavCore,
            publicBeta : prefService().getBoolPref("tomtom.app.showBetaVersions")
        };
        addSubscriptionsRPCArgs(args);
        this.networkCall(rpc.call("shop", "getAccountLicensedContent",
            args, null, RPC.METHOD_GET & ~RPC.USE_CACHE,
        function(result)
        {
            itemlist.addItemListFromServer(result);
            page.inputDone();
        },
        errorAbortTask));
    },

    showItemsDone : function(items)
    {
        this.subtaskDone(items);
    },

    __end : null
}
extend(ShowAccountItems, ttSubTask);
