/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function ShowItems()
{
    ttPage.apply(this, arguments);
}
ShowItems.prototype =
{
_devItems : null,
_devIncompleteItems : null,
    
    inputOnLoad : function()
    {
        this._listbox = E("listbox");
        this._listbox.addObserver(this);
        this._sb = E("strings");
    },

    inputStart : function(data)
    {
        let [itemlist, devItems] = data;
        this._devItems = devItems;
        this._devIncompleteItems = {__proto__: null};
        
        this._listbox.addItemList(itemlist);
        for each (let item in this._devItems)
        {
            if (item instanceof ttNavItem && item.isIncompleteInstall)
            {
                this._devIncompleteItems[item.idstrlong] = item;
            }
        }
       
    },

    addedListItem : function(listitem)
    {
        var me = this;
        var model = listitem.modelitem;

        listitem.addButton(this._sb.getString("addgoButton"), function(listitem)
        {
            if (me._selectedItem)
                return;
            listitem.button.setAttribute("busy", "true");
            listitem.button.disabled = true;

            me._selectedItem = listitem.modelitem;
            me.continue();
        });
		if (this._devIncompleteItems != null)
		{
	        if (model.idstrlong in this._devIncompleteItems)
	        {
	            let isNewerThan = model.newerThan(this._devIncompleteItems[model.idstrlong]);
	            let isVersionEquals = !isNewerThan && !this._devIncompleteItems[model.idstrlong].newerThan(model);
	            if (isVersionEquals || isNewerThan)
	            {
	                listitem.errorMessage = this._sb.getString("incompleteWarning.map");
	                listitem.disabled = false;
	            }
	        }
		}
    },

    result : function()
    {
        return [this._selectedItem];
    }
}
extend(ShowItems, ttPage);
window.page = new ShowItems();
