/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function ShowLocalItems()
{
    ttSubTask.apply(this, arguments);
}
ShowLocalItems.prototype =
{
    name : "showLocalItems",
_devItems : null,
    
    start : function()
    {
        ttSubTask.prototype.start.apply(this, arguments);
        this.showItemsLoad();
    },

    showItemsLoad : function()
    {
        this._ttwizard.loadPage(
            this._constructPageURL("showItems"),
            null,
            makeCallback(this, this.showItemsLoadAsync),
            makeCallback(this, this.showItemsLoadCheck),
            makeCallback(this, this.showItemsDone)
            );
    },
doDeviceScan: function(successCallback)
    {
        this._devItems = new ttItemList();
        this._devItems.addFilter(new ttDependencyTreeBuilder());
        this._task.doDeviceScan(successCallback, errorAbortTask, this._devItems);
    },
    showItemsLoadAsync : function(page)
    {
        var me = this;
        this.doDeviceScan(function()
        {
            var devItems = me._devItems.contents;
            var itemlist = new ttItemList();
            
            itemlist.addFilter(new ttDuplicateFilter());
            itemlist.addFilter(new ExcludeItemsOnDeviceFilter(devItems));
            itemlist.addFilter(new ttDependencyTreeBuilder());
            page.inputStart([itemlist, devItems]);
            itemlist.addItemListFromDLL(gApplication.homeServices.localNavItems());
            page.inputDone();
        });
    },

    showItemsLoadCheck : function(result, successCallback, errorCallback)
    {
        successCallback();
    },
    
    showItemsDone : function(items)
    {
        this.subtaskDone(items);
    },
      
    __end : null
}
extend(ShowLocalItems, ttSubTask);
function ExcludeItemsOnDeviceFilter(devItems)
{
    ttItemListFilter.apply(this);
    this._devItems = {__proto__: null};
    for each (let item in devItems)
    {
        if (!(item instanceof ttNavItem && !item.isIncompleteInstall))
            continue;

        if (!(item.idurl in this._devItems) || !this._devItems[item.idurl].newerThan(item))
            this._devItems[item.idurl] = item;
        if (!(item.idstrlong in this._devItems) || !this._devItems[item.idstrlong].newerThan(item))
            this._devItems[item.idstrlong] = item;
        if (item.basemap)
            this._devItems[item.basemap] = item;
    }
}
ExcludeItemsOnDeviceFilter.prototype =
{
    itemsOnDevice : null,

    checkItem : function(item)
    {
        if (item instanceof ttMap && item.basemap)
        {
            if (!(item.basemap in this._devItems))
            {
                return [item];
            }
            else
            {
                return[];
            }
        }
        var devItem = null;
        if (item.idurl in this._devItems)
            devItem = this._devItems[item.idurl];
        else if (item.idstrlong in this._devItems)
            devItem = this._devItems[item.idstrlong];

        if (devItem && !item.newerThan(devItem))
            return [];
        else
            return [item];
    },
}
extend(ExcludeItemsOnDeviceFilter, ttItemListFilter);
