/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function Update(params)
{
    ttSubTask.apply(this, arguments);
    this._silent = (params && "silent" in params && params.silent);
    this._noAutoLogin = (params && "noAutoLogin" in params && params.noAutoLogin);
    this._restartUpdateTaskOnLoginChange = (params && "restartUpdateTaskOnLoginChange" in params && params.restartUpdateTaskOnLoginChange);

    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/update/update.properties");
}
Update.prototype =
{
    name : "update",
    _silent : false,
    _noAutoLogin : false,
    _restartUpdateTaskOnLoginChange : false,
    _callsOutstanding : null,
    _itemlist : null,
    _downloaded : null,
    _page : null,
    _doOnetimeDeviceUpdate : true,
    _onetimePrefName : null,
    _mapShareEnabled : false,
    _mapPatchesServerBusy : false,
    _poiPatchesServerBusy : false,
    _mapPatchesMap : null,
    _mapPatchesDownloadURL : null,
    _poiPatchesDownloadURL : null,
    _mapPatchesDownloadCount : 0,
    _poiPatchesDownloadCount : 0,
    _mapPatchesInCache : false,
    _mapPatchesFragments: null,
    _poiPatchesDownloadFile: null,
    _mapUpload : false,
    _safetycamUpload : false,
    _stringBundle : null,
    _mapShareData : null,
    _mapShareUploadObj : null,
    _safetyCamData : null,
    _safetyCamUploadObj : null,
    _devFuelPriceItems : null,
_devItems : null,

    get _safetyCamPrefForAutomotive()
    {
        return prefService().getBoolPref("tomtom.app.speedCamera.all.updates");
    },

    start : function()
    {
        ttSubTask.prototype.start.apply(this, arguments);
        this._devFuelPriceItems = { __proto__: null };
        this._task.needDevice(makeCallback(this, this.selectInstallLoad));
    },

    selectInstallLoad : function()
    {
        this._ttwizard.loadPage(
            this._constructPageURL("selectInstall"),
            { silent : this._silent,
              restartUpdateTaskOnLoginChange : this._restartUpdateTaskOnLoginChange },
            makeCallback(this, this.selectInstallLoadAsyncPrecond),
            makeCallback(this, this.selectInstallCheck),
            makeCallback(this, this.selectInstallDone)
            );
    },

    selectInstallLoadAsyncPrecond : function(page)
    {
        var me = this;
this.networkCall(rpc.init(function ()
        {
            var callback = makeCallback(me, function()
            {
                if (gApplication.deviceManager.activeDevice)
                    this.selectInstallLoadAsync(page);
            });

            if (me._noAutoLogin)
            {
                callback();
            }
            else if (me._silent)
            {
                if (gApplication.login.isLoggedIn)
                    callback();
                else
                    me.networkCall(gApplication.login.tryStoredLogin(callback, callback, callback));
            }
            else
            {
                me.networkCall(me._task.shouldLogin(callback, callback));
            }
        }, function (ex)
        {
            if (me._silent)
            {
                me._task.abort();
            }
            else
            {
                errorAbortTask(ex);
            }
        }));
    },
doDeviceScan: function(successCallback)
    {
        this._devItems = new ttItemList();
        this._devItems.addFilter(new ttDependencyTreeBuilder());
        this._task.doDeviceScan(successCallback, errorAbortTask, this._devItems);
    },

    getDeviceContentIDList : function(devItems, body, list)
    {
        var me = this;
        for each (var item in devItems)
        {
            if (item.idurl in list)
            {
                let previousItem = list[item.idurl];
                if (previousItem.newerThan(item))
                {
                    body.contentidlist.content.(@idurl == previousItem.idurlWithVersion).@idurl = item.idurlWithVersion;
                    list[item.idurl] = item;
                }
            }
            else
            {
                var content = <content/>;
                content.@idurl = item.idurlWithVersion;
                if(item instanceof ttMap)
                    content.@regions = item.regions;
                body.contentidlist.appendChild(content);

                list[item.idurl] = item;
            }
            if (item instanceof ttFuelPrice)
                me._devFuelPriceItems[item.idurl] = item;
        }
    },

    selectInstallLoadAsync : function(page)
    {
        var dev = gApplication.deviceManager.activeDevice;
        var devID = dev.id;
        var devCode = dev.deviceCode;
        var devSerial = dev.serial;
        var devModel = dev.model.id;
        var devCaps = gApplication.deviceManager.activeDeviceCapabilitiesString;
        var devParams = gApplication.deviceManager.activeDeviceParametersString;
        var devNavcore = dev.versionNavCore;
        var devNavcoreBuild = dev.buildNumberNavCore;{}
this._page = page;
        var me = this;

        var starttime = new Date();{}
this.doDeviceScan(function()
        {
var devItems = me._devItems.contents;
            var localItems = gApplication.itemFactory.createItemListFromDLL(
                                gApplication.homeServices.localNavItems());

            me._itemlist = new ttItemList();
            me._itemlist.addFilter(new ttDuplicateFilter());
            me._itemlist.addFilter(new UpdateFilter(devItems, localItems));
            me._itemlist.addFilter(new ttMapHierarchyFilter());
            me._itemlist.addFilter(new ttDependencyTreeBuilder());
            page.inputStart({itemlist: me._itemlist, selectedItems : devItems, devItems : me._devItems});

            var newestVersionsBody = <getnewestversions><contentidlist/></getnewestversions>;
            var newestVersionsList = {__proto__: null};
            me.getDeviceContentIDList(devItems, newestVersionsBody, newestVersionsList);
            me._doOnetimeDeviceUpdate = true;
            me._onetimePrefName = "tomtom.device." + devID + ".hadOnetimeUpdate";
            try {
                me._doOnetimeDeviceUpdate = !prefService().getBoolPref(me._onetimePrefName);
            } catch (e) {}
            if (!devNavcore)
                me._doOnetimeDeviceUpdate = false;{}
me._callsOutstanding = 0;
            me._callsOutstanding++;
            me.networkCall(rpc.call("shop", "getNewestVersions",
                {
                    price: "free",
                    includeMissing: true,
                    deviceCode: devCode,
                    deviceModel: devModel,
                    deviceCapabilities: devCaps,
                    deviceParameters: devParams,
                    deviceSerial: devSerial,
                    deviceNavcoreVersion: devNavcore,
                    deviceNavcoreBuild: devNavcoreBuild,
                    publicBeta: prefService().getBoolPref("tomtom.app.showBetaVersions"),
                    safetyCamera: me._safetyCamPrefForAutomotive
                },
                newestVersionsBody, RPC.METHOD_POST | RPC.USE_CACHE,
                makeCallback(me, me.callSucceeded),
                makeCallback(me, me.callFailed)));
            var args =
            {
                deviceCapabilities: devCaps,
                deviceParameters: devParams,
                deviceCode: devCode,
                deviceSerial: devSerial,
                deviceModel: devModel,
                deviceNavcoreVersion : devNavcore,
                deviceNavcoreBuild: devNavcoreBuild,
                publicBeta: prefService().getBoolPref("tomtom.app.showBetaVersions"),
                safetyCamera: me._safetyCamPrefForAutomotive
            };
            addSubscriptionsRPCArgs(args);
            me._callsOutstanding++;

            var accountLicensedContentBody = <getaccountalicensedcontent><contentidlist/></getaccountalicensedcontent>;
            var accountLicensedContentList = {5: null};
            me.getDeviceContentIDList(devItems, accountLicensedContentBody, accountLicensedContentList);
            me.networkCall(rpc.call("shop", "getAccountLicensedContent",
                args, accountLicensedContentBody, RPC.METHOD_POST & ~RPC.USE_CACHE,
                makeCallback(me, me.callSucceeded),
                makeCallback(me, function(e)
                {
                    if (e instanceof ServerError &&
                        e.code == 406)
                    {
                        this.callDone();
                    }
                    else
                    {
                        this.callFailed(e);
                    }
                })));

            var onetimeDeviceUpdatesBody = <onetimedeviceupdates><contentidlist/></onetimedeviceupdates>;
            var onetimeDeviceUpdatesList = {__proto__: null};
            me.getDeviceContentIDList(devItems, onetimeDeviceUpdatesBody, onetimeDeviceUpdatesList);
            if (me._doOnetimeDeviceUpdate)
            {
                me._callsOutstanding++;
                me.networkCall(rpc.call("shop", "onetimeDeviceUpdates",
                    {
                        deviceModel: devModel,
                        deviceCapabilities: devCaps,
                        deviceParameters: devParams,
                        deviceSerial: devSerial,
                        deviceCode: devCode,
                        deviceNavcoreVersion: devNavcore,
                        safetyCamera: me._safetyCamPrefForAutomotive
                    },
                    onetimeDeviceUpdatesBody, RPC.METHOD_POST,
                    function(result)
                    {
                        me.callSucceeded(result);
                    },
                    function(e)
                    {
                        if (e instanceof ServerError &&
                            e.code == 516)
                        {
                            me.callDone();
                            return;
                        }
                        me._doOnetimeDeviceUpdate = false;
                        me.callFailed(e);
                    }));
            }

            me.mapSharePreview();
            me.mapShareUploadQuestion();
            me.safetycamUploadQuestion();
        });
    },

    callSucceeded : function(result)
    {
        var serverItems = gApplication.itemFactory.createItemListFromServer(result);
        var serverFuelPriceItems = serverItems.filter(function (item) item instanceof ttFuelPrice);

        for each (var fuelprice in serverFuelPriceItems)
        {
            if (fuelprice.idurl in this._devFuelPriceItems)
            {
                fuelprice.setFuelType(this._devFuelPriceItems[fuelprice.idurl].fuelType, function() {}, unimportantError);
            }
        }

        this._itemlist.addItemListArray(serverItems);

        this.callDone();
    },

    callFailed : function(e)
    {
        if (e.code != 513 && e.code != 514)
            errorNonFatal(e);

        this.callDone();
    },

    callDone : function()
    {
        if (--this._callsOutstanding == 0)
        {

            var me = this;
            var dev = gApplication.deviceManager.activeDevice;
            if (!dev)
                return;
            this._page.inputDone({
                mapShareEnabled : me._mapShareEnabled,
                mapPatchesMap: me._mapPatchesMap,
                mapPatchesServerBusy : me._mapPatchesServerBusy,
                poiPatchesServerBusy : me._poiPatchesServerBusy,
                mapPatchesDownloadSize : me._mapPatchesDownloadSize,
                poiPatchesDownloadSize : me._poiPatchesDownloadSize,
                haveMapPatches : dev.mapShare && dev.mapShare.mapPatchDownloadsEnabled &&
                                  (me._mapPatchesDownloadCount || me._mapPatchesInCache),
                havePoiPatches : me._poiPatchesDownloadCount,
                haveMapUpload : me._mapUpload,
                haveSafetycamUpload : me._safetycamUpload,
                __end : null
            });

        }
},
selectInstallCheck : function(result, successCallback, errorCallback, returnCallback)
    {
        this.loginChanged = function() {};
        let dev  = gApplication.deviceManager.activeDevice;
        var me = this;
        gMainWindow._accountObserver = false;

        if(dev && !dev.isBusinessSolutionDevice && gApplication.login._forcedLoginPrefForUser)
        {
             this.networkCall(this._task.needLogin(function(){
                              if(gMainWindow._accountObserver)
                              {
                                top.gMainWindow.loadTaskByName("update");
                                returnCallback();
                              }
                              else
                              {
                                successCallback();
                              }
                             }
                             ,returnCallback));
        }
        else
        {
            successCallback();
        }
    },
selectInstallDone : function(result)
    {
        this.loginChanged = function() {};
        if (result.getMapPatches)
        {
            if (this._mapPatchesDownloadCount)
            {
                this._ttwizard.addCommit(
                    makeCallback(this, this.mapPatchesDownloadCommit),
                    null,
                    this._stringBundle.GetStringFromName("mapPatchesDownloadCommit"),
                    this.commitPriority);
                this._ttwizard.addCommit(
                    makeCallback(this, this.mapPatchesCacheInstallCommit),
                    null,
                    this._stringBundle.GetStringFromName("mapPatchesCacheInstallCommit"),
                    this.commitPriority);
            }
            this._ttwizard.addCommit(
                makeCallback(this, this.mapPatchesDeviceInstallCommit),
                null,
                this._stringBundle.GetStringFromName("mapPatchesDeviceInstallCommit"),
                this.commitPriority);
        }
        if (result.getPOIPatches)
        {
            this._ttwizard.addCommit(
                makeCallback(this, this.poiPatchesDownloadCommit),
                null,
                this._stringBundle.GetStringFromName("poiPatchesDownloadCommit"),
                this.commitPriority);
            this._ttwizard.addCommit(
                makeCallback(this, this.poiPatchesDeviceInstallCommit),
                null,
                this._stringBundle.GetStringFromName("poiPatchesDeviceInstallCommit"),
                this.commitPriority);
        }
        if (this._doOnetimeDeviceUpdate)
        {
            this._ttwizard.addCommit(
                makeCallback(this, this.onetimePrefCommit),
                null,
                this._stringBundle.GetStringFromName("onetimePrefCommit"),
                this.commitPriority);
        }
        if (result.doMapUpload)
        {
            this._ttwizard.addCommit(
                makeCallback(this, this.mapUploadRetrieveCommit),
                null,
                this._stringBundle.GetStringFromName("mapUploadRetrieveCommit"),
                this.commitPriority);
            this._ttwizard.addCommit(
                makeCallback(this, this.mapUploadCommit),
                null,
                this._stringBundle.GetStringFromName("mapUploadCommit"),
                this.commitPriority);
        }
        if (result.doSafetycamUpload)
        {
            this._ttwizard.addCommit(
                makeCallback(this, this.safetycamRetrieveCommit),
                null,
                this._stringBundle.GetStringFromName("safetycamRetrieveCommit"),
                this.commitPriority);
            this._ttwizard.addCommit(
                makeCallback(this, this.safetycamUploadCommit),
                null,
                this._stringBundle.GetStringFromName("safetycamUploadCommit"),
                this.commitPriority);
        }
        var mapShareSizeRequirements = {__proto__ : null};
        if (result.getMapPatches)
        {
            var map = this._mapPatchesMap;
            mapShareSizeRequirements[map.installLocation.path.path] = map.mapShareLocalCache.getPatchFilesSizeInBytes() - map.mapPatchSizeInBytes;
        }
        if (result.getPOIPatches)
        {
        }
        var dev = gApplication.deviceManager.activeDevice;
        if(dev && dev.isUsbDevice)
        {
            this._ttwizard.setAttribute("createbackup", false);
            this.installUpdate(result.items, mapShareSizeRequirements, false);
        }
        else
        {
            var backupPref = prefService().getIntPref("tomtom.backup.automatic");
            if (backupPref == 1)
            {
                this._ttwizard.setAttribute("createbackup", true);
                this.installUpdate(result.items, mapShareSizeRequirements, false);
            }
            else if((backupPref == 3))
            {
                this._ttwizard.setAttribute("createbackup", false);
                this.installUpdate(result.items, mapShareSizeRequirements, false);
            }
            else
            {
                this._ttwizard.setAttribute("createbackup", true);
                this.initiateBackupLoad(result.items, mapShareSizeRequirements, true);
            }
        }    
    },

    installUpdate : function(result, mapShareSize, createbackup, initiateBackup)
    {
            if(initiateBackup && this._ttwizard.getAttribute("createbackup") == "true")
            {
                var backUpAlways = this._ttwizard._wizbrowser.contentDocument.getElementById("alwaysbackup");
                if(backUpAlways.checked)
                {
                    prefService().setIntPref("tomtom.backup.automatic", 1);
                }
            }

            if(this._ttwizard.getAttribute("createbackup") == "true")
            {
                this.initiateBackup();
            }

            var installSubtask = new InstallSelectSome();
            installSubtask.commitPriority = this.commitPriority + 0.1;
            this.loadSubTask(installSubtask,
                { items: result, confirmSelection: false,
                additionalSizeRequirements: mapShareSize},
                makeCallback(this, this.installSubtaskDone)
                );

            this._ttwizard.addCommit(
                makeCallback(this, this.getRecommendedProductsCommit),
                null,
                this._stringBundle.GetStringFromName("recommendedProductsCommit"),
                this.commitPriority);
    },

    initiateBackup: function()
    {
        var deviceid = gApplication.deviceManager.activeDevice.id;
        try
        {
            var backupFolder = gApplication.settings.backupsDir;
            var backup = getLatestBackup(true, backupFolder);
            if (!backup)
            {
                var backups = gApplication.homeServices.backups();
                backups.setFolder(backupFolder);
                backup = backups.createEmptyBackup(deviceid);
            }

            this._ttwizard.addCommit(
                makeCallback(this, this.backupCommit),
                backup,
                getStringBundle("chrome://tthome/locale/ui/subtask/backup/backup.properties").GetStringFromName("creating.computer.backup"),
                this.commitPriority + 1);
        }
        catch(e)
        {
            errorNonFatal(e);
        }
    },
backupCommit : function(backup, progressCallback, successCallback, errorCallback)
    {
        var errorStrOut = { value : null };
        var severity    = { value : null };
        backup.checkPreconditionsBackupOk(severity, { value: null }, errorStrOut);
        if (severity.value != 0 && severity.value != CI.ttIError.kSeverityWarning)
        {
            errorCallback(errorStrOut.value);
            return new NoOpAbortable();
        }
        var me = this;
        return new Abortable(backup.doBackup(new BaseListener(function(percent)
                {
                    progressCallback(percent * 0.1, getStringBundle("chrome://tthome/locale/ui/subtask/backup/backup.properties").GetStringFromName("scanning"));
                },
                function(errorCode) {},
                errorCallback),
                new CopyListener(function (percent, text)
                {
                    progressCallback(10 + (percent * 0.9), text);
                },
                function()
                {
                     me.createBackup(successCallback);
                },
                errorCallback)
        ));
    },

    createBackup : function(successCallback)
    {
        var backupsDir = gApplication.settings.backupsDir;
        var backup = getLatestBackup(true, backupsDir);

        if (backup.location.isDirectory())
        {
            var dir = backup.location.clone();
            dir.append("backup.xml");
            if(dir.exists())
            {
                removeFile(dir, false);
            }
            dir.create(dir.NORMAL_FILE_TYPE, 0774);
        }

        var xml = '';
        var me= this;
        var items = [];
        var noOfScannedLocations = 0;
        var installLocations = gApplication.deviceManager.getInstallLocationsForDevice();
        var devItems = new ttItemList();
        devItems.addFilter(new ttDependencyTreeBuilder());
        for (let i = 0; i < installLocations.length ; i++)
        {
            var installLocationName = installLocations[i];
            installLocationName.deviceNavItems().populate(
                new ScanListener(function() {},
                        function()
                        {
                            devItems.addItemListFromDLL(installLocationName.deviceNavItems());
                            items = devItems.contents;
                            noOfScannedLocations++;
                            if(noOfScannedLocations == (installLocations.length))
                            {
                                me.writeXml(items, dir, successCallback);
                            }
                        },
                        error
                        ));
        }
    },

    writeXml : function(items, dir, successCallback)
    {
        var gDLLUtilsStringBundle = getStringBundle("chrome://tthome/locale/logic/dllUtils.properties");
        var table = <TomTomXml version="1.0"/>;
        var sortedItemList = items.sort(function (a,b){ return b['typePriority'] - a['typePriority']});
        for each(let item in sortedItemList)
        {
            var xml = this.createXML(item);
            table.appendChild(xml);
        }
        writeStringToFile(dir, table.toXMLString());
        successCallback(gDLLUtilsStringBundle.GetStringFromName("copyDone"));
    },

    createXML : function(item)
    {
        var xml = <Item />;
        xml.name = encodeURIComponent(item['name']);
        xml.description = encodeURIComponent(item['description']);
        xml.version = item['version'];
        xml.size = item['size'];
        xml.typeID = item['typeID'];
        if(item['icon'])
        xml.icon = item['icon']['url'];
        return xml;
    },


    initiateBackupLoad : function(result, mapShareSize, createbackup)
    {
        var installSubtask = new InstallSelectSome();
        this._ttwizard.loadPage(
            this._constructPageURL("initiateUpdate"),
            null,
            null,
            null,
            makeCallback(this, this.installUpdate, result, mapShareSize, createbackup, 'true')
            );
    },

    installSubtaskDone : function(result)
    {
        this.subtaskDone();
    },

    taskDone : function(result)
    {
        ttSubtask.prototype.taskDone.apply(this, result);
    },
loginChanged : function()
    {
        if (!this._itemlist)
        {
            return;
        }
        this._task.interrupt(makeCallback(this, function()
        {
            if (this._restartUpdateTaskOnLoginChange)
            {
                var params = this._task.startParams;
                params.noAutoLogin = true;
                top.gMainWindow.loadTaskByName("update", params);
            }
            else
            {
                top.gMainWindow.goHome();
            }
        }));
    },
mapShareUploadQuestion : function()
    {
        try {
            var dev = gApplication.deviceManager.activeDevice;
            if (!dev.mapShare)
                return;

            this._mapShareEnabled = true;
            this._mapUpload = (dev.mapShare.mapShareUpload ? dev.mapShare.mapShareUpload.dataAvailable : false);{}
} catch (e) { errorNonFatal(e) }
    },
safetycamUploadQuestion : function()
    {
        try {
            var enabled = true;
            try {
                enabled = prefService().getBoolPref("tomtom.device.all.safetycam.upload.enabled") &&
                          rpc.serviceBaseURL("safetycamUpload");
            } catch (e) {}
            if (!enabled)
                return;
            this._safetycamUpload = gApplication.deviceManager.activeDevice
                .safetyCameraUpload.dataAvailable;{}
} catch (e) { errorNonFatal(e) }
    },
mapSharePreview : function()
    {
        try {
            var dev = gApplication.deviceManager.activeDevice;
            if (!dev.mapShare)
            {
return;
            }
this._mapShareEnabled = true;

            this._mapPatchesMap = dev.activeMap;
            if (!this._mapPatchesMap)
            {
return;
            }
var serverURL = rpc.serviceBaseURL("mapShare");
            if (!serverURL)
                return;{}
var me = this;
            this._callsOutstanding++;
            gApplication.homeServices.setMapShareLocalCacheFolder(
                gApplication.settings.mapShareCacheDir,
                new ScanListener(function() {}, function()
            {
me.mapShareMapPreview(dev, serverURL);
                me.mapSharePOIPreview(dev, serverURL);
                me._mapPatchesInCache = me._mapPatchesMap.lastAppliedMapPatchVersion < me._mapPatchesMap.mapShareLocalCache.lastAppliedMapPatchVersion;
                me.callDone();
            },
            makeCallback(this, this.callFailed)
            ));
        } catch (e) { errorNonFatal(e) }
    },
mapShareMapPreview : function(dev, serverURL)
    {
        try {
            if (!dev.mapShare.mapPatchDownloadsEnabled)
            {
return;
            }
            var mapParams = new Object();
            mapParams.version = dev.mapShare.patchFormatVersion;
            mapParams.mapId = this._mapPatchesMap.pna;
            mapParams.releaseId = this._mapPatchesMap.buildNumber;
            mapParams.patchLevel = this._mapPatchesMap.mapShareLocalCache.lastAppliedMapPatchVersion;
            mapParams.deviceModel = dev.model.id;
            mapParams.deviceSerial = dev.serial;
            mapParams.characterSet = dev.parameter("CharacterSet");
            mapParams.navCore = dev.versionNavCore + "." + dev.buildNumberNavCore;
            mapParams.fspace = this._mapPatchesMap.installLocation.sizeInBytesFree;
            mapParams.currentSourceCategory = 0;
            mapParams.futureSourceCategory = 0;
            mapParams.installedSizeByCountry = false;
            mapParams.preview = true;
            var mapPatchPreviewURL = serverURL.spec + "patches" +
                               mapShareCreateURLQueryParams(mapParams);
            mapParams.preview = false;
            mapParams.currentSourceCategory =
                this._mapPatchesMap.mapShareLocalCache.currentTrustLevel -
                CI.ttIMapShareLocalCache.kTrustLevelTomTomVerified;
            this._mapPatchesDownloadURL = serverURL.spec + "patches" +
                               mapShareCreateURLQueryParams(mapParams);

            var me = this;
            this._callsOutstanding++;
            this.networkCall(fetchHTTP.fetch(mapPatchPreviewURL, null, false, null, function(result)
            {
                if (typeof result != "xml")
                {
                    me.callFailed(me._stringBundle.GetStringFromName("noXMLResponse"));
                    return;
                }
                me._mapPatchesDownloadCount = 0;
                me._mapPatchesDownloadSize = 0;
                if (result.*::nbrOfPatches.length())
                    me._mapPatchesDownloadCount = makeSafe.integer(result.*::nbrOfPatches);
                if (result.*::responseSize.length())
                {
                    var size = makeSafe.integer(result.*::responseSize);
                    me._mapPatchesDownloadSize = size;
                }
                me.callDone();
            },
            function(e)
            {
                if (e.code == Components.results.NS_ERROR_OFFLINE ||
                    e.code == Components.results.NS_ERROR_UNKNOWN_HOST ||
                    e.code == Components.results.NS_ERROR_UNKNOWN_PROXY_HOST ||
                    e.code == -503 || e.code == -500)
                {
                    me._mapPatchesServerBusy = true;
                    unimportantError(e);
                    me.callDone();
                }
                else
                {
                    me.callFailed(e);
                }
            }));

        } catch (e) { errorNonFatal(e) }
    },
mapSharePOIPreview : function(dev, serverURL)
    {
        try {
            if (!dev.mapShare.poiPatchDownloadsEnabled || !dev.mapShare.mapPatchDownloadsEnabled)
            {
return;
            }

            var categories = "";
            var subscriptions = IteratorToArray(dev.mapShare.mapSharePOISubscriptions,
                                                CI.ttIMapSharePOISubscription);

            var versionsIterator = this._mapPatchesMap.mapSharePOIInfoList;
            var versionsMap = new Object();
            while (versionsIterator.hasMoreElements())
            {
                var cur = versionsIterator.getNext()
                          .QueryInterface(CI.ttIMapSharePOIPatchInfo);
                versionsMap[cur.category] = cur.version;
            };

            for (let i = 0; i < subscriptions.length; i++)
            {
                var cat = subscriptions[i];
                if (!cat.subscribed)
                    continue;
                if (categories != "")
                    categories += ",";
                categories += cat.category;

                var version = versionsMap[cat.category];
                if (version)
                    categories += ":" + version;
            }
{}
if (!categories)
                return;

            var poiParams = new Object();
            poiParams.version = dev.mapShare.patchFormatVersion;
            poiParams.poiTypes = "new,modify,delete";
            poiParams.mapId = this._mapPatchesMap.pna;
            poiParams.releaseId = this._mapPatchesMap.buildNumber;
            poiParams.deviceModel = dev.model.id;
            poiParams.deviceSerial = dev.serial;
            poiParams.characterSet = dev.parameter("CharacterSet");
            poiParams.navCore = dev.versionNavCore + "." + dev.buildNumberNavCore;
            poiParams.fspace = this._mapPatchesMap.installLocation.sizeInBytesFree;
            poiParams.sourceCategory = 4;
            poiParams.poiCategories = categories;

            poiParams.preview = true;
            var poiPrevewURL = serverURL.spec + "poiRequest" +
                               mapShareCreateURLQueryParams(poiParams);

            poiParams.preview = false;
            this._poiPatchesDownloadURL = serverURL.spec + "poiRequest" +
                               mapShareCreateURLQueryParams(poiParams);

            var me = this;
            this._callsOutstanding++;
            this.networkCall(fetchHTTP.fetch(poiPrevewURL, null, false, null, function(result)
            {
                if (typeof result != "xml")
                {
                    me.callFailed(me._stringBundle.GetStringFromName("noXMLResponse"));
                    return;
                }
                me._poiPatchesDownloadCount = 0;
                me._poiPatchesDownloadSize = 0;
                if (result.*::nbrOfPois.length())
                    me._poiPatchesDownloadCount = makeSafe.integer(result.*::nbrOfPois);
                if (result.*::responseSize.length())
                {
                    var size = makeSafe.integer(result.*::responseSize);
                    me._poiPatchesDownloadSize = size;
                }
                me.callDone();
            },
            function(e)
            {
                if (e.code == Components.results.NS_ERROR_OFFLINE ||
                    e.code == Components.results.NS_ERROR_UNKNOWN_HOST ||
                    e.code == Components.results.NS_ERROR_UNKNOWN_PROXY_HOST ||
                    e.code == -503 || e.code == -500)
                {
                    me._poiPatchesServerBusy = true;
                    unimportantError(e);
                    me.callDone();
                }
                else
                {
                    me.callFailed(e);
                }
            }));

        } catch (e) { errorNonFatal(e) }
    },
mapPatchesDownloadCommit : function(ignored, progressCallback, successCallback, errorCallback)
    {
        var tempDir = gApplication.settings.osTempDir;

        var me = this;

        var targetFile = tempDir.clone();
        targetFile.append("TomTomMapPatches");

        var downloadURL = getIOService().newURI(this._mapPatchesDownloadURL, null, null);
var patchesCombinedCall = new CombinedCall(new Downloader().download(
            downloadURL, targetFile, progressCallback,
            function (file)
            {
                var str = "";
                try {
                    var fstream = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(CI.nsIFileInputStream);
                    fstream.init(file,
0x01, 0644, 0);

                    try {
                        var sstream = Cc["@mozilla.org/scriptableinputstream;1"].createInstance(CI.nsIScriptableInputStream);
                        sstream.init(fstream);

                        try {
                            str = sstream.read(1024);
                        } finally {
                            sstream.close();
                        }
                    } finally {
                        fstream.close();
                    }
                } catch (e) {
                    errorCallback(e);
                    return;
                }

                if (str.indexOf("http://www.tomtom.com/map/patches/2/4") != -1)
                {
me._mapPatchesFragments =
                    {
                        downloadedMapPatchFiles : new ArrayIterator([file]),
                        isFragments : false
                    };
                    successCallback(me._stringBundle.GetStringFromName("mapPatchesDownloadCommitDone"));
                }
                else if (str.indexOf("http://www.tomtom.com/map/patches/2/4/1") != -1)
                {
                    var ampNS = new Namespace("http://www.tomtom.com/map/patches/2/4/1");{}
var data = readFile(file).join("\n");
                    try {
                        file.remove();
                    } catch(e) { unimportantError(e); }

                    var mapPatchList = new XML(data.replace(/<\?xml[^>]*\?>/, ""));
                    var totalFragments = mapPatchList.ampNS::patchFragmentURI.length();
                    if (totalFragments > 0)
                    {
                        var fragmentsArray = new Array();
                        var downloadedFragments = 0;

                        for each (var fragmentURL in mapPatchList.ampNS::patchFragmentURI)
                        {
                            fragmentURL = makeSafe.url(fragmentURL);
                            var leafName = fragmentURL.fileName;
                            var filePath = tempDir.clone();
                            assert(leafName.length > 0, "MapShare fragments URI must contain a leafName");
                            filePath.append(leafName);
                            patchesCombinedCall.addCall(new Downloader().download(fragmentURL, filePath, function() {},
                                function (fragment)
                                {
                                    fragmentsArray.push(fragment);
                                    progressCallback(Math.round((++downloadedFragments / totalFragments) * 100));

                                    if (downloadedFragments == totalFragments)
                                    {
                                        me._mapPatchesFragments =
                                        {
                                            downloadedMapPatchFiles : new ArrayIterator(fragmentsArray),
                                            isFragments : true
                                        };
                                        successCallback(me._stringBundle.GetStringFromName("mapPatchesDownloadCommitDone"));
                                    }
                                }, errorCallback));
                        }
                    }
                    else
                        throw new Exception(me._stringBundle.GetStringFromName("mapPatchesListEmptyException"));
                }
                else
                    throw new Malformed("MapShare protocol version must be specified within the first 1024 bytes in response from " + downloadURL + ".", str, "Internal/Malformed/#MapShare/XML");
            }, errorCallback));

        return patchesCombinedCall;
    },
mapPatchesCleanUp : function()
    {
        if (this._mapPatchesFragments)
        {
            while (this._mapPatchesFragments.downloadedMapPatchFiles.hasMoreElements())
            {
                try
                {
                    var fragment = enumerator.getNext().QueryInterface(CI.nsIFile);
                    removeFile(fragment);
                } catch (e) {
                    unimportantError(e);
                }
            }
        }
    },
mapPatchesCacheInstallCommit : function(ignored, progressCallback, successCallback, errorCallback)
    {
        assert(this._mapPatchesFragments, "this._mapPatchesFragments must not be null");
        var cacheInstaller = this._mapPatchesMap.mapShareLocalCache.createMapPatchesInstaller(
                                this._mapPatchesFragments.downloadedMapPatchFiles, this._mapPatchesFragments.isFragments);
        var me = this;
        return new Abortable(cacheInstaller.doInstall(new CopyListener(
        progressCallback,
        function()
        {
            me.mapPatchesCleanUp();
            successCallback(me._stringBundle.GetStringFromName("mapPatchesCacheInstallCommitDone"));
        },
        function(e)
        {
            e = addDebugInfo(e, "Map patches download URL: " + me._mapPatchesDownloadURL);

            me.mapPatchesCleanUp();
            errorCallback(e);
        })));
    },
mapPatchesDeviceInstallCommit : function(ignored, progressCallback, successCallback, errorCallback)
    {
        var installer = this._mapPatchesMap.createMapPatchesInstaller();
        var me = this;
        return new Abortable(installer.doInstall(new CopyListener(
        progressCallback,
        function()
        {
            successCallback(me._stringBundle.GetStringFromName("mapPatchesDeviceInstallCommitDone"));
        },
        function(e)
        {
            e = addDebugInfo(e, me._mapPatchesDownloadURL ?
                                "Map patches download URL: " + me._mapPatchesDownloadURL :
                                "Map patches installed from existing cache, no new download");

            errorCallback(e);
        })));
    },
poiPatchesDownloadCommit : function(ignored, progressCallback, successCallback, errorCallback)
    {
        var targetFile = gApplication.settings.osTempDir;
        targetFile.append("TomTomPOIPatches");
        var me = this;
        return new Downloader().download(
            makeSafe.url(this._poiPatchesDownloadURL),
            targetFile,
        progressCallback,
        function(file)
        {
            me._poiPatchesDownloadFile = file;
            successCallback(me._stringBundle.GetStringFromName("poiPatchesDownloadCommitDone"));
        },
        errorCallback);
    },
poiPatchesDeviceInstallCommit : function(ignored, progressCallback, successCallback, errorCallback)
    {
        var me = this;
        var installer = me._mapPatchesMap.createPOIPatchesInstaller(me._poiPatchesDownloadFile);
        return new Abortable(installer.doInstall(new CopyListener(
        progressCallback,
        function()
        {
            successCallback(me._stringBundle.GetStringFromName("poiPatchesDeviceInstallCommitDone"));
        },
        function(e)
        {
            e = addDebugInfo(e, "POI patches download URL: " + me._poiPatchesDownloadURL);

            errorCallback(e);
        })));
    },

    mapUploadRetrieveCommit : function(ignored, progressCallback, successCallback, errorCallback)
    {
        this._mapShareData = [];

        var email = "";
        try {
            if (prefService().getBoolPref("tomtom.mapshare.feedback"))
            {
                email = prefService().getCharPref("tomtom.device.all.mapShare.upload.feedbackEmailAddress");
                if (!email)
                    email = gApplication.login.getDefaultUsername();
            }
        } catch (e) { unimportantError(e); }

        var mapShare = gApplication.deviceManager.activeDevice.mapShare;
        mapShare.feedbackEmailAddress = email;

        this._mapShareUploadObj = mapShare.mapShareUpload;
        var me = this;

        return new Abortable(this._mapShareUploadObj.readData(new ProgressListener(progressCallback, function()
        {
            var dataIter = me._mapShareUploadObj.data;

            if (!dataIter.hasMoreElements())
                unimportantError(new Exception("DLL promised there was MapShare map correction data to upload, but there is none"));

            while (dataIter.hasMoreElements())
                me._mapShareData.push(dataIter.getNext().QueryInterface(CI.nsISupportsString).data);
            successCallback(me._stringBundle.GetStringFromName("mapUploadRetrieveCommitDone"));
        }, errorCallback)));
    },
mapUploadCommit : function(ignored, progressCallback, successCallback, errorCallback)
    {
        var serverBaseURL = rpc.serviceBaseURL("mapShare");
        if (!serverBaseURL)
        {
            errorCallback(new Exception(this._stringBundle.GetStringFromName("mapUploadServerNotFound")));
            return new NoOpCall();
        }
        var serverURL = makeSafe.url("submission", serverBaseURL);{}
var me = this;
        var uploadsOk = 0, uploadsFail = 0, uploadsTotal = this._mapShareData.length;
        var progressStep = 100 / uploadsTotal;

        var lastUploadError = null;
        function onDoneUploading()
        {
            if (uploadsFail > 0)
            {
                errorCallback(new ExceptionWithCustomMessage(
                    me._stringBundle.GetStringFromName("mapUploadCommitError"),
                    lastUploadError));
            }
            else
            {
                me._mapShareUploadObj.cleanupData();
                successCallback(me._stringBundle.GetStringFromName("mapUploadCommitDone"));
            }
        }

        var calls = new CombinedCall();
        for each (var uploadItem in this._mapShareData)
        {
            calls.addCall(fetchHTTP.fetch(
                serverURL.spec, null, true,
                uploadItem, function()
                {
                    uploadsOk++;
                    progressCallback((uploadsOk + uploadsFail) * progressStep,
                                     me._stringBundle.GetStringFromName("mapUploadCommitUploadProcessed"));

                    if (uploadsOk + uploadsFail == uploadsTotal)
                        onDoneUploading();
                },
                function(e)
                {
                    unimportantError(e);

                    uploadsFail++;
                    progressCallback((uploadsOk + uploadsFail) * progressStep,
                                     me._stringBundle.GetStringFromName("mapUploadCommitUploadProcessed"));

                    lastUploadError = e;

                    if (uploadsOk + uploadsFail == uploadsTotal)
                        onDoneUploading();
                }));
        }

        return calls;
    },

    safetycamRetrieveCommit : function(ignored, progressCallback, successCallback, errorCallback)
    {
        this._safetyCamData = [];
        this._safetyCamUploadObj = gApplication.deviceManager.activeDevice.safetyCameraUpload;
        var me = this;

        return new Abortable(this._safetyCamUploadObj.readData(new ProgressListener(progressCallback, function()
        {
            var dataIter = me._safetyCamUploadObj.data;

            if (!dataIter.hasMoreElements())
                unimportantError(new Exception("DLL promised there was SafetyCam data to upload, but there is none"));

            while (dataIter.hasMoreElements())
                me._safetyCamData.push(dataIter.getNext().QueryInterface(CI.nsISupportsString).data);
            successCallback(me._stringBundle.GetStringFromName("safetycamRetrieveDone"));
        }, errorCallback)));
    },
safetycamUploadCommit : function(ignored, progressCallback, successCallback, errorCallback)
    {
        var serverURL = rpc.serviceBaseURL("safetycamUpload");
        if (!serverURL)
        {
            errorCallback(new Exception(this._stringBundle.GetStringFromName("safetycamUploadServerNotFound")));
            return new NoOpCall();
        }

        var me = this;
        var uploadsOk = 0, uploadsFail = 0, uploadsTotal = this._safetyCamData.length;
        var progressStep = 100 / uploadsTotal;

        var lastUploadError = null;
        function onDoneUploading()
        {
            if (uploadsFail > 0)
            {
                unimportantError(new ExceptionWithCustomMessage(
                    me._stringBundle.GetStringFromName("safetycamUploadCommitError"),
                    lastUploadError));
                successCallback(me._stringBundle.GetStringFromName("safetycamUploadCommitErrorUserMessage"));
            }
            else
            {
                me._safetyCamUploadObj.cleanupData();
                successCallback(me._stringBundle.GetStringFromName("safetycamUploadCommitDone"));
            }
        }

        var calls = new CombinedCall();
        for each (var uploadItem in this._safetyCamData)
        {
            calls.addCall(fetchHTTP.fetch(
                serverURL.spec, null, true,
                uploadItem, function()
                {
                    uploadsOk++;
                    progressCallback((uploadsOk + uploadsFail) * progressStep,
                                     me._stringBundle.GetStringFromName("safetycamUploadCommitUploadProcessed"));

                    if (uploadsOk + uploadsFail == uploadsTotal)
                        onDoneUploading();
                },
                function(e)
                {
                    unimportantError(e);

                    uploadsFail++;
                    progressCallback((uploadsOk + uploadsFail) * progressStep,
                                     me._stringBundle.GetStringFromName("safetycamUploadCommitUploadProcessed"));

                    lastUploadError = e;

                    if (uploadsOk + uploadsFail == uploadsTotal)
                        onDoneUploading();
                }));
        }

        return calls;
    },
onetimePrefCommit : function(ignored, progressCallback, successCallback, errorCallback)
    {
        try {
            prefService().setBoolPref(this._onetimePrefName, true);
        } catch (e) { errorNonFatal(e); }
        successCallback(this._stringBundle.GetStringFromName("onetimePrefCommitDone"));
        return new NoOpCall();
    },
getRecommendedProductsCommit : function(ignored, progressCallback, successCallback, errorCallback)
    {
        var me = this;
        var recommendedProducts = new ttItemList();
        var pageDocument = this._ttwizard._wizbrowser.contentDocument;
        var overlayObserver =
        {
            observe : function()
            {
var listbox = pageDocument.getElementById("listbox");
                listbox.addObserver(
                {
                    addedListItem : function(listitem)
                    {
                        var model = listitem.modelitem;
                        if (!model.price)
                        {
return;
                        }
                        if (model.price.free)
                        {
                            listitem.addButton(me._stringBundle.GetStringFromName("recommendedProductsFree"), function(listitem)
                            {
                                if (listitem.modelitem.typeID == "mapsubscription")
                                {
                                    top.MapSubscription.offerMapSubscriptionDeal(true, "mapshop");
                                }
                                else
                                {
                                    top.gMainWindow.loadTaskByName("installSelectSome",{items:[model], confirmSelection:true});
                                }
                            });
                        }
                        else
                        {
                            var buttonLabel = me._stringBundle.GetStringFromName("recommendedProductsBuy");
                            if (model.userIsOrWasSubscribed)
                            {
                                buttonLabel = me._stringBundle.GetStringFromName("recommendedProductsRenew");
                            }

                            listitem.addButton(buttonLabel, function(listitem)
                            {
                                if (listitem.modelitem.typeID == "mapsubscription")
                                {
                                    top.MapSubscription.offerMapSubscriptionDeal(true, "mapshop");
                                }
                                else
                                {
                                    gApplication.cart.addItem(listitem.modelitem);
                                    top.gMainWindow.loadTaskByName("checkout");
                                }
                            });
                        }
                    },

                    removedListItem : function(listitem){}
                });
                listbox.addItemList(recommendedProducts);
                listbox.doneLoading = true;
            },

            QueryInterface : function(iid)
            {
                if ( iid.equals(CI.nsIObserver) ||
                     iid.equals(CI.nsISupports)) {
                    return this;
                }
                throw Components.results.NS_NOINTERFACE;
            }
        };

        var dev = gApplication.deviceManager.activeDevice;
        var activemapid = dev.activeMap ? dev.activeMap.id : "";
        var args =
        {
            deviceModel: dev.model.id,
            deviceCapabilities: gApplication.deviceManager.activeDeviceCapabilitiesString,
            deviceParameters: gApplication.deviceManager.activeDeviceParametersString,
            deviceNavcoreVersion: dev.versionNavCore,
            deviceSerial: dev.serial,
            deviceCode: dev.deviceCode,
            activeMapID: activemapid,
            publicBeta: prefService().getBoolPref("tomtom.app.showBetaVersions"),
            safetyCam: this._safetyCamPrefForAutomotive
        };
        addSubscriptionsRPCArgs(args);
        var callBody = <proposed><contentidlist/></proposed>;
        var extensions = ttExtension.prototype.importItemsFromExtensionManager();
        var themes = ttTheme.prototype.importItemsFromExtensionManager();
        for each (var item in this._devItems.contents.concat(extensions).concat(themes))
        {
            callBody.contentidlist.appendChild(<content idurl={item.idurlWithVersion}/>);
        }

        return rpc.call("shop", "getProposedDownloads",
            args, callBody, RPC.METHOD_POST | RPC.USE_CACHE,
            function(result)
            {
                let serverItems = gApplication.itemFactory.createItemListFromServer(result);
                recommendedProducts.addItemListArray(serverItems, true);
                if (recommendedProducts.contents.length > 0)
                    pageDocument.loadOverlay("chrome://tthome/content/ui/subtask/update/recommendedProductsOverlay.xul", overlayObserver);
                successCallback(me._stringBundle.GetStringFromName("recommendedProductsCommitDone"));
            },
            function(e)
            {
successCallback(me._stringBundle.GetStringFromName("recommendedProductsCommitDone"));
                unimportantError(e);
            });
    },

    __end : null
}
extend(Update, ttSubTask);
function mapShareCreateURLQueryParams(args)
{
    var result = "";
    for (var name in args)
    {
        if (result == "")
            result = "?"
        else
            result += "&";
        result += name + "=" + encodeURIComponent(args[name]);
    }
    return result;
}
function addDebugInfo(e, debugInfo)
{
    var wrapper =
    {
        toString: function()
        {
            return this.__proto__.toString() + "\n" + debugInfo;
        }
    };
    wrapper.__proto__ = e;
    return wrapper;
}
function UpdateFilter(devItems, localItems)
{
    ttItemListFilter.apply(this);

    this._devItems = {__proto__: null};
    this._devIncompleteItems = {__proto__: null};

    for each (let item in devItems)
    {
        for each (let id in item.significantIDs)
        {
            if (item instanceof ttNavItem && item.isIncompleteInstall)
            {
                this._devIncompleteItems[id] = item;
            }
            else if (!(id in this._devItems) || this._devItems[id].newerThan(item))
                this._devItems[id] = item;
        }
    }

    this._localItems = {__proto__: null};
    for each (let item in localItems)
    {
        this._localItems[item.idurl] = item;
        this._localItems[item.idstrlong] = item;
    }

    this.resetAll();
}
UpdateFilter.prototype =
{
    _devItems: null,
    _devIncompleteItems: null,
    _localItems: null,
_zones: null,
checkItem: function(item)
    {
                    if (this._devIncompleteItems != null)
                    {
                            if (!(item.idurl in this._devIncompleteItems) || !(item.idstrlong in this._devIncompleteItems))
                            {
                                    if (item instanceof ttMap && item.basemap)
                                    {
                                      if (!(item.idurl in this._devItems) && item.idstr != item.basemap)
                                      {
                                            return [];
                                      }
                                    }
                                    var devItem = null;
                                    for each (let id in item.significantIDs)
                                    {
                                            if (id in this._devItems)
                                            {
                                                    devItem = this._devItems[id];
                                                    break;
                                            }
                                    }

                                    if (devItem && !item.newerThan(devItem))
                                            return [];
                                    var localItem = null;
                                    if (item.idurl in this._localItems)
                                            localItem = this._localItems[item.idurl];
                                    else if (item.idstrlong in this._localItems)
                                            localItem = this._localItems[item.idstrlong];

                                    if (localItem && gApplication.deviceManager.activeDevice &&
                                            !(localItem instanceof ttProgram) &&
                                            !(localItem instanceof ttPartialUpdate) &&
                                            localItem.canInstallOn(gApplication.deviceManager.activeDevice) == 0 &&
                                            !(localItem.idurl in this._devItems) && !(localItem.idstrlong in this._devItems))
                                    {
                                            return [];
                                    }
                                    for each (var dependency in item.dependencies)
                                    {
                                            if (dependency.idstrlong && dependency.idstrlong in this._devItems && dependency.matches(this._devItems[dependency.idstrlong]))
                                                    continue;

                                            if (dependency.idurl && dependency.idurl in this._devItems && depencency.matches(this._devItems[dependency.idurl]))
                                                    continue;
                                            return [];
                                    }
                            }
                    }

        return [item];
    },

    resetAll: function()
    {
      this._zones = {__proto__: null};
    }
}
extend(UpdateFilter, ttItemListFilter);
