/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function BuyAndInstall(arg)
{
    ttTask.apply(this, arguments);
}
BuyAndInstall.prototype =
{
    name : "BuyAndInstall",
    startParams : null,

    init : function()
    {
        ttTask.prototype.init.apply(this, arguments);
        this.shopSelect = new ShopSelect();
        this.checkout = new Checkout();
        this.install = new InstallSelectSome();
    },

    start : function(args)
    {
        ttTask.prototype.start.apply(this, arguments);
        this.shopSelectLoad(args.contentType, args.searchString);
        this.startParams = args;
    },
_deviceRemoved : function ()
    {
        if(this._ttwizard)
        {
            let commitPage = this._ttwizard._wizbrowser.contentWindow.page;
            if (commitPage && !commitPage._done && commitPage._disconnect)
            {
                commitPage._disconnect = false;
                commitPage.disturbedDownload(true);
                this._ttwizard.cancelCommit();
                commitPage.loadDisconnectDeviceErrorMessage();
            }
        }

    },

    shopSelectLoad : function(contentType, searchString)
    {
        this.loadSubTask(this.shopSelect,
                         {contentType: contentType, searchString: searchString},
                         makeCallback(this, this.shopSelectDone));
    },

    shopSelectDone : function(items)
    {
        var immediateInstallItems = items.filter(function(item)
            {
                return (!item.price || item.price.free || item.isLocal) && !item.hasNoDownload;
            });

        if (items.length == 0)
        {
            this.taskDone();
        }
        else if (immediateInstallItems.length > 0)
        {
            this.installLoad(immediateInstallItems, false);
        }
        else
        {
            this.checkoutLoad();
        }
    },

    checkoutLoad : function()
    {
        this.loadSubTask(this.checkout, null,
            makeCallback(this, this.checkoutDone)
            );
    },
    checkoutDone : function(items)
    {
        this.installLoad(items, true);
    },

    installLoad : function(items, confirmSelect)
    {
        if (items.length == 0)
        {
this.taskDone();
            return;
        }

        this.loadSubTask(this.install,
            { items: items, confirmSelection: confirmSelect },
            makeCallback(this, this.installDone)
            );
    },
    installDone : function(items)
    {
        this.taskDone();
    },

    __end : null
}
extend(BuyAndInstall, ttTask);
var task = new BuyAndInstall();
