/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/


function MapZonesTask(arg)
{
    ttTask.apply(this, arguments);
}
MapZonesTask.prototype =
{
    name : "mapZones",
    origMap : null,
    devItems : null,
    resultCallback : null,

    start : function(args)
    {
        ttTask.prototype.start.apply(this, arguments);

        this.origMap = args.map;
        this.devItems = args.devItems;
        this.resultCallback = args.resultCallback;

        this.loadSubTask(new MapZones(),
            { item : this.origMap,
              insideInstallFlow : false,
              installedItems : [],
              devItems : this.devItems,
              additionalSizeRequirements : null,
              freeSpaceBuffer : kFreeSpaceBuffer },
            makeCallback(this, this.zoneSelectionDone)
            );
    },

    zoneSelectionDone : function(zone)
    {
        if (this.resultCallback)
        {
            this.taskDone();
            this.resultCallback(zone);
            return;
        }

        if (!zone || zone.idstr == this.origMap.idstr)
        {
            this.taskDone();
            return;
        }

        this.loadSubTask(new InstallSelectSome(),
            { items: [zone], confirmSelection: false },
            makeCallback(this, this.installDone)
            );
    },

    installDone : function()
    {
        this.taskDone();
    },

    __end : null
}
extend(MapZonesTask, ttTask);
var task = new MapZonesTask();
