/*
  @Copyright (C) 2006-2012, TomTom International B.V. All rights reserved.
*/



function E(id)
{
  return document.getElementById(id);
}

const kNS_HTML = "http://www.w3.org/1999/xhtml";
const kNS_XUL = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
function handleOutsideLinks(event)
{
    var linkNode = getLinkNode(event);

    if ( ! linkNode ||
        linkNode.href.indexOf(linkNode.ownerDocument.URL + "#") == 0)
    {
        return;
    }

    var protocol = linkNode.protocol;
    if (protocol)
    {
        if (protocol != "file:" && protocol != "javascript:" && protocol != "jar:")
        {
            event.preventDefault();
            if (protocol == "webid:")
            {
                var urlid = linkNode.href.substring(linkNode.href.lastIndexOf(":")+1);
                launchSystemBrowserWithStaticURL(idMapping[urlid], null, null);
            }
            else if (protocol == "tomtomhome:" || protocol.substr(0, 11) == "vnd-tomtom-")
            {
                gApplication.urlHandler.openURI(linkNode.href);
            }
            else
            {
                launchSystemBrowser(linkNode.href)
            }
        }
    }
}

function getLinkNode(event)
{
    var t = event.target;
    while (t &&
           !(t instanceof HTMLAnchorElement && t.href) &&
           !(t instanceof HTMLAreaElement && t.href))
    {
        t = t.parentNode;
    }
    return t;
}
function launchSystemBrowser(urlString)
{
    var uri = getIOService().newURI(urlString, null, null);
    var utilStringBundle = getStringBundle("chrome://tthome/locale/logic/util.properties");

    try {
        var extps = Cc["@mozilla.org/uriloader/external-protocol-service;1"]
                    .getService(CI.nsIExternalProtocolService);
        extps.loadURI(uri, null);
        return true;
    } catch (e) {
        ttMessageService().confirm(
            utilStringBundle.GetStringFromName("problemLaunchingSystemBrowser.alert.title"),
            utilStringBundle.GetStringFromName("problemLaunchingSystemBrowser.alert.prompt"),
            utilStringBundle.GetStringFromName("problemLaunchingSystemBrowser.alert.copyToClipboard"),
            null,
            null,
            function(arg)
            {
                putStringOnClipboard(uri.spec);
            },
            MessageService.SEVERITY_WARNING);
        return false;
    }
};
function launchSystemBrowserWithStaticURL(urlid, successCallback, errorCallback, additionalParameters)
{
    var params = additionalParameters ? additionalParameters : {};
    params.__proto__ = null;

    getStaticURL(urlid, 
        function (url)
        {
            launchSystemBrowser(url);
            if (successCallback)
                successCallback();
        },
        function(e)
        {
            error(e);
            if (errorCallback)
                errorCallback();
        },
        params);
}
function error(ex)
{
    errorInternal(window, ex)
}
